;compatible BASIC for PC-6001
; by AKIKAWA, Hisashi

;subroutine entry address
BOOT	equ	0000h
CPHLDE	equ	0020h
FTODE	equ	0741h
ABTOF	equ	0d16h
INTTIM	equ	0f74h
GETC	equ	0fbch
GETKBF	equ	103ah
CLRKBF	equ	1058h
STICK	equ	1061h
PUTC	equ	1075h
PATCH1	equ	10eah
SETCSR	equ	116dh
GETAD	equ	11cdh
CHGMOD	equ	1390h
CHGDSP	equ	13edh
CHGACT	equ	140ch
CGROM	equ	14a0h
SETATT	equ	15c0h
ROPEN	equ	1a61h
GETCMT	equ	1a70h
RCLOSE	equ	1aaah
WOPEN	equ	1ab8h
PUTCMT	equ	1acch
WCLOSE	equ	1b06h
OUTB0H	equ	1b54h
PLSTPS	equ	1b60h
PLSTOP	equ	1bb3h
SOUND	equ	1bc5h
JOYSTK	equ	1ca6h
PATCH2	equ	1cb4h
CLS	equ	1dfbh
PLAY	equ	1eb3h
CMTSKP	equ	254eh
INPOPN	equ	259ah
PUTS	equ	30cfh

;work area
STOPFLG	equ	0fa18h		;03h=STOP,1bh=ESC
CMTSTAT	equ	0fa19h		;bit1=data received, bit4=error
CMTBUF	equ	0fa1dh		;CMT data
ASTSTAT	equ	0fa1eh		;cload asterisk status
PORTB0H	equ	0fa27h		;port b0h
TIME	equ	0fa28h		;fa28-fa2b
CONSOL4	equ	0fa2dh		;console 4th parameter
CSRBLNK	equ	0fa2eh		;0=cursor blink off, 1=on
CSRSTAT	equ	0fa2fh		;0=normal, ff=reversed
GRPWRK	equ	0fa30h		;input graphic character work
GRPFLG	equ	0fa31h		;print graphic character flag
FNCCNT	equ	0fa32h		;function key counter
RSEED	equ	0fa51h		;random seed, fa51-fa55
PRTPOS	equ	0fa57h		;printer head position
DEVICE	equ	0fa58h		;output device
CMMCNST	equ	0fa59h		;const for comma
STACK	equ	0fa5bh		;initial stack pointer
LINENUM	equ	0fa5dh		;present line number
STARTAD	equ	0fa5fh		;basic program start address

USRAD	equ	0faebh		;USR() function address
FNCKEY	equ	0fb3dh		;function key data
FNCAD	equ	0fb8dh		;function key address
KYBFIN	equ	0fb8fh		;key buffer in
KYBFOUT	equ	0fb90h		;key buffer out
KYBFSZ	equ	0fb92h		;key buffer size
KYBFAD	equ	0fb93h		;key buffer address
RSBFIN	equ	0fb95h		;RS-232C buffer in
RSBFOUT	equ	0fb96h		;RS-232C buffer out
RSBFSZ	equ	0fb98h		;RS-232C buffer size
RSBFAD	equ	0fb99h		;RS-232C buffer address
KEYBUF	equ	0fbb9h		;key buffer, fbb9-fbf8
RSBUF	equ	0fbf9h		;RS-232C buffer, fbf9-fc38

;PLAY command
BUFAIN	equ	0fba1h		;channelA buffer in
BUFAOUT	equ	0fba2h		;channelA buffer out
BUFASZ	equ	0fba4h		;channelA buffer size
BUFAAD	equ	0fba5h		;channelA buffer address
BUFBIN	equ	0fba7h		;channelB buffer in
BUFCIN	equ	0fbadh		;channelC buffer in
BUFA	equ	0fc39h		;channelA buffer, fc39-fc78
BUFB	equ	0fc79h		;channelB buffer, fc79-fcb8
BUFC	equ	0fcb9h		;channelC buffer, fcb9-fcf8
CHANNEL	equ	0fd14h		;channel (0-2)
SVBCK	equ	0fd15h		;backup of S/V-value
PLAYLEN	equ	0fd17h		;length
PLAYSTR	equ	0fd18h		;string address
PLAYST	equ	0fd1bh		;PLAY status

PLWKA	equ	0fd1dh		;PLAY work for channelA
REMAIN	equ	0fd1dh-PLWKA	;remaining time
PLLEN	equ	0fd1fh-PLWKA	;string length
PLADR	equ	0fd20h-PLWKA	;string address
OCTAVE	equ	0fd2ch-PLWKA	;O-value
LENGTH	equ	0fd2dh-PLWKA	;L-value
TEMPO	equ	0fd2eh-PLWKA	;T-value
VOLUME	equ	0fd2fh-PLWKA	;V-value
PERIOD	equ	0fd30h-PLWKA	;M-value
PLWKB	equ	0fd42h		;PLAY work for channelB
PLWKC	equ	0fd67h		;PLAY work for channelC

PAGES	equ	0fd8ch		;How many pages?
USREND	equ	0fd8dh		;user area end, fd8d-fd8e
SCREEN2	equ	0fd8fh		;screen 2nd parameter-1
SCREEN3	equ	0fd90h		;screen 3rd parameter-1

VRAM	equ	0fd91h		;VRAM address (high)
SCREEN1	equ	0fd92h		;screen 1st parameter-1
COLOR1	equ	0fd93h		;color 1st parameter
COLOR2	equ	0fd94h		;color 2nd parameter
COLOR3	equ	0fd95h		;color 3rd parameter (1,2 -> 0,2)
M1COLOR	equ	0fd96h		;screen mode 1 color parameters, fd96-fd98
M2COLOR	equ	0fd99h		;screen mode 1 color parameters, fd99-fd9b
M3COLOR	equ	0fd9ch		;screen mode 1 color parameters, fd9c-fd9e
M4COLOR	equ	0fd9fh		;screen mode 1 color parameters, fd9f-fda1
CONSOL1	equ	0fda2h		;console 1st line number+1
CONSOL2	equ	0fda3h		;console last line number+1
LASTLIN	equ	0fda5h		;(CONSOL2)-(CONSOL3) (sc12) (CONSOLE2) (sc34)
CONSOL3	equ	0fda6h		;console 3rd parameter
CSRY	equ	0fda8h		;cursor Y+1
CSRX	equ	0fda9h		;cursor X+1
CSRAD	equ	0fdaah		;cursor address
WIDTH	equ	0fdach		;X max+1
GRPX1	equ	0fdaeh		;graphic X, fdae-fdaf
GRPY1	equ	0fdb0h		;graphic Y, fdb0-fdb1
PAGE1	equ	0fdc8h		;page1 data, fdc8-fdfe
PAGE2	equ	0fdffh		;page2 data, fdff-fe35
PAGE3	equ	0fe36h		;page3 data, fe36-fe6c
PAGE4	equ	0fe6dh		;page4 data, fe6d-fea3

STOPSC2	equ	0feaah		;screen 2nd parameter -1 in stop
STOPSC3	equ	0feabh		;screen 3rd parameter -1 in stop
ATTDAT	equ	0feach		;color attribute data
GRPX2	equ	0feadh		;graphic X, fead-feae
GRPY2	equ	0feafh		;graphic Y, feaf-feb0
GRPX3	equ	0feb1h		;graphic work, feb1-feb2
GRPY3	equ	0feb3h		;graphic work, feb3-feb4
PAWRK	equ	0feb5h		;paint work, feb5-feb6
PACNT	equ	0feb7h		;paint work
BORDERA	equ	0fec5h		;paint border color attribute
BORDERC	equ	0fec6h		;paint border color code
FNCSHFT	equ	0fec8h		;shift key status for function key display
GMKYBUF	equ	0fecah		;reply to game key query
TARGET	equ	0fecbh		;target file name, fecb-fed0
FNAME	equ	0fed1h		;loading file name, fed1-fed6
VERIFY	equ	0fed8h		;load/verify flag 00h=load ffh=verify
INPBUF	equ	0fedah		;input buffer, feda-ff21, (ff22)-(ff23)=00h
ARGTYP	equ	0ff25h		;0=value 1=string
STREND	equ	0ff27h		;strings area end
BASICAD	equ	0ff29h		;basic area start
STRDSC2	equ	0ff2dh		;temporary string descriptor, ff2d-ff30
STRBCK2	equ	0ff31h		;backup of string descriptor for GC, ff31-ff34
STRBCK1	equ	0ff35h		;backup of string descriptor for GC, ff35-ff38
STRDSC1	equ	0ff39h		;temporary string descriptor, ff39-ff3c
STRAD	equ	0ff3dh		;string area start address - 1
GCWRK	equ	0ff41h		;garbage collection work
DATALN	equ	0ff45h		;data line number
PROGAD	equ	0ff4eh		;program address in interpreting
TMP	equ	0ff50h		;temporary
STOPLN	equ	0ff52h		;line number at stop
STOPAD	equ	0ff54h		;stop address
VARAD	equ	0ff56h		;variable area start address
ARRAD	equ	0ff58h		;array area start address
FREEAD	equ	0ff5ah		;free area start address
DATAAD	equ	0ff5ch		;data command address
FNPAR	equ	0ff5eh		;FN() parameter name
FNARG	equ	0ff60h		;FN() argument value, ff60-ff64
OPRTR	equ	0ff65h		;operator, FAC1-1
FAC1	equ	0ff66h		;floating accumlator 1, ff66-ff6a
FAC2	equ	0ff6dh		;floating accumlator 2, ff6d-ff71
FAC3	equ	0ff72h		;floating accumlator 3 (string conversion)

COLUMNS	equ	32
ROWS	equ	16

FOR	equ	081h
DATA	equ	083h
GOTO	equ	088h
RUN	equ	089h
GOSUB	equ	08ch
REM	equ	08eh
DEF	equ	093h
PRINT	equ	095h
SCREEN	equ	09fh
LASTCMD	equ	0aah
TAB	equ	0c2h
TO	equ	0c3h
FN	equ	0c4h
SPC	equ	0c5h
INKEY	equ	0c6h
THEN	equ	0c7h
NOT	equ	0c8h
STEP	equ	0c9h
PLUS	equ	0cah
MINUS	equ	0cbh
ASTRSK	equ	0cch
GT	equ	0d1h
EQ	equ	0d2h
LT	equ	0d3h
LASTFNC	equ	0f1h

;;;;;;;;;;;;;;;;;;;;;;;;;

;boot
	org	BOOT
	di
	jp	INIT


;check free size
;broken:f,de,hl
CHKFRE:
	ld	hl,(FREEAD)

;check stack size
;hl <= stack - 0024h?
;input: hl=address
;broken: f,de
CHKSTK:
	ex	de,hl
	ld	hl,0-0024h
	add	hl,sp
	or	a
	sbc	hl,de
	jp	c,OMERR
	ex	de,hl
	ret


;compare hl and de
;input: hl,de
;output: f
;broken: af
_CPHLDE:ds	CPHLDE-_CPHLDE
	org	CPHLDE

	ld	a,h
	sub	d
	ret	nz
	ld	a,l
	sub	e
	ret


;initialize
INIT:

;8255 (port 93h)
	ld	bc,0693h
	ld	hl,IOTBL93
	otir

;8251 (port 81h)
	ld	bc,0581h
	ld	hl,IOTBL81
	otir

;relay,VRAM,timer
	xor	a
	out	(0b0h),a	;bit3=CMT relay, bit21=VRAM address=c000,bit0=timer
	ld	(PORTB0H),a

;interrupt
	ld	hl,INTTBL
	ld	de,0fa02h
	ld	bc,11*2
	ldir
	ld	a,d
	ld	i,a
	im	2

;work area
	xor	a
	ld	h,d
	ld	l,e
	ld	(hl),a
	inc	de
	ld	bc,0ffffh-0fa18h
	ldir

	inc	a		;a=1
	ld	(CONSOL4),a
	ld	(PAGES),a

	ld	hl,0f9ffh-50
	ld	(STACK),hl
	ld	sp,hl

	ld	hl,KEYBUF
	ld	(KYBFAD),hl
	ld	hl,RSBUF
	ld	(RSBFAD),hl
	ld	hl,BUFA
	ld	(BUFAAD),hl
	ld	hl,BUFB
	ld	(BUFAAD+6),hl
	ld	hl,BUFC
	ld	(BUFAAD+12),hl
	ld	a,3fh
	ld	(KYBFSZ),a
	ld	(RSBFSZ),a
	ld	(BUFASZ),a
	ld	(BUFASZ+6),a
	ld	(BUFASZ+12),a

	ld	a," "
	ld	(ASTSTAT),a
	ld	hl,FCERR
	ld	(USRAD),hl

;RND()
	call	SETZERO
	call	RNDMNS

;function key
	ld	hl,FKEYTBL
	ld	de,FNCKEY
	ld	bc,8*10
	ldir

;screen
	ld	de,VRAM		;top of active page data
	ld	a,5
INITLP1:
	ld	hl,PAGEDATA
	ld	bc,PAGE1-VRAM
	ldir
	dec	a
	jr	nz,INITLP1

	ld	a,0e0h
	ld	(PAGE2),a
	ld	a,0c0h
	ld	(PAGE3),a
	ld	a,0a0h
	ld	(PAGE4),a

;16KB or 32KB?
	ld	hl,8000h
	ld	a,(hl)
	inc	(hl)
	cp	(hl)
	ld	(hl),a
	ld	a,00000100b
	ld	c,a		;limit of pages
	ld	b,00000110b
	jr	nz,RAM32K
;16KB
	ld	h,0c0h
	xor	a
	ld	c,2		;limit of pages
RAM32K:
	call	OUTB0H

	ld	a,h
	ld	(VRAM),a
	ld	(PAGE1),a
	add	a,04h
	ld	h,a
	ld	(BASICAD),hl	;l=0
	inc	l		;inc hl
	ld	(STARTAD),hl

	push	bc
	call	CLS

;PLAY
	call	PLSTOP		;ei

;check external ROM
	ld	hl,(4000h)
	ld	de,"A"+"B"*100h
	rst	CPHLDE
	ld	hl,(4002h)
	call	z,JPHL

;How Many Pages?
INITLP2:
	ld	hl,HOWMANY
	call	PUTS
	call	INPT1
	ex	de,hl
	call	SKIPSPLP
	or	a
	jr	z,SETMAXPAGE
	ld	hl,MO
	cp	":"
	jr	z,PAGEERR
	ld	hl,SN
	sub	"0"
	cp	"9"-"0"+1
	jp	nc,PAGEERR

	ld	b,0
	call	ATOI2
	ld	a,h
	or	a
	jr	nz,PAGEFC
	or	l
	jr	z,PAGEFC
	pop	bc
	ld	a,l
	dec	a
	cp	c
	jr	c,SETPAGE
	push	bc
PAGEFC:
	ld	hl,FC
PAGEERR:
	call	PUTS
	ld	hl,ERROR
	call	PUTS
	jr	INITLP2

SETMAXPAGE:
	pop	bc
	ld	a,c
	dec	a

SETPAGE:	
	inc	a
	ld	(PAGES),a
	ld	hl,ENDTBL-1
	add	a,l
	ld	l,a
	jr	nc,ENDNC
	inc	h
ENDNC:
	ld	h,(hl)
	ld	l,0ffh
	ld	(USREND),hl
	ld	(STREND),hl
	ld	(STRAD),hl
	ld	l,0cdh
	ld	(STACK),hl	;(STREND)-50
	ld	sp,hl
	call	NEW
	call	CLEREND

;screen clear
	ld	a,(PAGES)
INITLP3:
	dec	a
	call	CHGACT
	jr	z,PRTBOOT
	push	af
	call	CLS
	pop	af
	jr	INITLP3

;bootup message
PRTBOOT:
	ld	hl,SYSNAME
	call	PUTS

	ld	hl,0-10+1
	add	hl,sp
	ld	de,(FREEAD)
	sbc	hl,de		;c-flag=1
	call	I2TOF
	call	FTOA
	inc	hl		;skip space(sign)
	call	PUTS
	ld	hl,BFREE

PUTSEDIT:
	call	PUTS
;	jp	EDIT


;END command
C_END:
;	jp	EDIT

;direct command mode (line editor)
EDIT:
	ld	a,(PRTPOS)
	or	a
	jr	z,EDITZ
	ld	a,1
	ld	(DEVICE),a
	call	PRTNL
	xor	a
EDITZ:
	ld	(DEVICE),a
	ld	(GRPFLG),a
	call	CHGTXT
	ld	a,(CSRX)
	dec	a
	call	nz,PRTNL
	ld	hl,OK
	call	PUTS
	ld	hl,0ffffh
	ld	(LINENUM),hl
	call	CLRKBF

EDITLP:
	call	INPT1
	call	CNVIL
	jr	z,EDITLP
	ld	a,(hl)
	ld	b,a
	sub	"0"
	cp	"9"-"0"+1
	ld	a,b
	jr	c,CHGPRG
	jp	INTPRT

;change program
CHGPRG:
	ex	de,hl
	call	GETLN
	push	de		;buffer address
	push	hl		;line number

	ld	bc,0
	ld	a,(de)
	or	a
	jr	z,PRGZ		;delete line
	ld	c,5		;bc=5
PRGLP1:
	inc	de
	inc	c		;inc bc
	ld	a,(de)
	or	a
	jr	nz,PRGLP1
PRGZ:
	ld	d,b
	ld	e,c
	call	SRCHLN
	inc	hl
	inc	bc
	jr	c,PRGC		;line found
	ld	a,d
	or	e
	jp	z,ULERR
	ld	h,b
	ld	l,c

PRGC:
	push	de		;size
	push	bc		;target line address
	push	hl		;next line address
	or	a
	sbc	hl,bc		;size of old line > 0
	ex	de,hl
	xor	a
	sbc	hl,de		;size difference
	rla			;1=ldir 0=lddr

	pop	de		;next
	push	hl		;diff

	ld	hl,(VARAD)
	or	a
	sbc	hl,de		;ldir/lddr size
	ld	b,h
	ld	c,l

	or	a
	jr	z,PRGLDDR1
PRGLDIR1:
	ld	h,d
	ld	l,e
	jr	SKPLDDR1
PRGLDDR1:
	ld	hl,(VARAD)
	dec	hl
SKPLDDR1:

	pop	de	;diff
	push	de
	push	hl
	add	hl,de
	call	CHKSTK
	ex	de,hl
	pop	hl

	or	a
	jr	z,PRGLDDR2
PRGLDIR2:
	ldir
	jr	SKPLDDR2
PRGLDDR2:
	lddr
SKPLDDR2:

	pop	bc		;diff
	pop	de		;target
	pop	hl		;size
	push	hl		;size
	push	de		;target
	add	hl,de
	ex	de,hl
	call	CHGLNKP
	pop	hl		;target
	pop	bc		;size


;insert line
;input:	hl=insert start address, bc=size of new line
;	(sp)=line number, (sp+2)=buffer address
	ld	a,b
	or	c
	jr	z,DELLINE

	ld	d,h
	ld	e,l
	add	hl,bc
	ex	de,hl

;link pointer
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
;line number
	pop	de		;line number
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl

	ex	de,hl
	pop	hl		;buffer address
	dec	c		;dec bc
	dec	c		;dec bc
	dec	c		;dec bc
	dec	c		;dec bc
	ldir
PRGEND:
	call	CLEREND
	jp	EDITLP

DELLINE:
	pop	de		;line number
	pop	hl		;buffer address
	jr	PRGEND


;change link pointer
;input: de=00-address, bc=slide size
;broken:af,de,hl
CHGLNKP:
	ld	hl,(VARAD)
	add	hl,bc
	ld	(VARAD),hl

CHGLNKPLP:
	ex	de,hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	a,e
	or	d
	ret	z
	ex	de,hl
	add	hl,bc
	ex	de,hl
	ld	(hl),d
	dec	hl
	ld	(hl),e
	jr	CHGLNKPLP


;convert to intermediate language
;input:	hl=INPBUF-1
;output:hl=INPBUF, z(1=only space)
CNVIL:
	inc	hl
	ld	a,(hl)
	cp	" "
	jr	z,CNVIL
	or	a
	ret	z
	ld	de,INPBUF
	push	de

ILLP1:
	ld	b,80h
	ld	de,CMDLST
	ld	a,(hl)
	or	a
	jp	z,ILEND
	cp	22h		;double quotation mark
	jr	z,ILDQ
	cp	"?"
	jr	z,ILQ
	cp	14h
	jr	z,ILGRP
	cp	80h
	jr	nc,ILKANA

ILLP2:
	push	hl
	ld	a,(hl)
	call	TOUPPER
	set	7,a
	ex	de,hl
	cp	(hl)
	jr	nz,ILLP5

;1st character matched
ILLP3:
	inc	hl
	ld	a,(hl)
	rlca
	jr	c,ILFOUND

	ld	a,b
	cp	GOTO
ILLP4:
	inc	de
	ld	a,(de)
	jr	nz,NOGOTO
	cp	" "
	jr	z,ILLP4
NOGOTO:
	call	TOUPPER
	cp	(hl)
	jr	z,ILLP3

ILLP5:
	inc	hl
	bit	7,(hl)
	jr	z,ILLP5
	ex	de,hl
	pop	hl
	inc	b
	ld	a,b
	cp	LASTFNC+1
	jr	nc,ILNC
	cp	LASTCMD+1
	jr	nz,ILLP2
	add	a,17h
	ld	b,a
	jr	ILLP2

;not found
ILNC:
	ld	a,(hl)
	call	TOUPPER
	ld	b,a
	jr	ILPUT

;found
ILFOUND:
	pop	af		;cancel
	ex	de,hl
ILPUT:
	ex	(sp),hl
	ld	(hl),b
	inc	hl
	ex	(sp),hl
	inc	hl

	ld	a,b
	cp	REM
	jr	z,ILREM
	cp	DATA
	jr	z,ILDAT
	jr	ILLP1

ILQ:
	pop	de
	ld	a,95h
	ld	(de),a
	inc	de
	push	de
	inc	hl
	jr	ILLP1

ILGRP:
	inc	hl
	ld	a,(hl)
	sub	30h
	ld	(hl),a
	jr	ILLP1

ILKANA:
	inc	hl
	jr	ILLP1

ILDQ:
	pop	de
	ldi
ILDQLP:
	ld	a,(hl)
	ldi
	or	a
	jr	z,ILEND2
	cp	22h		;double quotation mark
	jr	nz,ILDQLP
	push	de
	jp	ILLP1

ILREM:
	pop	de
ILREMLP:
	ld	a,(hl)
	ldi
	or	a
	jr	z,ILEND2
	jr	ILREMLP

ILDAT:
	pop	de
	ld	c,0
	ld	a,(hl)
	ldi
	or	a
	jr	z,ILEND2
	push	de
	bit	0,c
	jr	nz,ILDATNZ
	cp	":"
	jp	z,ILLP1
ILDATNZ:
	cp	22h
	jr	nz,ILDAT

	inc	c
	pop	de
ILDATLP:
	ld	a,(hl)
	ldi
	or	a
	jr	z,ILEND2
	cp	22h		;double quotation mark
	jr	nz,ILDATLP
	push	de
	jp	ILLP1

ILEND:
	xor	a
	pop	de
	ld	(de),a
	inc	de
ILEND2:
	ld	(de),a
	inc	de
	ld	(de),a
	ld	hl,INPBUF
	inc	a		;reset z-flag
	ret


;convert lowercase letter to uppercase letter
;input:	a
;output:a
;broken:f
TOUPPER:
	cp	"a"
	ret	c
	cp	"z"+1
	ret	nc
	sub	"a"-"A"
	ret


;table
IOTBL93:
	db	0c0h		;8255 portA=mode2 portB=mode0
	db	0dh		;nack=1
	db	09h		;nstb=1
	db	05h		;CGROM off
	db	03h		;CRTC
	db	0fh		;nobf=1 (for emulator?)

IOTBL81:
	db	12h		;reset error, DTR=1, RxE/TxEN=0
	db	12h		; set twice for synchronous mode
	db	52h		;reset, reset error, DTR=1, RxE/TxEN=0
	db	4fh		;stop bits=1, parity disable,
				; character length=8bits, baud rate factor=64
	db	37h		;reset error, RTS/DTR/RxE/TxEN=1


INTTBL:
	dw	INTKEY		;fa02 normal key
	dw	INT232		;fa04 RS-232C
	dw	INTTIM		;fa06 2ms timer
	dw	INTCMT		;fa08 CMT read
	dw	EIRET		;fa0a ?
	dw	EIRET		;fa0c ?
	dw	INTRSTP		;fa0e CMT read stop
	dw	INTWSTP		;fa10 CMT write stop
	dw	INTERR		;fa12 CMT error
	dw	INTGRP		;fa14 GRAPH key etc.
	dw	INTGAM		;fa16 reply to game key query

ENDTBL:
	db	0f9h,0dfh,0bfh,09fh

HOWMANY:
	db	"How Many Pages? ",00h
FC:
	db	"?FC",00h
SN:
	db	"?SN",00h
MO:
	db	"?MO",00h
SYSNAME:
	db	9ah,0deh,96h,0fdh,"BASIC Ver.0.2",0dh,0ah,00h
BFREE:
	db	" Bytes free",00h
OK:
	db	"Ok"
CRLF:
	db	0dh,0ah,00h


PAGEDATA:
	db	0c0h		;fd91	VRAM address
	db	00h		;fd92	screen 1st parameter-1
	db	01h		;fd93	color 1st parameter
	db	00h		;fd94	color 2nd parameter
	db	00h		;fd95	color 3rd parameter (1,2 -> 0,2)
	db	01h,00h,00h	;fd96	screen mode 1 color parameters
	db	01h,00h,00h	;fd99	screen mode 2 color parameters
	db	02h,00h,00h	;fd9c	screen mode 3 color parameters
	db	03h,00h,00h	;fd9f	screen mode 4 color parameters
	db	01h		;fda2	console 1st line number+1
	db	10h		;fda3	console last line number+1
	db	00h		;fda4
	db	0fh		;fda5	-function key
	db	01h		;fda6	console 3rd parameter
	db	00h		;fda7
	db	01h		;fda8	cursor Y+1
	db	01h		;fda9	cursor X+1
	dw	0c200h		;fdaa	cursor address
	db	COLUMNS		;fdac	X max+1
	db	00h		;fdad
	dw	0000h		;fdae	graphic X
	dw	0000h		;fdb0	graphic Y


CMDLST:
	db	"E"+80h,"ND",	"F"+80h,"OR",	"N"+80h,"EXT",	"D"+80h,"ATA"
	db	"I"+80h,"NPUT",	"D"+80h,"IM",	"R"+80h,"EAD",	"L"+80h,"ET"
	db	"G"+80h,"OTO",	"R"+80h,"UN",	"I"+80h,"F",	"R"+80h,"ESTORE"
	db	"G"+80h,"OSUB",	"R"+80h,"ETURN","R"+80h,"EM",	"S"+80h,"TOP"
	db	"O"+80h,"UT",	"O"+80h,"N",	"L"+80h,"PRINT","D"+80h,"EF"
	db	"P"+80h,"OKE",	"P"+80h,"RINT",	"C"+80h,"ONT",	"L"+80h,"IST"
	db	"L"+80h,"LIST",	"C"+80h,"LEAR",	"C"+80h,"OLOR",	"P"+80h,"SET"
	db	"P"+80h,"RESET","L"+80h,"INE",	"P"+80h,"AINT",	"S"+80h,"CREEN"
	db	"C"+80h,"LS",	"L"+80h,"OCATE","C"+80h,"ONSOLE","C"+80h,"LOAD"
	db	"C"+80h,"SAVE",	"E"+80h,"XEC",	"S"+80h,"OUND",	"P"+80h,"LAY"
	db	"K"+80h,"EY",	"L"+80h,"COPY",	"N"+80h,"EW"

FNCLST:
	db					"T"+80h,"AB(",	"T"+80h,"O"
	db	"F"+80h,"N",	"S"+80h,"PC(",	"I"+80h,"NKEY$","T"+80h,"HEN"
	db	"N"+80h,"OT",	"S"+80h,"TEP",	"+"+80h,	"-"+80h
	db	"*"+80h,	"/"+80h,	"^"+80h,	"A"+80h,"ND"
	db	"O"+80h,"R",	">"+80h,	"="+80h,	"<"+80h
	db	"S"+80h,"GN",	"I"+80h,"NT",	"A"+80h,"BS",	"U"+80h,"SR"
	db	"F"+80h,"RE",	"I"+80h,"NP",	"L"+80h,"POS",	"P"+80h,"OS"
	db	"S"+80h,"QR",	"R"+80h,"ND",	"L"+80h,"OG",	"E"+80h,"XP"
	db	"C"+80h,"OS",	"S"+80h,"IN",	"T"+80h,"AN",	"P"+80h,"EEK"
	db	"L"+80h,"EN",	"H"+80h,"EX$",	"S"+80h,"TR$",	"V"+80h,"AL"
	db	"A"+80h,"SC",	"C"+80h,"HR$",	"L"+80h,"EFT$",	"R"+80h,"IGHT$"
	db	"M"+80h,"ID$",	"P"+80h,"OINT",	"C"+80h,"SRLIN","S"+80h,"TICK"
	db	"S"+80h,"TRIG",	"T"+80h,"IME",	80h


CMDTBL:
;80-8f
	dw	C_END,	C_FOR,	C_NEXT,	C_DATA,	C_INPT,	C_DIM,	C_READ,	C_LET
	dw	C_GOTO,	C_RUN,	C_IF,	C_RSTR,	C_GSUB,	C_RET,	C_REM,	C_STOP
;90-9f
	dw	C_OUT,	C_ON,	C_LPRT,	C_DEF,	C_POKE,	C_PRT,	C_CONT,	C_LIST
	dw	C_LLST,	C_CLER,	C_COLR,	C_PSET,	C_PRST,	C_LINE,	C_PAIN,	C_SCRN
;a0-af
	dw	C_CLS,	C_LOCA,	C_CNSL,	C_CLD,	C_CSV,	C_EXEC,	C_SOUN,	C_PLAY
	dw	C_KEY,	C_LCPY,	C_NEW

FNCTBL:
;c4-cf
	dw					C_FN,	C_SPC,	C_INKY,	C_THEN
	dw	C_NOT,	C_STEP,	C_PLS,	C_MNS,	C_MUL,	C_DIV,	C_POW,	C_AND
;d0-df
	dw	C_OR,	C_GT,	C_EQ,	C_LT,	C_SGN,	C_INT,	C_ABS,	C_USR
	dw	C_FRE,	C_INP,	C_LPOS,	C_POS,	C_SQR,	C_RND,	C_LOG,	C_EXP
;e0-ef
	dw	C_COS,	C_SIN,	C_TAN,	C_PEEK,	C_LEN,	C_HEX,	C_STR,	C_VAL
	dw	C_ASC,	C_CHR,	C_LEFT,	C_RHT,	C_MID,	C_POIN,	C_CSRL,	C_STCK
;f0-f1
	dw	C_STRG,	C_TIME


FKEYTBL:
	db	"COLOR ",00h,00h
	db	"CLOAD",22h,00h,00h
	db	"GOTO ",00h,00h,00h
	db	"LIST ",00h,00h,00h
	db	"RUN",0dh,00h,00h,00h,00h
	db	"SCREEN ",00h
	db	"CSAVE",22h,00h,00h
	db	"PRINT ",00h,00h
	db	"PLAY ",00h,00h,00h
	db	"CONT",0dh,00h,00h,00h


;error
NFERR:
	ld	e,0
	db	01h		;ld bc,****
C_HEX:
C_TO:
C_TAB:
C_SPC:
C_THEN:
C_STEP:
SNERR:
	ld	e,2
	db	01h		;ld bc,****
RGERR:
	ld	e,4
	db	01h		;ld bc,****
ODERR:
	ld	e,6
	db	01h		;ld bc,****
FCERR:
	ld	e,8
	db	01h		;ld bc,****
OVERR:
	ld	e,0ah
	db	01h		;ld bc,****
OMERR:
	ld	e,0ch
	db	01h		;ld bc,****
ULERR:
	ld	e,0eh
	db	01h		;ld bc,****
BSERR:
	ld	e,10h
	db	01h		;ld bc,****
DDERR:
	ld	e,12h
	db	01h		;ld bc,****
DIV0ERR:
	ld	e,14h
	db	01h		;ld bc,****
IDERR:
	ld	e,16h
	db	01h		;ld bc,****
TMERR:
	ld	e,18h
	db	01h		;ld bc,****
OSERR:
	ld	e,1ah
	db	01h		;ld bc,****
LSERR:
	ld	e,1ch
	db	01h		;ld bc,****
STERR:
	ld	e,1eh
	db	01h		;ld bc,****
CNERR:
	ld	e,20h
	db	01h		;ld bc,****
UFERR:
	ld	e,22h
	db	01h		;ld bc,****
TRERR:
	ld	e,24h
	db	01h		;ld bc,****
MOERR:
	ld	e,26h
	db	01h		;ld bc,****
FDERR:
	ld	e,28h

	ld	hl,(STACK)
	ld	sp,hl

	xor	a
	ld	(DEVICE),a
	ld	h,a
	ld	l,a
	ld	d,a		;
	ld	(STRBCK1+2),hl
	ld	(STRBCK2+2),hl
	ld	(STOPAD),hl
	call	CHGTXT
	ld	a,(CSRX)
	dec	a
	call	nz,PRTNL
	ld	a,"?"
	call	PUTC
	ld	hl,ERRID
	add	hl,de		;
	ld	a,(hl)
	call	PUTC
	inc	hl
	ld	a,(hl)
	call	PUTC
	ld	hl,ERROR
PRTLNUM:
	call	PUTS

	call	PLSTOP

	ld	hl,(LINENUM)
	push	hl		;
	ld	a,h
	and	l
	inc	a
	jp	z,EDIT		;if (LINENUM)=0ffffh
	ld	hl,ERRIN
	call	PUTS
	pop	hl		;
	call	I2TOF
	call	FTOA
	jp	PUTSEDIT

ERRID:
	db	"NF","SN","RG","OD","FC","OV","OM","UL"
	db	"BS","DD","/0","ID","TM","OS","LS","ST"
	db	"CN","UF","TR","MO","FD"

ERROR:
	db	07h," Error",00h

ERRIN:
	db	" in",00h


;get integer part from float
;input: FAC1 (>=0)
;output: FAC1
;broken: af,b,de,hl
GETINT:
	ld	a,(FAC1+4)
	sub	81h
	jp	c,SETZERO
	sub	31
	ret	nc		;large
	neg
	ld	hl,(FAC1)
	ld	de,(FAC1+2)
	ld	b,a
GETILP1:
	srl	d
	rr	e
	rr	h
	rr	l
	djnz	GETILP1
	ld	b,a
GETILP2:
	add	hl,hl
	rl	e
	rl	d
	djnz	GETILP2
	ld	(FAC1),hl
	ld	(FAC1+2),de
	ret


;convert float to 2-byte integer for USR()
;input: FAC1
;output: de
;broken: af,b,hl
_FTODE:	ds	FTODE-_FTODE
	org	FTODE

	call	FTOI2
	ex	de,hl
	ret


;convert string to 2-byte integer (unsigned)
;input: de=program address, b=string length
;output: hl=integer, de=next address
;broken: af,bc
ATOI2:
	ld	hl,0
	dec	de
ATOI2LP:
	inc	de
	ld	a,(de)
	cp	" "
	jr	z,ATOI2LP
	sub	"0"
	cp	"9"-"0"+1
	ret	nc
	push	de
	ld	d,h
	ld	e,l
	add	hl,hl		;*2
	jr	c,ATOI2END
	add	hl,hl		;*4
	jr	c,ATOI2END
	add	hl,de		;*5
	jr	c,ATOI2END
	add	hl,hl		;*10
	jr	c,ATOI2END
	ld	d,0
	ld	e,a
	add	hl,de
	pop	de
	djnz	ATOI2LP
	inc	de
	ret

ATOI2END:
	ex	de,hl
	pop	de
	ret


;convert hexadecimal string to integer
;input: de="&" address, b=max length-1("&")
;output: hl=decimal, de=next address
;broken: af,bc
HEX:
	ld	hl,0
HEXLP1:
	inc	de
	ld	a,(de)
	cp	" "
	jr	nz,CHKH
	djnz	HEXLP1
	ret

CHKH:
	or	20h
	cp	"h"
	jp	nz,SNERR
	dec	b
	ld	c,5

HEXLP2:
	inc	de
	ld	a,(de)
	cp	" "
	jr	z,HEXEND
	cp	DEF		;93h
	jr	z,HEXDEF
	sub	"0"
	cp	"9"-"0"+1
	jr	c,HEX0F
	or	20h
	sub	"a"-"0"
	cp	"f"-"a"+1
	ret	nc		;not hex
	add	a,10
HEX0F:
	call	ADDA16HL
HEXEND:
	djnz	HEXLP2
	inc	de
	ret

HEXDEF:
	ld	h,l
	ld	l,0deh
	ld	a,0fh
	jr	HEX0F

;hl=a+16*hl
ADDA16HL;
	dec	c
	jp	z,OVERR
	add	hl,hl		;*2
	add	hl,hl		;*4
	add	hl,hl		;*8
	add	hl,hl		;*16
	add	a,l
	ld	l,a
	ret

;convert a digit character to integer
;input: de=program address
;output: a=integer (c-flag=0) / character (c-flag=1), de=next address
;broken:
DIGIT1:
	ld	a,(de)
	inc	de
	cp	" "
	jr	z,DIGIT1
	sub	"0"
	jr	c,NOTDGT
	cp	"9"+1
	ccf
	ret	nc
NOTDGT:
	dec	de
	ld	a,(de)
	ret


;get line number from string (0-65529)
;input: de=program address
;output: hl=integer, de=next address
;broken: af,bc
GETLN:
	ld	b,0
	call	ATOI2
	push	de
	ld	de,65530
	rst	CPHLDE
	pop	de
	ret	c
	ld	hl,6553
GETLNLP:
	dec	de
	ld	a,(de)
	cp	" "
	ret	nz
	jr	GETLNLP


;search line number
;input: hl=line number
;output:z=1,c=1) bc=address, hl=next line address
;	z=0,c=0) bc=next line address, hl=next next line address
;	z=1,c=0) bc=hl=end address
;broken:af
SRCHLN:
	push	de
	ex	de,hl
	ld	hl,(LINENUM)
	rst	CPHLDE

	ld	hl,(STARTAD)
	jr	nc,SRCHLP2	;less than or equal to present line number
	ld	hl,(PROGAD)
SRCHLP1:
	ld	a,(hl)
	inc	hl
	or	a
	jr	nz,SRCHLP1

;search start
SRCHLP2:
	ld	c,l
	ld	b,h
	ld	a,(hl)
	inc	hl
	or	(hl)
	jr	z,SRCHEND2	;program end
	inc	hl
	inc	hl
	ld	a,d
	sub	(hl)
	dec	hl
	jr	nz,SRCHNZ
	ld	a,e
	sub	(hl)
SRCHNZ:
	dec	hl
	ld	a,(hl)
	dec	hl
	ld	l,(hl)
	ld	h,a
	jr	z,SRCHEND	;de-bc
	jr	nc,SRCHLP2	;de-bc
SRCHEND:
	ccf
	dec	bc
	dec	hl
	pop	de
	ret

SRCHEND2:
	dec	hl
	dec	bc
	dec	hl
	pop	de
	ret


;get a 1-byte integer for function 
;input:	de=program address
;output:FAC1,l, de=next address
;broken:FAC2,f,bc
FNCI1:
	call	FNCNUM
	call	FTOI1
	ret


;get a numerical argument for function 
;input: de=program address
;output: FAC1
;broken: FAC2,af,bc,de,hl
FNCNUM:
	call	CHKLPAR
FNCNUMR:
	call	ARG
	call	CHKRPAR
	call	CHKNUM
	jp	nz,SNERR
	ret


;check )
;input: de=program address
;output: de=next address
;broken: af
CHKRPAR:
	ld	a,(de)
	cp	")"
	jp	nz,SNERR
	inc	de
	ld	(PROGAD),de
	ret


;check (
;input: de=program address
;output: de=next address
;broken: af
CHKLPAR:
	call	SKIPSP
	cp	"("
	jp	nz,SNERR
	inc	de
	ret


;check parenthesis and string argument
;input: de=program address
;output: a=length, hl=string descriptor address, de=next address
;broken: f,bc,FAC1,FAC2
FNCSTR:
	call	CHKLPAR
	call	ARG
	call	CHKRPAR
	call	CHKSTR
	jp	nz,SNERR
	ret


;get a numerical argument
;input: de=program address
;output: FAC1, de=next address, z-flag(1=ok)
;broken: af,bc,FAC2
NUMARG:
	call	ARG
;	call	CHKNUM
;	ret


;check numeric or not
;output:z-flag (1=ok)
;broken:af
CHKNUM:
	ld	a,(ARGTYP)
	or	a
	ret	z
	dec	a
	ret	nz
	jp	TMERR


;get a numerical argument and check result (?MO Error)
;input: de=program address
;output: FAC1, de=next address
;broken: af,bc,FAC2
NUMARGMO:
	call	CHKCLN
	jp	z,MOERR
;	call	NUMARGSN
;	ret


;get a numerical argument and check result (?SN Error)
;input: de=program address
;output: FAC1, de=next address
;broken: af,bc,FAC2
NUMARGSN:
	call	NUMARG
	ret	z
	jp	SNERR


;get a 2-byte integer argument (-65535~65535)
;input: de=program address
;output: FAC1,hl=integer, de=next address
;broken: FAC2, af, bc
INTARG:
	call	NUMARGMO
	push	de
	call	FTOI
	pop	de
	ret


;get a 2-byte integer argument (-32768~32767)
;input: de=program address
;output: FAC1,hl=integer, de=next address
;broken: FAC2, af, bc
INT2ARG:
	call	NUMARGMO
	push	de
	call	FTOI2
	pop	de
	ret


;get a 1-byte integer argument (0~255)
;input: de=program address
;output: FAC1,a,hl=integer, de=next address
;broken: FAC2, f, bc
INT1ARG:
	call	INT2ARG
	ld	a,h
	or	a
	jp	nz,FCERR
	ld	a,l
	ret


;get two 2-byte integer arguments (-65535~65535)
;input: de=program address
;output: FAC1, bc=1st, hl=2nd, de=next address
;broken: af
INTARG2:
	call	INTARG
	ld	a,(de)
	cp	","
	jp	nz,SNERR
	inc	de
	push	hl		;
	call	INTARG
	pop	bc		;
	ret


;get two 2-byte integer arguments (-32768~32767)
;input: de=program address
;output: FAC1, bc=1st, hl=2nd, de=next address
;broken: af
INT2ARG2:
	call	INT2ARG
	ld	a,(de)
	cp	","
	jp	nz,SNERR
	inc	de
	push	hl		;
	call	INT2ARG
	pop	bc		;
	ret


;get a string argument
;input: de=program address
;output: a=length, hl=string descriptor address, de=next address, z-flag(1=ok)
;broken: f,bc,FAC1,FAC2
STRARG:
	call	ARG
CHKSTR:
	ld	a,(ARGTYP)
	or	a
	jp	z,TMERR
	dec	a		;z-flag
	ld	hl,(FAC1+1)
	ld	a,(hl)
	ret


;get string,integer argument
;input: de=program address
;output: de=string descriptor address, FAC1,hl=integer
;broken: FAC1, FAC2, af,bc
ARGSI1:
	call	CHKLPAR
	call	ARG
	jp	nz,SNERR
	ld	a,(de)
	cp	","
	jp	nz,SNERR
	call	CHKSTR
	inc	de
	push	hl		;string desciptor address
	call	INT1ARG
	pop	de		;string desciptor address
	ret


;analyze an argument
;input: de=program address
;output: de=next address, FAC1=numerical value or pointer to string descriptor
;	(ARGTYP)=0(numeric), 1(string), other(cannot analyzed)
;broken: FAC2,af,bc,de,hl
ARG:
	push	de
	call	SETZERO		;for first +-
	pop	de
	xor	a
	ld	l,a
	push	hl		;l=dummy operator
	dec	a
	ld	(ARGTYP),a	;ff=unknown
	ld	(OPRTR),a
ARGLP:
	ld	a,(de)
	inc	de
	ld	(PROGAD),de
;command
	cp	80h
	jp	nc,ARGCMD
;[0-9&.]
	ld	b,a		;
	sub	"0"
	cp	"9"-"0"+1
	ld	a,b		;
	jr	c,ARGNUM
	cp	"&"
	jr	z,ARGNUM
	cp	"."
	jr	z,ARGNUM
	sub	"A"
	cp	"Z"-"A"+1
	jr	c,ARGVAR
	ld	a,b		;
	cp	22h		;double quotation mark
	jp	z,ARGSTR
	cp	"("
	jr	z,PARL
	cp	" "
	jr	z,ARGLP
ARGTAIL:
	dec	de
	ld	(PROGAD),de
	xor	a
	jp	OPR

PARL:
	call	COPYSTR
	push	af
	call	ARG
	pop	af
	call	z,BACKSTR
	call	CHKRPAR
	jr	ARGLP

ARGNUM:
	call	ARGNCHK
	dec	de
	ld	a,255
	call	ATOF
	ld	(PROGAD),de
	jr	ARGLP

;broken: af,bc
ARGNCHK:
	pop	bc		;return address
	ld	a,(OPRTR)
	or	a
	jr	z,ARGTAIL
	xor	a
	ld	(OPRTR),a
	ld	(ARGTYP),a
	push	bc		;return address
	ret

ARGVAR:
	push	de		;program address
	ex	de,hl
	call	GETNAME
	ld	a,(ARGTYP)
	ld	d,a
	ld	a,(OPRTR)
	ld	e,a
	push	de
	ex	de,hl
	call	PUSHF1
	ex	de,hl

	push	bc
	ld	a,(hl)
	cp	"("
	jr	z,ARGVARR
	ld	(PROGAD),hl
	call	SRCHVAR
	jr	nc,ARGVNC
	ld	hl,ZERO	
	jr	ARGVNC
ARGVARR:
	call	GETARR
ARGVNC:
	pop	bc
	ex	de,hl
	call	POPF1
	ex	de,hl
	pop	de
	ld	a,d
	ld	(ARGTYP),a
	ld	a,e
	ld	(OPRTR),a
	pop	de		;program address
	bit	7,c
	jr	nz,ARGVSTR
ARGVNUM:
	call	ARGNCHK
	ld	de,FAC1
	ld	bc,5
	ldir
	ld	de,(PROGAD)
	jp	ARGLP


;string variable
ARGVSTR:
	call	ARGSCHK
	ld	de,STRDSC1
	ld	bc,4
	ldir
	ld	de,(PROGAD)
	jp	ARGLP

ARGSTR:
	call	ARGSCHK
	ld	(STRDSC1+2),de
	ld	l,0
ARGSLP:
	ld	a,(de)
	or	a
	jr	z,ARGSOK
	inc	de
	cp	22h		;double quotation mark
	jr	z,ARGSOK
	inc	l
	jp	z,LSERR
	jr	ARGSLP
ARGSOK:
	ld	(STRDSC1),hl
	ld	(PROGAD),de
	jp	ARGLP

;broken: af,bc
ARGSCHK:
	pop	bc		;return address
	ld	a,(OPRTR)
	or	a
	jp	z,ARGTAIL
	xor	a
	ld	(OPRTR),a	;a=0
	inc	a		;a=1
	ld	(ARGTYP),a
	push	bc		;return address
	ld	bc,STRDSC1
	ld	(FAC1+1),bc
	ret

ARGCMD:
	cp	SCREEN		;9fh
	jr	z,FNC
	cp	FN		;0c4h
	jr	z,FNC
	cp	INKEY		;0c6h
	jr	z,FNC
	cp	NOT		;0c8h
	jr	z,OPR
	cp	PLUS		;0cah
	jp	c,ARGTAIL
	cp	LT+1		;0d4h
	jr	c,OPR
	cp	LASTFNC+1
	jp	nc,SNERR
;	jr	FNC

;function
FNC:
	ld	b,a		;;
	xor	a
	ld	(ARGTYP),a
	ld	(OPRTR),a
	call	COPYSTR
	push	af		;
	ld	a,b		;;
	cp	SCREEN
	jp	z,FNCSCRN
	ld	hl,FNCTBL-(0c4h-80h)*2
	call	JPTBL
FNCRTN:
	ld	de,(PROGAD)
CHKSTRBCK:
	pop	af		;
	call	z,BACKSTR
	jp	ARGLP

;operator
OPR:
	ld	d,a		;operator
	ld	a,(OPRTR)
	inc	a
	cp	2
	jp	nc,OPROPR	;not 00 nor ff
	ld	a,(ARGTYP)
	inc	a
	ld	a,d		;operator
	jr	nz,NOTHEAD
;first +, for numeric and string
	cp	PLUS
	jr	z,ARGNEXT2
	cp	MINUS
	jr	z,NOTHEAD
	cp	NOT
	jr	z,NOTHEAD
	or	a
	jp	nz,SNERR
NOTHEAD:
	call	GETPRIO
	ld	e,a
	pop	bc		;c=previous operator
	push	bc
	ld	a,c
	or	a
	jr	z,ARGHEAD

	call	GETPRIO
	cp	e
	jr	nc,CALLOP
	ld	a,d		;
ARGNEXT:
	ld	(OPRTR),a
	ld	a,(ARGTYP)
	dec	a
	jr	z,ARGNEXTS
	call	PUSHF1
	jr	ARGNEXT2
ARGNEXTS:
	ld	hl,(STRDSC1+2)
	push	hl
	ld	hl,(STRDSC1)
	push	hl
	ld	hl,(FAC1-1)	;h=length, l=operator
	res	6,l
	push	hl
ARGNEXT2:
	ld	de,(PROGAD)
	jp	ARGLP


CALLOP:
	push	de		;;d=following operator
	push	bc		;c=previous operator
	ld	a,(ARGTYP)
	dec	a
	jr	z,CALLOPS

;numeric
	call	CPYFAC
	pop	bc		;
	pop	de		;;
	call	POPF1

CALLOPEND:
	bit	6,c
	jr	nz,TYPNUM
	set	6,c
	ld	hl,ARGTYP
	set	1,(hl)
TYPNUM:
	push	de		;;
	ld	a,c
	ld	hl,FNCTBL-(0c4h-80h)*2
	call	JPTBL
	xor	a
	ld	(OPRTR),a
	pop	af		;;
	jp	OPR

;string
CALLOPS:
	ld	hl,(STRDSC1)
	ld	(STRDSC2),hl
	ld	hl,(STRDSC1+2)
	ld	(STRDSC2+2),hl
	pop	bc

;pop as string, TM Error if numeric
	pop	de
	pop	hl
	ld	(FAC1-1),hl
	pop	hl
	ld	(STRDSC1),hl
	pop	hl
	ld	(STRDSC1+2),hl
	jr	CALLOPEND

ARGHEAD:
	add	a,d
	jr	nz,ARGNEXT
	pop	hl		;cancel dummy operator
	ld	de,(PROGAD)
	ret

;operator and operator
OPROPR:
	ld	a,d		;
	cp	NOT		;0c8h
	jr	z,ARGNEXT
	cp	PLUS		;0cah
	jr	z,OPRPLS
	ld	hl,MNSONE
	cp	MINUS		;0cbh
	jr	z,OPRMNS
	ld	a,(OPRTR)
	cp	GT		;0d1h
	jr	nc,GTLTEQ	;>=<
	jp	SNERR

OPRPLS:
	ld	hl,PLSONE
OPRMNS:
	call	SETF1
	ld	a,ASTRSK	;0cch
	jp	ARGNEXT

GTLTEQ:
	cp	d
	jp	z,SNERR		;>>,<<,==
	add	a,d
	cp	GT+EQ
	jr	z,GTLTEQOK
	cp	LT+EQ
	jr	z,GTLTEQOK
	cp	GT+LT
	jp	nz,SNERR
GTLTEQOK:
	sub	EQ
	and	7fh
	pop	bc		;c=previous operator

;copy numeric/string bit
	xor	c
	and	10111111b
	xor	c

	ld	(OPRTR),a
	ld	c,a
	push	bc
	ld	de,(PROGAD)
	jp	ARGLP


;input: a=operator
;output: a=priority
;broken: f,hl
GETPRIO:
	or	a
	ret	z
	ld	hl,PRIO
	or	40h		;numeric/string bit
	sub	NOT		;0c8h
	jr	c,PRIONC	;>=,=>,<=,=<,<>,><
	inc	a
	add	a,l
	ld	l,a
	jr	nc,PRIONC
	inc	h
PRIONC:
	ld	a,(hl)
	ret

PRIO:
;operator priority table
;		   not   +  -  *  /  ^ and or >  =  <
	db	5, 3, 0, 6, 6, 7, 7, 8, 2, 1, 4, 5, 4


;check string descriptor and copy
;output:z(1=backup, 0=no)
;broken:af,hl
COPYSTR:
	ld	a,(ARGTYP)
	dec	a
	ret	nz
	ld	hl,(FAC1+1)
	push	de
	ld	de,STRDSC1
	rst	CPHLDE
	jr	nz,CPSTREND
	push	bc
	ld	hl,STRBCK1
	ld	de,STRBCK2
	ld	bc,8
	ldir
	pop	bc
CPSTREND:
	pop	de
	ret			;z=1

;copy back string descriptor
;broken:hl
BACKSTR:
	ld	hl,(STRBCK2)
	ld	(STRBCK1),hl
	ld	hl,(STRBCK2+2)
	ld	(STRBCK1+2),hl
	ld	hl,0
	ld	(STRBCK2+2),hl
	ret


;convert float to string
;input: FAC1
;output: FAC3,hl=FAC3
;broken: FAC1,FAC2,af,b,de
FTOA:
	ld	de,FAC3
	ld	a,(FAC1+4)
	or	a
	jp	z,FTOAZERO
	ld	hl,FAC1+3
	ld	a,(hl)
	rlca
	ld	a," "
	jr	nc,FTOASGN
	res	7,(hl)
	ld	a,"-"
FTOASGN:
	ld	(de),a
	inc	de
FTOA2:
	push	de

	ld	hl,E8
	call	SETF2
	call	CMPF
	jp	nc,LARGE	;FAC1 >= 1e8
	ld	hl,EM2
	call	SETF2
	call	CMPF
	jp	c,SMALL		;FAC1 < 1e-2

	ld	b,9
FTOALP1:
	push	bc
	ld	hl,E7
	call	SETF2
	call	CMPF
	jr	nc,FTOAOK
	call	MULF10
	pop	bc
	djnz	FTOALP1
	push	bc

FTOAOK:
	pop	bc
	pop	de
	push	bc
	push	de
	push	bc
	ld	a,(FAC1+4)
	sub	97h
	ld	b,a
	ld	a,(FAC1)
FTOALP2:
	rlca
	djnz	FTOALP2

	jr	nc,NORDUP
	ld	hl,PLSONE
	call	SETF2
	call	ADDF
NORDUP:
	call	FTOI4
	pop	bc

	ld	hl,INTE7
	ld	c,0
FTOALP3:
	ld	a,b
	cp	2
	jr	c,FTOADOT
	push	bc
	call	DIVINT4
	pop	bc
	pop	de
	or	a
	jr	nz,PUTNUM
	dec	c
	inc	c
	jr	z,NOPUT
PUTNUM:
	add	a,"0"
	ld	(de),a
	inc	de
	inc	c
NOPUT:
	push	de
	djnz	FTOALP3

FTOADOT:
	pop	de
	pop	bc
	push	de

	push	hl
	ld	hl,FAC1
	ld	a,(hl)
	inc	hl
	or	(hl)
	inc	hl
	or	(hl)
	inc	hl
	or	(hl)
	pop	hl
	jr	z,FTOAEND

	ld	a,9
	sub	b
	ld	b,a
	pop	de
	ld	a,"."
	ld	(de),a
	inc	de

FTOALP4:
	push	hl
	ld	hl,FAC1
	ld	a,(hl)
	inc	hl
	or	(hl)
	inc	hl
	or	(hl)
	inc	hl
	or	(hl)
	pop	hl
	push	de
	jr	z,FTOAEND

	ld	a,b
	cp	9
	jr	nz,FTOANZ
	ld	a,"0"
	pop	de
	ld	(de),a
	inc	de
	push	de
	dec	b

FTOANZ:
	push	bc
	call	DIVINT4
	pop	bc
	pop	de
	add	a,"0"
	ld	(de),a
	inc	de
	djnz	FTOALP4

	push	de
;	jr	FTOAEND

FTOAEND:
	pop	hl
	ld	(hl),0
	ld	hl,FAC3
	ret


FTOAZERO:
	ex	de,hl
	ld	(hl)," "
	inc	hl
	ld	(hl),"0"
	inc	hl
	ld	(hl),0
	dec	hl
	dec	hl
	ret


LARGE:
	pop	af		;cancel
	xor	a
	push	af

LARLP1:
	pop	af
	inc	a
	push	af
	call	DIVF10
	ld	hl,E2
	call	SETF2
	call	CMPF
	jr	nc,LARLP1

	ld	de,FAC3+1
	call	FTOA2

LARLP2:
	ld	a,(hl)
	inc	hl
	or	a
	jr	nz,LARLP2

	dec	hl
	ld	(hl),"E"
	inc	hl
	ld	(hl),"+"
	inc	hl
	pop	af
	ld	bc,300ah	;b="0",c=10
LARLP3:
	sub	c
	jr	c,LAREND
	inc	b
	jr	LARLP3

LAREND:
	ld	(hl),b
	inc	hl
	add	a,c
	add	a,"0"
	ld	(hl),a
	inc	hl
	ld	(hl),0
	ld	hl,FAC3
	ret

SMALL:
	pop	af		;cancel
	xor	a
	push	af
SMALP1:
	pop	af
	inc	a
	push	af
	call	MULF10
	ld	hl,E0
	call	SETF2
	call	CMPF
	jr	c,SMALP1

	ld	de,FAC3+1
	call	FTOA2

SMALP2:
	ld	a,(hl)
	inc	hl
	or	a
	jr	nz,SMALP2

	dec	hl
	ld	(hl),"E"
	inc	hl
	ld	(hl),"-"
	inc	hl
	pop	af
	ld	bc,300ah	;b="0",c=10
SMALP3:
	sub	c
	jr	c,LAREND
	inc	b
	jr	SMALP3


PLSONE:
	db	00h, 00h, 00h, 00h, 81h

TRUE:
MNSONE:
	db	00h, 00h, 00h, 80h, 81h

FALSE:
ZERO:
	db	00h, 00h, 00h, 00h, 00h

;99999999.5
E8:
	db	0f0h, 1fh, 0bch, 3eh, 9bh

;9999999.95
E7:
	db	0f3h, 7fh, 96h, 18h, 98h

;9.99999995
E2:
	db	0f3h, 0ffh, 0ffh, 1fh, 84h

;0.999999995
E0:
	db	0ebh, 0ffh, 0ffh, 7fh, 80h

;0.1
EM1:
	db	0cdh, 0cch, 0cch, 4ch, 7dh

;0.00999999995
EM2:
	db	30h, 0ah, 0d7h, 23h, 7ah

INTE7:
	db	80h, 96h, 98h, 00h	;10^7
	db	40h, 42h, 0fh, 00h	;10^6
	db	0a0h,86h, 01h, 00h	;10^5
	db	10h, 27h, 00h, 00h	;10^4
	db	0e8h,03h, 00h, 00h	;10^3
	db	64h, 00h, 00h, 00h	;10^2
	db	0ah, 00h, 00h, 00h	;10^1
INTE0:
	db	01h, 00h, 00h, 00h	;10^0


;convert FAC1 and FAC2 to 2-byte integer
;input:	FAC1,FAC2
;output:de,hl
;broken:af,b
F12TOI2:
	ld	a,(ARGTYP)
	or	a
	jp	nz,TMERR
	call	FTOI2
	push	hl		;
	call	EXFAC
	call	FTOI2
	pop	de		;
	ret


;convert 2-byte integer to float for USR()
;input: ab
;output: FAC1
;broken: af,bc,hl
_ABTOF:	ds	ABTOF-_ABTOF
	org	ABTOF

	ld	h,a
	ld	l,b
	call	S2TOF
	ret


;convert float to 2-byte integer (-65535~65535)
;input: FAC1
;output: hl
;broken: af,b,de,hl
FTOI:
	ld	hl,0
	ld	a,(FAC1+4)
	or	a
	ret	z
	sub	91h
	jp	nc,FCERR	;large
	neg
	ld	b,a
	dec	b		;
	ex	de,hl
	ld	hl,(FAC1+2)
	ld	a,h		;;
	set	7,h
	jr	z,FTOIZ		;
FTOILP:
	srl	h
	rr	l
	djnz	FTOILP
FTOIZ:
	rlca			;;
	ret	nc
	ex	de,hl
	or	a
	sbc	hl,de
	ret


;convert float to 2-byte integer (-32768~32767)
;input: FAC1
;output: hl
;broken: af,b,de,hl
FTOI2:
	ld	a,(FAC1+3)
	push	af
	call	FTOI
	pop	af
	rlca			;
	bit	7,h		;;
	jr	c,FTOI2MNS	;
	ret	z		;;
	xor	a
FTOI2MNS:
	ret	nz		;;
	jp	FCERR


;convert float to 1-byte integer
;input: FAC1
;output: l
;broken: af,b,de,hl
FTOI1:
	call	FTOI2
	ld	a,h
	or	a
	ret	z
	jp	FCERR


;convert float to 4-byte integer
;input: FAC1
;output: FAC1 (integer)
;broken: af,b,de,hl
FTOI4:
	ld	a,(FAC1+4)
	or	a
	jr	nz,FTOI4NZ
	ld	h,a
	ld	l,a
	ld	(FAC1),hl
	ld	(FAC1+2),hl
FTOI4NZ:
	sub	81h+30
	ret	nc		;large
	neg
	inc	a
	ld	b,a
	ld	a,(FAC1+3)	;
	ld	hl,(FAC1)
	ld	de,(FAC1+2)
	set	7,d
FTOI4LP:
	srl	d
	rr	e
	rr	h
	rr	l
	djnz	FTOI4LP

	ld	(FAC1),hl
	ld	(FAC1+2),de
	rlca			;
	call	c,NEGINT4
	ret


;convert 1- or 2-byte integer to float
;input: hl=integer (unsigned)
;output: FAC1
;broken: af,b,hl
I1TOF:
	ld	h,0
I2TOF:
	ld	a,h
	or	l
	jr	z,I2TOFZERO
	ld	b,16
I2TOFLP:
	ld	a,h
	add	a,80h
	jr	c,I2TOFEND
	add	hl,hl
	djnz	I2TOFLP

I2TOFEND:
	ld	h,a
	ld	(FAC1+2),hl
	ld	hl,0
	ld	(FAC1),hl
	ld	a,b
	add	a,80h
	ld	(FAC1+4),a
	ret

I2TOFZERO:
;input:	hl=0
	xor	a
	ld	(FAC1),hl
	ld	(FAC1+2),hl
	ld	(FAC1+4),a
	ret


;convert 1- or 2-byte signed integer to float
;input: hl=integer (signed)
;output: FAC1
;broken: af,bc,hl
S1TOF:
	ld	h,0
	bit	7,l
	jr	z,S2TOF
	ld	h,0ffh
S2TOF:
	bit	7,h
	jr	z,I2TOF
	ld	b,h
	ld	c,l
	ld	hl,0
	or	a
	sbc	hl,bc
	call	I2TOF
	ld	hl,FAC1+3
	set	7,(hl)
	ret


;convert 4-byte integer to float (unsigned)
;input: de-hl
;output: FAC1
;broken: af,b,de,hl
I4TOF:
	ld	a,h
	or	l
	or	d
	or	e
	jr	z,I2TOFZERO

	ld	a,d
	ld	b,32
I4TOFLP:
	add	a,80h
	jr	c,I4TOFEND
	add	hl,hl
	rl	e
	rla
	djnz	I4TOFLP

I4TOFEND:
	ld	d,a
	ld	(FAC1+2),de
	ld	(FAC1),hl
	ld	a,b
	add	a,80h
	ld	(FAC1+4),a
	ret


;interrupt for normal key
INTKEY:
	push	af
	push	hl
	call	IN90H
	or	a
	jr	z,POPEIRET
	ld	hl,STOPFLG
	ld	(hl),0
	call	CLICK
	cp	03h		;Ctrl-C
	jr	z,SETSTOP
	cp	7fh
	jr	nz,INTKNZ
	ld	a,08h		;DEL->ctrl-H, not necessary for emulator?
INTKNZ:
	call	PUTKBF
	jr	c,POPEIRET
	cp	1bh
	jr	z,SETSTOP
	cp	14h
	jr	nz,POPEIRET
	ld	a,0efh		;Ctrl-T->14h+0efh
	call	PUTKBF
	jr	nc,POPEIRET

UNDOKBF:
	ld	hl,KYBFIN
	ld	a,(hl)
	dec	a
	cp	0ffh
	jr	nz,UNDONZ
	ld	a,(KYBFSZ)
UNDONZ:
	ld	(hl),a
	jr	POPEIRET


;interrupt for graphic key
INTGRP:
	push	af
	push	hl
	call	IN90H
	ld	hl,STOPFLG
	ld	(hl),0
	or	a
	jr	z,POPEIRET
	cp	0fch		;SHIFT+PAGE, only for emulator
	jr	z,POPEIRET
	cp	0feh		;KANA, only for emulator
	jr	z,POPEIRET

	call	CLICK
	cp	0fah		;STOP
	jr	z,STOPKEY
	push	af		;
	ld	a,14h
	call	PUTKBF
	pop	hl		;
	jr	c,POPEIRET
	ld	a,h
	call	PUTKBF
	jr	nc,POPEIRET
	jr	UNDOKBF

STOPKEY:
	ld	a,03h
SETSTOP:
	ld	(STOPFLG),a
POPEIRET:
	pop	hl
	pop	af
EIRET:
	ei
	ret


;put into key buffer
;input: a
;output: c-flag (1=buffer full)
;broken: f,hl
PUTKBF:
	ld	hl,KYBFIN
;	call	PUTBF
;	ret


;put characer into buffer
;input: a=character, hl=buffer control address
;output: c-flag (1=buffer full)
;broken: f,hl
PUTBF:
	push	af
	ld	a,(hl)		;in
	inc	a
	inc	l		;inc hl
	inc	l		;inc hl
	inc	l		;inc hl
	and	(hl)		;size
	dec	l		;dec hl
	dec	l		;dec hl
	cp	(hl)		;out
	jr	z,BFFULL

	dec	l		;dec hl
	ld	(hl),a		;in
	inc	l		;inc hl
	inc	l		;inc hl
	inc	l		;inc hl
	inc	l		;inc hl
	add	a,(hl)		;address
	inc	l		;inc hl
	ld	h,(hl)
	ld	l,a
	jr	nc,PTBNC
	inc	h
PTBNC:
	pop	af
	ld	(hl),a
	or	a		;reset c-flag
	ret

BFFULL:
	pop	af
	scf
	ret


;interrupt for RS-232C
INT232:
	push	af
	push	hl
	ld	a,17h		;RTS=0
	out	(81h),a
INT232LP:
	in	a,(81h)
	and	02h
	jr	z,INT232LP	;wait for RxRDY=1
	in	a,(80h)

	ld	hl,RSBFIN
	call	PUTBF

	ld	a,37h		;RTS=1
	out	(81h),a
	jr	POPEIRET


;interrupt for reply to key query
INTGAM:
	push	af
	call	IN90H
	ld	(GMKYBUF),a
	pop	af
	ei
	ret


;play subroutine called by time interrupt
;broken:af,hl
PLAYINT:
	push	de
	push	bc
	ld	a,(PLAYST)
	rrca
	rrca
	rrca
	ld	c,a
	ld	hl,PLWKC
	ld	b,3
PLILP:
	push	hl
	rlc	c
	jp	nc,PLIZ

	ld	d,(hl)
	inc	l		;inc	hl
	ld	e,(hl)
	dec	de
	ld	(hl),e
	dec	l		;dec	hl
	ld	(hl),d
	ld	a,d
	or	e
	jr	nz,PLINEXT
	jr	PLIGET

PLIZ:
	ld	hl,PLAYST
	ld	a,(CHANNEL)
	cpl
	or	(hl)
	jp	nz,PLINEXT

PLIGET:
;length
	call	GETPLBF
	jr	z,PLINEXT
	cp	0ffh
	jr	z,PLIRES
	pop	de
	push	de
	ld	(de),a
	call	GETPLBF		;no change in de
	inc	e		;inc de
	ld	(de),a

;tune
	call	GETPLBF
	ld	e,a
	ld	a,b
	add	a,a
	dec	a		;register1,3,5=4bit coarse tune
	call	SOUND
	call	GETPLBF
	ld	e,a
	ld	a,b
	dec	a
	add	a,a		;register0,2,4=8bit fine tune
	call	SOUND

;volume or envelope
	call	GETPLBF
	ld	d,a		;
	cp	10h
	jr	c,PLIVOL
	ld	a,10h		;envelope
PLIVOL:
	ld	e,a
	ld	a,b
	add	a,7		;register8,9,10=volume
	call	SOUND
	ld	a,d		;
	sub	10h
	jr	c,PLISET

;period
	ld	d,a		;
	call	GETPLBF
	ld	e,a
	ld	a,0bh
	call	SOUND
	call	GETPLBF
	ld	e,a
	ld	a,0ch
	call	SOUND

;envelope pattern
	ld	e,d		;
	ld	a,0dh		;register13=envelope pattern
	call	SOUND

;status
PLISET:
	set	0,c

PLINEXT:
	pop	hl
	ld	a,PLWKA-PLWKB
	add	a,l
	ld	l,a		;no increase
	djnz	PLILP

	ld	hl,PLAYST
	ld	a,(hl)
	or	a		;
	ld	(hl),c
	ld	a,c
	pop	bc
	pop	de
;	ret	z		;
;	or	a
;	ret	nz
;	jp	PLAYINT


	jr	nz,PLINZ
	or	a
	ret	nz
	ld	a,(CHANNEL)
	inc	a
	ret	nz
	ld	(CHANNEL),a
	ret
PLINZ:
	or	a
	jp	z,PLAYINT
	ret


PLIRES:
;reset
	res	0,c

	ld	a,b
	add	a,7		;register8,9,10=volume
	ld	e,0
	call	SOUND
	jr	PLINEXT


;interrupt for CMT error
INTERR:
	push	af
	ld	a,10h
	jr	SETCMTST


;interrupt for timer
_INTTIM:ds	INTTIM-_INTTIM

	org	INTTIM
	push	af
	push	hl

	call	PLAYINT

	ld	hl,(TIME)
	inc	l		;inc hl, no increase
	inc	hl
	ld	(TIME),hl
	ld	a,h
	or	l		;
	ld	a,l		;;
	jr	nz,TIMCSR	;
	ld	hl,(TIME+2)
	inc	hl
	ld	(TIME+2),hl

TIMCSR:
;cursor blink
	or	a		;;
	jp	nz,POPEIRET
	ld	a,(SCREEN1)
	ld	hl,CSRBLNK
	cpl
	rrca
	and	(hl)
	call	nz,CSRREV	;(SCREEN1)=0or1, (CSRBLNK)=1
	pop	hl
	pop	af
	ei
	ret


;interrupt for CMT load
INTCMT:
	push	af
	call	IN90H
	ld	(CMTBUF),a
	ld	a,02h
SETCMTST:
	ld	(CMTSTAT),a
	pop	af
	ei
	ret


;interrupt for CMT read stop
INTRSTP:
;interrupt for CMT write stop
INTWSTP:
	push	af
	ld	a,03h
	ld	(STOPFLG),a
	pop	af
	ei
	ret


;get input character
;output: a, z-flag(1=no input)
;broken: f
_GETC:	ds	GETC-_GETC
	org	GETC

	ld	a,(FNCCNT)
	or	a
	jr	z,FNCSKP

;function key
	push	hl
	dec	a
	ld	(FNCCNT),a
	ld	hl,(FNCAD)
	ld	a,(hl)
	inc	hl
	ld	(FNCAD),hl
	pop	hl
	or	a
	ret	nz

FNCSKP:
	ld	a,(GRPWRK)
	or	a
	jr	z,GETCZ
	push	bc
	ld	b,a
	xor	a
	ld	(GRPWRK),a
	ld	a,b
	pop	bc
	cp	0efh		;Ctrl-T=14h+0efh
	ret	z
	add	a,30h
	ret

GETCZ:
;(GRPWRK)=0
	push	hl
	call	GETKBF
	pop	hl
	ret	z
	cp	1bh		;ESC key
	jr	z,GETCZ
	cp	03h
	jr	z,GETCZ
	cp	14h
	ret	nz

;14h+**
	push	hl
	call	GETKBF
	pop	hl
	cp	0f0h
	jr	nc,SETFNC
	ld	(GRPWRK),a
	ld	a,14h
	or	a		;reset z-flag
	ret

SETFNC:
	push	hl
	sub	0f0h
	add	a,a
	add	a,a
	add	a,a
	ld	hl,FNCKEY
	add	a,l
	ld	l,a
	jr	nc,FNCNC
	inc	h
FNCNC:
	ld	(FNCAD),hl
	ld	a,8
	ld	(FNCCNT),a
	pop	hl
	jr	GETC


;get a character from buffer
;input:	hl=buffer map address
;output:a,z-flag(1=no input)
;broken:f,hl
GETBF:
	ld	a,(hl)		;in
	inc	l		;inc hl
	cp	(hl)		;out
	ret	z
	ld	a,(hl)
	inc	a
	inc	l		;inc hl
	inc	l		;inc hl
	and	(hl)		;size
	dec	l		;dec hl
	dec	l		;dec hl
	ld	(hl),a		;out
	inc	l		;inc hl
	inc	l		;inc hl
	inc	l		;inc hl
	add	a,(hl)		;hl=(bfad)+a
	inc	l		;inc hl, reset z-flag (l>0)
	ld	h,(hl)
	ld	l,a
	jr	nc,GETBFNC
	inc	h		;reset z-flag (h>0)
GETBFNC:
	ld	a,(hl)
	ret


;get a character from key buffer
;output:a,z-flag(1=no input)
;broken:f,hl
_GETKBF:ds	GETKBF-_GETKBF
	org	GETKBF

	ld	hl,KYBFIN
CALLGETBF:
	di
	call	GETBF
	ei
	ret

	
;get a character from RS-232C buffer
;output:a,z-flag(1=no input)
;broken:f,hl
GETRSBF:
	ld	hl,RSBFIN
	jr	CALLGETBF


;get from PLAY command buffer
;input:	b=channel+1 (1,2,3)
;output:a,z
;broken:f,hl
GETPLBF:
	ld	a,b
	add	a,a		;*2
	add	a,b		;*3
	add	a,a		;*6
	ld	l,BUFAIN-6	;(lower 1 byte)
	add	a,l		;(no increase)
	ld	l,a
	ld	h,BUFAIN/256	;(upper 1 byte)
	call	GETBF
	ret


;clear key buffer pointer
;broken:hl
_CLRKBF:ds	CLRKBF-_CLRKBF
	org	CLRKBF

	ld	hl,0
	ld	(KYBFIN),hl	;clear KYBFIN and KYBFOUT
	ret


;send key-query to sub CPU and get reply
;output: a (space-0-left-right-down-up-stop-shift)
;broken: f
_STICK:	ds	STICK-_STICK
	org	STICK

	ld	a,0ffh
	ld	(GMKYBUF),a
	ld	a,06h
	call	OUT90H
STICKLP:
	ld	a,(GMKYBUF)
	cp	0ffh		;bit6=0?
	jr	z,STICKLP
	ret


;put a character in CRT
;input: a
;broken: none
_PUTC:	ds	PUTC-_PUTC
	org	PUTC

	push	af
	push	hl
	push	de

	ld	hl,(GRPFLG)
	inc	l
	dec	l
	jr	nz,PUTGRP
	cp	20h
	jr	c,PUTCTL

PUTCMAIN:
	ld	h,a
	ld	a,(SCREEN1)
	cp	2
	jp	nc,PUTC34
	ld	a,h
	ld	hl,(CSRAD)
	ld	(hl),a
	inc	hl
	ld	(CSRAD),hl
	dec	hl
	call	CNVATT1
	ld	(hl),a
CHKNL:
	ld	hl,CSRX
	inc	(hl)
	ld	a,(WIDTH)
	cp	(hl)
	jr	c,CTLLF

PUTCEND:
CTLNUL:
	pop	de
	pop	hl
	pop	af
	ret

PUTGRP:
	sub	30h
	ld	hl,GRPFLG
	ld	(hl),0
	jr	PUTCMAIN

PUTCTL:
	ld	hl,CTLTBL
	jp	JPTBL

CTLGRP:
	ld	a,14h
	ld	(GRPFLG),a
	jr	PUTCEND

CTLRHT:
	ld	hl,(CSRY)	;l=y+1,h=x+1
	inc	h
	ld	a,(WIDTH)
	cp	h
	jr	nc,SETAD
	call	PRTNL
	jr	PUTCEND

CTLLFT:
	ld	hl,(CSRY)	;l=y+1,h=x+1
	dec	h
	jr	nz,SETAD
	dec	l
	jr	z,PUTCEND
	ld	a,(WIDTH)
	ld	h,a
	jr	SETAD

CTLUP:
	ld	hl,(CSRY)	;l=y+1,h=x+1
	dec	l
	jr	nz,CTLUPNZ
	ld	l,1
CTLUPNZ:
	ld	a,(CONSOL2)
	cp	l
	jr	SKPPATCH1


;10eah: to be patched by iP6plus
_PATCH1:ds	PATCH1-_PATCH1
	org	PATCH1
	db	00h


SKPPATCH1:
	jr	nc,SETAD
	ld	l,a
	jr	SETAD

CTLDWN:
	ld	hl,(CSRY)	;l=y+1,h=x+1
	inc	l
	jr	CTLUPNZ

CTLCLS:
	call	CLS
	jr	PUTCEND

CTLHOM:
	ld	a,(CONSOL1)
	ld	(CSRY),a
	jr	CTLCR

CTLLF:
	ld	hl,CSRY
	ld	a,(LASTLIN)
	dec	a
	cp	(hl)
	jp	c,SCROLL
	inc	(hl)
;	jr	CTLCR

CTLCR:
	ld	hl,(CSRY)	;l=y+1,h=x+1
	ld	h,1
;	jr	SETAD

;set cursor address
SETAD:
	call	SETCSR
	jr	PUTCEND

CTLTBL:
	dw	CTLNUL,CTLNUL,CTLNUL,CTLNUL,CTLNUL,CTLNUL,CTLNUL,CTLBEL
	dw	CTLNUL,CTLNUL,CTLLF, CTLHOM,CTLCLS,CTLCR, CTLNUL,CTLNUL
	dw	CTLNUL,CTLNUL,CTLNUL,CTLNUL,CTLGRP,CTLNUL,CTLNUL,CTLNUL
	dw	CTLNUL,CTLNUL,CTLNUL,CTLNUL,CTLRHT,CTLLFT,CTLUP, CTLDWN


;move cursor location
;input:	h=x+1, l=y+1
;output:(fda8h)=y+1,(fda9h)=x+1,(fdaa-fdab)=VRAM address
;broken:none
_SETCSR:ds	SETCSR-_SETCSR
	org	SETCSR
	push	hl
	ld	(CSRY),hl
	call	GETAD
	ld	(CSRAD),hl
	pop	hl
	ret


;cursor on
;broken: none
CSRON:
	push	af
	ld	a,1
	ld	(CSRBLNK),a
	pop	af
	ret


;cursor off
;broken: hl
CSROFF:
	push	af
	ld	a,(CSRSTAT)
	or	a
	di
	call	nz,CSRREV
	xor	a
	ld	(CSRBLNK),a
	ei
	pop	af
	ret


;reverse cursor
;broken: af,hl
CSRREV:
	ld	hl,CSRSTAT
	ld	a,(hl)
	cpl
	ld	(hl),a
	ld	hl,(CSRAD)
	dec	h
	dec	h
	ld	a,(hl)
	bit	6,a		;semi-graphic mode?
	jr	nz,CSRSEMI
	xor	01h
	ld	(hl),a
	ret

CSRSEMI:
	inc	h
	inc	h
	ld	a,(hl)
	cpl
	ld	(hl),a
	ret


;get VRAM attirbute address (screen mode 1,2)
;input: bc=graphic X, hl=graphic Y
;output: hl=VRAM address, d=Y mod 12
;broken: af,bc
GETADG:
	call	CHKXY
	call	DIV12
	ld	d,a
;hl=(VRAM)+X/8+Y/12*32
	add	hl,hl		;*2
	add	hl,hl		;*4
	add	hl,hl		;*8
	add	hl,hl		;*16
	add	hl,hl		;*32
	ld	a,(VRAM)
	ld	b,a
	srl	c
	srl	c
	srl	c
	add	hl,bc
	ret


;get VRAM character address (screen mode 1,2)
;input: h=x+1, l=y+1
;output: hl=VRAM address
;broken: none
_GETAD:ds	GETAD-_GETAD
	org	GETAD

	push	af
	push	de
	dec	h
	dec	l
	ex	de,hl
	ld	a,(VRAM)
	rra
	inc	a
	ld	h,a
	ld	l,d
	ld	a,e
	add	a,a		;*2
	add	a,a		;*4
	add	a,a		;*8
	add	a,a		;*16
	add	a,a		;*32
	rl	h
	add	a,l
	ld	l,a
	pop	de
	pop	af
	ret


;	push	af
;	push	de
;	dec	h
;	dec	l
;	ld	a,(VRAM)
;	inc	a
;	inc	a
;	ld	d,a
;	ld	e,h
;	ld	h,0
;	add	hl,hl		;*2
;	add	hl,hl		;*4
;	add	hl,hl		;*8
;	add	hl,hl		;*16
;	add	hl,hl		;*32
;	add	hl,de
;	pop	de
;	pop	af
;	ret


;a=(LASTLIN)-1
;hl=CSRY
SCROLL:
	push	bc
	inc	a
	ld	(hl),a
	ld	hl,(CONSOL1)
	sub	l		;a=(LASTLIN)-(CONSOL1) < 16
	ld	h,1
	call	GETAD
	ld	d,h
	ld	e,l
	ld	bc,COLUMNS
	add	hl,bc
	add	a,a		;*2
	add	a,a		;*4
	add	a,a		;*8
	add	a,a		;*16
	add	a,a		;*32
	ld	c,a
	rl	b		;bc=((LASTLIN)-(CONSOL1))*32
	ld	a,b
	or	c
	jr	z,SCROLLZ

	ld	a,(SCREEN1)
	cp	2
	jr	nc,SCRL34

	push	hl
	push	de
	push	bc
	ldir
	pop	bc
	pop	de
	pop	hl

;attribute
	dec	d
	dec	d
	dec	h
	dec	h
	ldir
	inc	d
	inc	d

SCROLLZ:
	call	GETSP
	ld	h,d
	ld	l,e
	ld	(hl),a
	inc	e		;inc de
	ld	c,COLUMNS-1	;b=0
	push	hl
	push	de
	ldir

;attribute
	call	GETSPA
	pop	de
	pop	hl
	dec	d
	dec	d
	dec	h
	dec	h
	ld	(hl),a
	ld	c,COLUMNS-1	;b=0
	ldir
	pop	bc
	jp	CTLCR

SCRL34:
	call	GETAD34
	ex	de,hl
	ld	h,b
	ld	l,c
	add	hl,hl		;bc*2
	add	hl,bc		;bc*3
	add	hl,hl		;bc*6
	add	hl,hl		;bc*12
	ld	b,h
	ld	c,l
	ld	hl,0-180h
	add	hl,de
	ex	de,hl
	ldir

	ld	h,d
	ld	l,e
	inc	de
	ld	a,(COLOR2)
	call	SETATT
	ld	(hl),a
	ld	bc,180h
	ldir

	pop	bc
	jp	CTLCR



;h=character
PUTC34:
	ld	a,04h
	out	(93h),a		;CGROM ON
	ld	a,h


;	call	CGROM
;
	rlca
	rlca
	rlca
	rlca
	ld	d,a
	and	0f0h
	ld	e,a
	ld	a,d
	and	0fh
	add	a,60h
	ld	d,a
;
;

	ld	hl,(CSRAD)
	call	GETAD34
	ld	a,(COLOR1)
	call	SETATT

	push	bc
	ld	b,0ch
	exx
	push	de
	push	bc
	exx
PUTC34LP:
	ld	a,(SCREEN1)
	cp	2
	ld	a,(de)
	jr	z,CALL3
	call	PUTC4
	jr	CALL34END
CALL3:
	call	PUTC3
	dec	hl
CALL34END:
	push	de
	ld	de,0020h
	add	hl,de
	pop	de
	inc	de
	djnz	PUTC34LP

	exx
	pop	bc
	pop	de
	exx
	pop	bc

	ld	a,05h
	out	(93h),a		;CGROM OFF

	ld	hl,(CSRAD)
	inc	hl
	ld	(CSRAD),hl
	jp	CHKNL


PUTC3:
	call	PUTHALF
	inc	hl
	ld	a,(de)
	rrca
	rrca
	rrca
	rrca
PUTHALF:
	exx
	and	0f0h
	ld	c,a
	xor	a
	ld	d,0c0h
	ld	b,4
PUTC3LP:
	rl	c
	jr	nc,PUTC3NC
	add	a,d
PUTC3NC:
	srl	d
	srl	d
	djnz	PUTC3LP
	exx

PUTC4:
	ld	c,a
	ld	a,(ATTDAT)
	xor	(hl)
	and	c
	xor	(hl)
	ld	(hl),a
	xor	a
	ret


;get (step)(x,y) cordinate
;input: de=program address
;output: bc=X(0-255), hl=Y(0-191), (GRPX1),(GRPY1)(0-32767)
;broken: af,de
GETXYLP:
	inc	de
GETXY:
	ld	a,(de)
	cp	" "
	jr	z,GETXYLP
	cp	STEP
	push	af		;STEP?
	jr	nz,GETXYNZ
	inc	de
GETXYNZ:
	call	CHKLPAR
	call	INTARG2		;bc,hl
	call	CHKRPAR
	pop	af		;STEP?
	jr	nz,NOSTEP
	ex	de,hl
	ld	hl,(GRPX1)
	add	hl,bc

	ld	b,h
	ld	c,l
	ld	hl,(GRPY1)
	add	hl,de

NOSTEP:
	bit	7,b
	jp	nz,FCERR
	bit	7,h
	jp	nz,FCERR
	ld	(GRPX1),bc
	ld	(GRPY1),hl
;	call	CHKXY
;	ret


;check graphic coordinates (x,y)
;input: bc=x, hl=y
;output: bc,hl
;broken: af,de
CHKXY:
	ld	a,b
	or	a
	jr	z,CHKXOK
	ld	c,255
CHKXOK:
	ld	de,191
	ld	a,(SCREEN1)
	cp	2
	jr	nc,NOFKEY
	ld	a,(CONSOL3)
	or	a
	jr	z,NOFKEY
	ld	de,191-12
NOFKEY:
	rst	CPHLDE
	jr	c,CHKYOK
	ex	de,hl
CHKYOK:
	ld	a,(SCREEN1)	;0,1,2,3
	ld	b,a
	dec	a
	jr	z,ROUNDY2
	jp	p,ROUNDX	;screen mode 3,4

;round off y for screen mode 1
ROUNDY1:
	call	DIV12
	ld	a,l
	add	a,a		;*2
	add	a,l		;*3
	add	a,a		;*6
	add	a,a		;*12
	ld	l,a		;h=0
	jr	ROUNDX

;round off y for screen mode 2
ROUNDY2:
	ld	a,0fch
	and	l
	ld	l,a

ROUNDX:
	inc	b
	ld	a,10h
ROUNDXLP:
	rrca
	djnz	ROUNDXLP
	dec	a
	cpl			;f8,fc,fe,ff
	and	c
	ld	c,a		;b=0
	ret


;skip space
;input: de=program address
;output: a=code, de,(PROGAD)=code address
;broken: f
SKIPSPLP:
	inc	de
SKIPSP:
	ld	a,(de)
	cp	" "
	jr	z,SKIPSPLP
	ld	(PROGAD),de
	ret


;check colon and line end
;input: de=program address
;output: a=(de), z-flag(1= 00h or ":")
;broken: af
CHKCLN:
	ld	a,(de)
	or	a
	ret	z
	cp	":"
	ret	z
	cp	" "
	ret	nz
	inc	de
	jr	CHKCLN


;check comma or argument
;input: de=program address
;output: a=(de), f(z=1:comma), de=next address
CHKCMM:
	call	CHKCLN		;a=(de)
	jp	z,MOERR
	inc	de
	cp	" "
	jr	z,CHKCMM
	cp	","
	ret	z
	dec	de
	ret


;change screen mode
;input: a=mode-1
;broken: af,de
_CHGMOD:ds	CHGMOD-_CHGMOD
	org	CHGMOD

	cp	4
	jp	nc,FCERR
	push	hl
	ld	hl,SCREEN1
	ld	e,(hl)		;
	cp	e
	jr	z,CMODEND
	ld	(hl),a

	push	bc
	push	af		;

	cp	2
	ld	a,COLUMNS	;screen mode 1,2,4:width=32
	jr	nz,SETWID
	rra			;screen mode 3:width=16
SETWID:
	ld	(WIDTH),a

	ld	hl,M1COLOR
	ld	d,0
	add	hl,de		;
	add	hl,de
	add	hl,de
	ex	de,hl
	ld	hl,COLOR1
	ld	bc,3
	ldir

	pop	af		;
	ld	hl,M1COLOR
	ld	d,b		;b=0
	ld	e,a
	add	hl,de
	add	hl,de
	add	hl,de
	ld	de,COLOR1
	ld	bc,3
	ldir

	ld	l,1
	ld	a,ROWS-1
	call	CLSMAIN

	ld	a,(SCREEN1)
	cp	2
	ld	a,(CONSOL2)
	ld	hl,(CONSOL3)
	jr	nc,CMODNC
	sub	l		;screen mode 1,2
CMODNC:
	ld	(LASTLIN),a

	pop	bc
CMODEND:
	pop	hl
	ret


;change display page
;page1=8000h or c000h	out (0b0h),4 or 0
;page2=e000h		out (0b0h),2
;page3=c000h		out (0b0h),0
;page4=a000h		out (0b0h),6
;input: a=page-1
;broken: af
_CHGDSP:ds	CHGDSP-_CHGDSP
	org	CHGDSP

	ld	(SCREEN3),a
	or	a
	jr	nz,DSPOK
	ld	a,(BASICAD+1)
	cp	0c4h
	ld	a,2		;16KB:page1=c000h
	jr	z,DSPOK
	xor	a		;32KB:page1=8000h
DSPOK:
;0,1,2,3->4,2,0,6
	rrca
	ccf
	adc	a,0
	rlca
	rlca
;	and	06h

	push	bc
	ld	b,00000110b
	call	OUTB0H
	pop	bc
	ret


;change active page
;input: a=page-1
;broken: none
_CHGACT:ds	CHGACT-_CHGACT
	org	CHGACT

	push	af
	push	hl
	push	de
	push	bc

	ld	hl,SCREEN2
	cp	(hl)
	jr	z,ACTEND
	push	af		;
	ld	b,a
	ld	a,(hl)
	ld	(hl),b
	call	GETPGAD
	ex	de,hl
	ld	hl,VRAM		;top of active page data
	ldir

	pop	af		;
	call	GETPGAD
	ld	de,VRAM
	ldir

ACTEND:
	pop	bc
	pop	de
	pop	hl
	pop	af
	ret


;change to text screen
;input:	none
;output:none
;broken:af
CHGTXT:
	ld	a,(SCREEN3)
	call	CHGACT
	ld	a,(SCREEN1)
	cp	2
	ret	c
	xor	a
	call	CHGACT
	call	CHGDSP
	ret


;get page data address
;input: a=page-1
;output: hl=address, bc=size
;broken: af
GETPGAD:
	inc	a
	ld	hl,PAGE1-(PAGE2-PAGE1)
	ld	bc,PAGE2-PAGE1
PGADLP:
	add	hl,bc
	dec	a
	jr	nz,PGADLP
	ret


;get space character data for scroll
;output: a
;broken: f
GETSP:
	ld	a,(SCREEN1)
	or	a
	ld	a," "
	ret	z

;screen mode 2
	ld	a,(COLOR2)
	or	a
	jr	z,GETSP2Z	;color,0
	dec	a
	and	03h
	rrca
	rrca
	or	3fh
	ret

GETSP2Z:
	ld	a,(COLOR1)
	or	a
	ret	z
	dec	a
	cp	4
	jr	c,GETSP2ZC
	sub	4
GETSP2ZC:
	rrca
	rrca
	ret


;get space attribute data for scroll
;output: a
;broken: f,hl
GETSPA:
	ld	a,(SCREEN1)
	or	a
	jr	nz,GETSPA2
	ld	a,(COLOR1)
	call	CNVATT
	ret

GETSPA2:
	ld	a,(COLOR2)
	or	a
	jr	nz,GETSPA2NZ
	ld	a,(COLOR1)
GETSPA2NZ:
	cp	5
	ld	a,(COLOR3)
	jr	c,GETSPAC
	xor	02h
GETSPAC:
	add	a,60h
	ret


;get CGROM address
;input:	a=character code
;output:de
;broken:none
_CGROM:	ds	CGROM-_CGROM
	org	CGROM

	push	af
	rlca
	rlca
	rlca
	rlca
	ld	d,a
	and	0f0h
	ld	e,a
	ld	a,d
	and	0fh
	add	a,60h
	ld	d,a
	pop	af
	ret

;	push	af
;	ex	de,hl
;	ld	h,06h
;	ld	l,a
;	add	hl,hl
;	add	hl,hl
;	add	hl,hl
;	add	hl,hl
;	ex	de,hl
;	pop	af
;	ret


;convert to attribute data
;input: a=color code
;output: a=attribute
;broken: f
CNVATT:
	push	af		;color
	ld	a,(SCREEN1)
	dec	a
	jr	z,ATT2
	jp	m,ATT1
	dec	a
	jr	z,ATT3

ATT4:
	pop	af
	or	a
	ret	z
	ld	a,0ffh
	ret

ATT3:
	pop	af
	or	a
	ret	z
	cp	05h
	jr	c,ATT3C
	ld	a,4
ATT3C:
	dec	a
	push	bc
	ld	c,a
	ld	b,3
ATT3LP:
	rrca
	rrca
	or	c
	djnz	ATT3LP
	pop	bc
	ret

ATT2:
	pop	af
	cp	9
	ret	c
	ld	a,8
	ret


;convert to attribute address and get value for screen mode 1
;input: hl=character address
;output: hl=attribute address, a=attirbute value
;broken: f
CNVATT1:
	dec	h		;hl=hl-200h
	dec	h
	ld	a,(COLOR1)
	push	af

ATT1:
	pop	af
	or	a
	jr	z,ATT1OK
	dec	a
	cp	4
	jr	c,ATT1OK
	ld	a,3
ATT1OK:
	add	a,20h
	push	hl
	ld	hl,COLOR3
	xor	(hl)
	pop	hl
	ret


;get attribute
;input:	hl=address, d=bit
;output:e
;broken:af
GETATT:
	ld	a,(hl)
	and	d
	ld	e,a

	ld	a,(SCREEN1)
	or	a
	ret	z		;screen mode 1
	push	bc
	push	hl
	cp	2
	ld	a,e
	jr	z,GETATT3
	ld	b,7
GETATT4LP:
	rlca
	add	a,e
	djnz	GETATT4LP
GETATTEND:
	ld	e,a
	pop	hl
	pop	bc
	ret

;screen mode 3
GETATT3:
	ld	b,3
GETATT3LP:
	rlca
	rlca
	add	a,e
	djnz	GETATT3LP
	jr	GETATTEND


;get VRAM dot pattern address (screen mode 3,4)
;input: bc=graphic X, hl=graphic Y
;output: hl=VRAM address, d=bit
;broken: af,bc
;hl=(VRAM)+(X/8)*Y*32
GETADG34:
	push	de
	call	CHKXY
	pop	de
	add	hl,hl		;*2
	add	hl,hl		;*4
	add	hl,hl		;*8
	add	hl,hl		;*16
	add	hl,hl		;*32
	ld	a,(VRAM)
	add	a,2
	ld	b,a
	ld	a,c
	srl	c
	srl	c
	srl	c
	add	hl,bc

	and	07h
	inc	a
	ld	b,a

	ld	a,(SCREEN1)
	cp	3
	ld	a,01h
	jr	z,GADG34LP	;screen mode 4

	dec	b
	res	0,b
	inc	b
	ld	a,81h

GADG34LP:
	rrca
	djnz	GADG34LP
	ld	d,a
	ret


;get VRAM character address (screen mode 3,4)
;input: hl=character VRAM address =(VRAM+200h)+y*32+x
;output: hl=graphic VRAM address =(VRAM+200h)+y*384+x
;broken: none
GETAD34:
	push	af
	push	de
	push	bc

	ld	a,l
	and	1fh
	ld	c,a	;x
	ld	a,l
	and	0e0h
	ld	l,a

	ld	a,h
	and	0feh
	ld	b,a
	ld	a,h
	and	01h
	ld	h,a

	ld	d,h
	ld	e,l
	add	hl,hl	;y*32*2
	add	hl,de	;y*32*3
	add	hl,hl	;y*32*6
	add	hl,hl	;y*32*12
	ld	a,(SCREEN1)
	cp	2
	jr	nz,GAD34NZ
;screen mode 3
	sla	c
GAD34NZ:
	add	hl,bc
	pop	bc
	pop	de
	pop	af
	ret


CTLBEL:
	push	bc
	di
	call	PLSTPS
;tune
	xor	a		;register0=ch.A 8bit fine tune
	ld	e,55h
	call	SOUND
	ld	e,a		;a=0
	inc	a		;register1=ch.A 4bit coarse tune
	call	SOUND
;volume
	ld	hl,0800h
	ld	a,h		;register8=ch.A volume
	ld	e,07h
	call	SOUND
	call	WAIT

;volume
	ld	e,l		;l=0
	call	SOUND
	ei
	pop	bc
	jp	PUTCEND


;check stop
;broken: af
CHKSTOP:
	ld	a,(STOPFLG)
	cp	03h
	jp	z,C_STOP
	cp	1bh
	ret	nz
CHKSTLP:
	ld	a,(STOPFLG)
	cp	1bh
	jr	z,CHKSTLP
	call	GETC		;cancel ESC
	jr	CHKSTOP


;set attribute data
;input: a=color code
;output: a,(ATTDAT)=attribute
;broken: f
_SETATT:ds	SETATT-_SETATT
	org	SETATT

	call	CNVATT
	ld	(ATTDAT),a
	ret


;jump subroutine in table
;input: hl=table address, a=data(00h-7fh or 80h-ffh)
;broken: af,hl
JPTBL:
	add	a,a
	add	a,l
	ld	l,a
	jr	nc,JPTBLNC
	inc	h
JPTBLNC:
	ld	a,(hl)
	inc	hl
	ld	h,(hl)
	ld	l,a
	jp	(hl)


;get data from port 90h
;output: a
;broken: f
IN90H:
	ld	a,0ch
	out	(93h),a		;nack=0
IN90HLP:
	in	a,(92h)
	cpl
	and	28h
	jr	nz,IN90HLP	;wait for ibf=1,intr=1
	ld	a,0dh
	out	(93h),a		;nack=1
	in	a,(90h)
	ret


;output port 90h
;input: a=data
;broken: none
OUT90H:
	di
	push	af
	ld	a,08h
	out	(93h),a		;nstb=0
OUT90HLP:
	in	a,(92h)
	rlca
	jr	nc,OUT90HLP	;wait for nobf=1
	ld	a,09h
	out	(93h),a		;nstb=1
	pop	af
	out	(90h),a
	ei
	ret


;put into variable
;input: bc=variable name, de=program address, hl=variable address
;output: hl=next program address
;broken: af,bc,de
VARIN:
	call	SKIPSP
	cp	EQ		;0d2h
	jp	nz,SNERR

	push	bc
	push	hl		;variable address
	inc	de
	call	ARG
	pop	de		;variable address
	pop	bc

	ld	a,(ARGTYP)
	or	a
	jr	z,VARNUM
	dec	a
	jp	nz,SNERR

;string
	bit	7,c
	jp	z,TMERR
	ld	a,(STRDSC1+3)
	cp	0fah		;fa00h=work area start address
	jr	c,VARSTROK
	xor	a
	ld	(STRDSC2),a
	push	de
	call	ADDSTR
	pop	de
VARSTROK:
	ld	hl,STRDSC1
	ld	bc,4
	jr	VARINOK
VARNUM:
	bit	7,c
	jp	nz,TMERR
	ld	hl,FAC1
	ld	bc,5
VARINOK:
	ldir
	ld	hl,(PROGAD)
	ret


;search variable
;input: bc=variable name
;output: hl=address, c-flag(1=not found)
;broken: af,de
SRCHVAR:
	ld	hl,(FNPAR)
	ld	a,l
	cp	b
	jr	nz,SRCHVMAIN
	ld	a,h
	cp	c
	ld	hl,FNARG
	ret	z

SRCHVMAIN:
	ld	hl,(VARAD)
SRCHVLP:
	ld	de,(ARRAD)
	rst	CPHLDE
	ccf
	ret	c		;not found
	ld	a,(hl)
	inc	hl
	cp	b		;
	ld	a,(hl)
	inc	hl
	jr	nz,VARNEXT	;
	cp	c
	ret	z		;found
VARNEXT:
	rlca			;c-flag=1 if string
	ccf
	ld	de,6-2
	adc	hl,de
	jr	SRCHVLP


;make variable
;input: bc=variable name, hl=variable address
;output: hl=hl+2
;broken: af,bc,de
MAKEVAR:
	push	bc		;variable name
	push	hl		;variable address

	ld	de,6
	bit	7,c
	jr	nz,MAKEVSTR
	inc	e
MAKEVSTR:
	push	de		;numeric=7, string=6
	ld	hl,(FREEAD)
	ld	de,(ARRAD)
	or	a
	sbc	hl,de
	ld	b,h
	ld	c,l

	ld	hl,(FREEAD)
	pop	de		;numeric=7, string=6
	push	de		;numeric=7, string=6
	add	hl,de
	call	CHKSTK
	ld	(FREEAD),hl

	pop	de		;numeric=7, string=6
	ld	hl,(ARRAD)
	add	hl,de
	ld	(ARRAD),hl

	ld	a,b
	or	c
	jr	z,NOLDDR
	ld	hl,(FREEAD)
	sbc	hl,de		;c-flag=0
	dec	hl
	ld	de,(FREEAD)
	dec	de
	lddr
NOLDDR:
	pop	hl		;variable address
	pop	bc		;variable name
	ld	(hl),b
	inc	hl
	ld	(hl),c
	inc	hl
	push	hl
	ex	de,hl

	bit	7,c		;
	ld	hl,ZERO
	ld	bc,4
	jr	nz,INISTR	;
	inc	c
INISTR:
	ldir
	pop	hl
	ret


;check variable name
;input: hl=program address
;output: bc=name, hl=next address
;broken: af
CHKVAR:
	ld	a,(hl)
	inc	hl
	cp	" "
	jr	z,CHKVAR
	ld	b,a
	sub	"A"
	cp	"Z"-"A"+1
	jp	nc,SNERR
;	call	GETNAME
;	ret


;get variable name
;input: hl=2nd character address, b=1st character
;output: bc=name, hl=next address
;broken: af
GETNAME:
	ld	c,0
	dec	hl
NAMELP1:
	inc	hl
	ld	a,(hl)
	cp	" "
	jr	z,NAMELP1
	cp	"$"
	jr	z,NAMESTR
	call	ALPNUM
	ret	c
	ld	c,a
NAMELP2:
	inc	hl
	ld	a,(hl)
	cp	" "
	jr	z,NAMELP2
	call	ALPNUM
	jr	nc,NAMELP2
	cp	"$"
	ret	nz
NAMESTR:
	inc	hl
	set	7,c
	ret


;get variable name for PLAY command
;input: b=1st character
;output: bc=name
;broken: af,hl
GETNAMEPLAY:
	ld	c,0
	call	PLAYGETC
	ret	z
	cp	";"
	ret	z
	call	PLAYINC
	cp	"$"
	jr	z,NAMEPLSTR
	call	TOUPPER
	call	ALPNUM
	jp	c,FCERR
	ld	c,a
NAMEPLLP:
	call	PLAYGETC
	ret	z
	cp	";"
	ret	z
	call	PLAYINC
	cp	"$"
	jr	z,NAMEPLSTR
	call	TOUPPER
	call	ALPNUM
	jp	c,FCERR
	jr	NAMEPLLP
NAMEPLSTR:
	set	7,c
	ret


;alphabet or numeral?
;input: a
;output: c-flag(0=yes,1=no)
;broken: f
ALPNUM:
	cp	"0"
	ret	c
	cp	"9"+1
	ccf
	ret	nc
	cp	"A"
	ret	c
	cp	"Z"+1
	ccf	
	ret


;get variable address
;input: bc=variable name, hl=program address
;output: hl=variable address, (PROGAD)=next program address
;broken: FAC1,FAC2,af,de
GETVAR:
	push	bc
	ld	a,(hl)
	cp	"("
	jr	z,GETVARR
	ld	(PROGAD),hl
	call	SRCHVAR
	call	c,MAKEVAR
	pop	bc
	ret
GETVARR:
	call	GETARR
	pop	bc
	ret


;get array address
;input: bc=variable name, hl=program address of "("
;output: hl=array address
;broken: af,bc,de
GETARR:
	inc	hl
	ld	(PROGAD),hl
	push	bc		;variable name
	call	SRCHARR
	jr	nc,ARROK

	push	hl		;array address
	ld	de,(PROGAD)
	push	de		;program address
	call	DIMAUTO
	pop	hl		;program address
	ld	(PROGAD),hl
	pop	hl		;array address
	inc	hl
	inc	hl
ARROK:
	inc	hl
	inc	hl
	ld	c,(hl)		;dimensions
	ld	b,0
	add	hl,bc
	add	hl,bc
	push	hl		;array address
	ld	b,c
	ld	a,c
	ex	af,af'		;dimensions
	push	af

	ld	de,0
	push	de		;pointer
	push	hl		;array address
	ld	hl,1
	ld	(TMP),hl	;multiplied sizes

GETALP:
	ld	hl,(TMP)
	push	hl		;multiplied sizes
	ld	de,(PROGAD)
	call	INT2ARG
	pop	de		;multiplied sizes
	ld	(TMP),de
	ex	(sp),hl		;push suffix, pop array address
	ld	d,(hl)		;de=size of each dimension
	dec	hl
	ld	e,(hl)
	dec	hl
	ex	(sp),hl		;push array address, pop suffix
	rst	CPHLDE
	jp	nc,BSERR

	push	de		;size
	ld	de,(TMP)	;multiplied sizes
	call	MULINT2		;hl = multiplied sizes * suffix
	pop	bc		;size
	ex	de,hl
	pop	hl		;array address
	ex	(sp),hl		;push array address, pop pointer
	add	hl,de		;pointer += multiplied size * suffix
	push	hl		;pointer
	ld	hl,(TMP)	;multiplied sizes
	ld	d,b		;size
	ld	e,c
	call	MULINT2		;hl = multiplied size * size
	ld	(TMP),hl
	pop	hl		;pointer
	ex	(sp),hl		;push poniter, pop array address
	push	hl		;array address

	ex	af,af'		;dimensions
	dec	a
	ld	b,a
	ex	af,af'
	ld	hl,(PROGAD)
	ld	a,(hl)
	cp	","
	jr	nz,NOTCMM
	inc	hl
	ld	(PROGAD),hl
	inc	b
;	dec	b
;	jr	nz,GETALP
	djnz	GETALP
	jp	SNERR

NOTCMM:
	inc	b
	dec	b
	jp	nz,BSERR
	cp	")"
	jp	nz,SNERR
	inc	hl
	ld	(PROGAD),hl

	pop	de		;array address
	pop	hl		;pointer
	pop	af
	ex	af,af'
	pop	de		;array address
	pop	bc		;variable name
	ld	a,c
	ld	b,h
	ld	c,l
	add	hl,hl		;*2
	add	hl,hl		;*4
	rlca
	jr	c,NCMMSTR
	add	hl,bc		;*5
NCMMSTR:
	add	hl,de
	inc	hl
	ret


DIMAUTO:
	call	SETARNM
	push	hl		;array address

	bit	7,c
	ld	bc,4
	jr	nz,AUTOSTR
	inc	c		;numeric:bc=5, string:bc=4
AUTOSTR:
	push	hl		;array address
	push	bc		;element bytes

	ld	de,(PROGAD)
	ld	c,0
AUTOLP1:
	push	bc		;dimensions
	call	INT2ARG
	ld	a,h
	or	a
	jp	nz,BSERR
	ld	a,l
	ld	l,11		;hl=10+1
	cp	l
	jp	nc,BSERR
	pop	bc		;dimensions
	inc	c
	ld	a,c
	cp	4
	jp	nc,BSERR	;over 3 dimensions
	pop	de		;element bytes
	ex	(sp),hl		;push size, pop array address
	push	hl		;array address
	push	de		;element bytes
	ld	de,(PROGAD)
	ld	a,(de)
	inc	de
	cp	","
	jr	z,AUTOLP1
	cp	")"
	jp	nz,SNERR
	call	MAKEARR
	ret


;search array variable
;input: bc=variable name
;output: hl=address, c-flag(1=not found)
;broken: af,de
SRCHARR:
	ld	hl,(ARRAD)
SRCHALP:
	ld	de,(FREEAD)
	rst	CPHLDE
	ccf
	ret	c		;not found
	ld	a,(hl)
	inc	hl
	cp	b		;
	ld	a,(hl)
	inc	hl
	jr	nz,ARRNEXT	;
	cp	c
	ret	z		;found
ARRNEXT:
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	add	hl,de
	jr	SRCHALP


;make array
;input: c=dimensions, de=program address
;pushed: size*(1~255), array address, element bytes
;broken:
MAKEARR:
	ld	(PROGAD),de
	pop	hl		;return address
	ld	(TMP),hl
	pop	de		;element bytes
	pop	hl		;array address
	inc	hl
	inc	hl
	ld	(hl),c		;dimensions
	inc	hl
	ld	b,c
	ex	de,hl

DIMLP2:
	ex	(sp),hl		;push element bytes, pop size
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ex	(sp),hl		;push array address, pop element bytes
	push	bc		;dimensions
	call	MULINT2
	pop	bc		;dimensions
	ld	a,d
	or	e
	jp	nz,BSERR
	pop	de		;array address
	djnz	DIMLP2

	push	hl		;element bytes
	add	hl,bc		;b=0
	jp	c,OMERR
	add	hl,bc
	jp	c,OMERR
	inc	hl		;+1(dimensions)
	ld	a,h
	or	l
	jp	z,OMERR
	push	hl		;dimensions*2 + element bytes + 1
	ld	de,4
	add	hl,de		;+2(total bytes)+2(name)
	jp	c,OMERR

	ld	de,(FREEAD)
	add	hl,de
	jp	c,OMERR
	call	CHKSTK
	ld	(FREEAD),hl

	ld	a,c		;dimensions
	pop	de		;dimensions*2 + element bytes + 1
	pop	hl		;element bytes
	ex	(sp),hl		;push element bytes, pop array address

	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	inc	hl
	add	hl,bc
	add	hl,bc

	ld	(hl),0
	ld	d,h
	ld	e,l
	inc	de
	pop	bc		;element bytes
	dec	bc
	ldir
	ld	hl,(TMP)	;return address
	jp	(hl)


;set array name
;input: bc=name, hl=array address
;output: hl=array address (next of name)
;broken: af,de
SETARNM:
	call	CHKSTK
	ld	(hl),b
	inc	hl
	ld	(hl),c
	inc	hl
	ret


;garbage collection
;broken: af,bc,de,hl
GC:
	ld	hl,(STREND)
	ld	(STRAD),hl

GCLP:
	ld	hl,0
	ld	(GCWRK),hl
	ld	hl,(VARAD)

;normal variable
GCVAR:
	ld	de,(ARRAD)
	rst	CPHLDE
	jr	nc,GCARR
	inc	hl
	ld	a,(hl)
	rlca
	jr	c,GCVARS
	ld	de,6
	add	hl,de
	jr	GCVAR
GCVARS:
	inc	hl
	call	GETSTR
	jr	GCVAR


;array variable
GCARR:
	ld	de,(FREEAD)
	rst	CPHLDE
	jr	nc,GCSDSC
	inc	hl
	ld	a,(hl)
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	rlca
	jr	c,GCARRS
	add	hl,de
	jr	GCARR
GCARRS:
	ex	de,hl
	add	hl,de
	ex	de,hl
	push	de
	ld	a,(hl)		;dimensions
	inc	hl
	add	a,a
	add	a,l
	ld	l,a
	jr	nc,GCARRLP
	inc	h
GCARRLP:
	pop	de
	rst	CPHLDE
	jr	nc,GCARR
	push	de
	call	GETSTR
	jr	GCARRLP

;temporary string descriptor
GCSDSC:
	ld	hl,STRDSC1
	call	GETSTR
	ld	hl,STRDSC2
	call	GETSTR
	ld	hl,STRBCK1
	call	GETSTR
	ld	hl,STRBCK2
	call	GETSTR

	ld	hl,(GCWRK)
	ld	a,h
	or	l
	ret	z


;compaction
;input:	bc=string descriptor address
;	hl=string data address to be comacted

	ld	a,(bc)
	push	bc		;
	ld	d,0
	ld	e,a
	add	hl,de
	dec	hl
	ld	de,(STRAD)
	ld	b,0
	ld	c,a
	lddr
	ld	(STRAD),de

	pop	hl		;
	inc	hl
	inc	hl
	inc	de
	ld	(hl),e
	inc	hl
	ld	(hl),d

	jp	GCLP


;input: hl=string descriptor address
;	(GCWRK)=candidate of string data address to be comacted
;output:bc=string descriptor address
;	de,(GCWRK)=string data address to be comacted
;	hl=next string descriptor address
GETSTR:
	push	hl
	ld	a,(hl)
	inc	hl
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl

	push	hl
	or	a
	jr	z,GETNOSTR	;length=0
	ld	hl,(VARAD)
	rst	CPHLDE
	jr	nc,GETNOSTR	;in program area
	ld	hl,(STRAD)
	rst	CPHLDE
	jr	c,GETNOSTR	;in work area or have been compacted
	ld	hl,(GCWRK)
	rst	CPHLDE
	jr	nc,GETNOSTR	;de <= candidate
	ld	(GCWRK),de
	pop	hl
	pop	bc
	ret

GETNOSTR:
	pop	hl
	pop	af
	ret


;print function key
;input: none
;output: none
;broken: af,bc,de,hl
PRTFKEY:
	ld	a,(SCREEN1)
	cp	2
	ret	nc

	ld	a,(VRAM)
	add	a,3
	ld	h,a

	ld	a,(CONSOL3)
	or	a
	jr	nz,FKEYNZ

	call	GETSP
	ld	l,0ffh
	ld	(hl),a
	ld	d,h
	ld	e,l
	dec	de
	ld	bc,31
	lddr

	call	GETSPA
	ld	hl,COLOR3
	xor	(hl)
	ld	hl,0-200h+COLUMNS
	add	hl,de
	ld	(hl),a
	ld	d,h
	ld	e,l
	dec	de
	ld	bc,COLUMNS-1
	lddr
	ret

FKEYNZ:
	ld	a,(SCREEN1)
	or	a
	jr	z,FKEYZ
;screen mode 2
	ld	a,(COLOR1)
	cp	9
	jr	c,FKEYC
	xor	a
FKEYC:
	dec	a
	and	03h
	inc	a
	ld	(COLOR1),a
FKEYZ:
	ld	a,(SCREEN2)
	add	a,"1"
	ld	l,0e0h
	ld	(hl),a
	inc	hl
	ld	(hl)," "
	inc	hl

	ld	b,5
	ld	de,FNCKEY
	ld	a,(FNCSHFT)
	or	a
	jr	z,FKEYLP1
	ld	de,FNCKEY+8*5

FKEYLP1:
	push	bc
	push	hl
	push	de
	ld	b,5
FKEYLP2:
	ld	a,(de)
	or	a
	jr	z,hoge4
	cp	20h
	jr	nc,FKEYNC
	ld	a," "
FKEYNC:
	ld	(hl),a
	inc	hl
	inc	de
	djnz	FKEYLP2
	jr	hoge5
hoge4:
	ld	(hl)," "
	inc	hl
	djnz	hoge4

hoge5:
	ld	(hl)," "
	pop	de
	pop	hl
	ld	bc,6
	add	hl,bc
	ex	de,hl
	ld	c,8		;bc=8
	add	hl,bc
	ex	de,hl
	pop	bc
	djnz	FKEYLP1

	ld	c,5
FKEYLP3:
	dec	hl
	push	hl
	call	CNVATT1
	ld	(hl),a
	pop	hl

	ld	b,5
FKEYLP4:
	dec	hl
	push	hl
	call	CNVATT1
	xor	01h
	ld	(hl),a
	pop	hl
	djnz	FKEYLP4
	dec	c
	jr	nz,FKEYLP3

	dec	hl
	push	hl
	call	CNVATT1
	ld	(hl),a
	pop	hl
	dec	hl
	call	CNVATT1
	xor	01h
	ld	(hl),a
	ret


;click sound
;broken:hl
CLICK:
	push	af
	ld	a,(CONSOL4)
	or	a
	jr	z,SKPCLK
	push	de
	ld	a,08h		;register8=ch.A volume
	out	(0a0h),a
	in	a,(0a2h)
	push	af		;
	ld	a,08h
	ld	e,0fh
	call	SOUND

	ld	a,01h		;register1=ch.A coarse tune
	out	(0a0h),a
	in	a,(0a2h)
	push	af		;;
	ld	a,01h
	ld	e,00h
	call	SOUND

	ld	hl,0008h
	call	WAIT
	pop	af		;;
	ld	e,a
	ld	a,01h
	call	SOUND

	pop	af		;
	ld	e,a
	ld	a,08h
	call	SOUND
	pop	de
SKPCLK:
	pop	af
	ret


;open for tape read
;broken: none
_ROPEN:ds	ROPEN-_ROPEN
	org	ROPEN

	push	af
	ld	a,1eh
	call	OPENCMT
	call	MTON
	pop	af
	ret


;get 1 character from CMT
;output: a=data, z(0=error, 1=no error)
;broken: f
_GETCMT:ds	GETCMT-_GETCMT
	org	GETCMT

GETCMTLP:
	ld	a,(STOPFLG)
	cp	03h
	jr	z,CMTSTP
	ld	a,(CMTSTAT)
	bit	4,a
	ret	nz		;read error, z-flag=0
	and	02h
	jr	z,GETCMTLP
	xor	a
	ld	(CMTSTAT),a
	ld	a,(CMTBUF)
	cp	a		;set z-flag
	ret

CMTSTP:
;	call	RCLOSE
;	ld	a,(VERIFY)
;	or	a
;	call	z,NEW
	call	CHKVRF
	jp	C_STOP


;call GETCMT, if z=0 then ?TR Error
GETCMTTR:
	call	GETCMT
	ret	z
;	call	RCLOSE
;	ld	a,(VERIFY)
;	or	a
;	call	z,NEW
	call	CHKVRF
	jp	TRERR


;check verify or not
CHKVRF:
	call	RCLOSE
	ld	a,(VERIFY)
	or	a
	call	z,NEW
	ret


;close for tape read
;broken: none
_RCLOSE:ds	RCLOSE-_RCLOSE
	org	RCLOSE

	push	af
	ld	a,1ah
	call	CLOSECMT
	xor	a
	ld	(CMTBUF),a
	pop	af
	ret


;open for tape write
;broken: none
_WOPEN:	ds	WOPEN-_WOPEN
	org	WOPEN

	push	af
	call	MTON
	call	WAIT0000
	call	CHKWSTP
	ld	a,3eh
	call	OPENCMT
	call	WAIT0000
	pop	af
	ret


;put 1 character to CMT
;input: a=data
;broken: none
_PUTCMT:ds	PUTCMT-_PUTCMT
	org	PUTCMT

	push	af
PUTCMT2:
	call	CHKWSTP
	ld	a,38h		;1200 baud
	call	OUT90H
	pop	af
	call	OUT90H
	ret

;check stop for tape write
;broken: none
CHKWSTP:
	push	af
	ld	a,(STOPFLG)
	cp	03h
	jr	z,WSTOP
	pop	af
	ret

WSTOP:
	ld	a,3ah
	call	CLOSECMT
	jp	C_STOP


;blink cload asterisk
;broken: af
BLNKAST:
	push	hl

	ld	hl,ASTSTAT
	ld	a,(hl)
	xor	"*"-" "
	ld	(hl),a

	ld	hl,(WIDTH-1)	;h=(WIDTH)
	dec	h
	ld	l,1
	call	GETAD
	ld	(hl),a

	pop	hl
	ret


;close for tape write
;broken: none
_WCLOSE:ds	WCLOSE-_WCLOSE
	org	WCLOSE

	push	af
	push	hl
	ld	hl,0380h
	call	WAIT
	ld	a,3ah
	call	CLOSECMT
	pop	hl
	pop	af
	ret


;wait
;input: hl
;broken: hl
WAIT:
	push	af
WAITLP:
	ex	(sp),hl
	ex	(sp),hl
	dec	hl
	ld	a,h
	or	l
	jr	nz,WAITLP
	pop	af
	ret


;broken: none
WAIT0000:
	push	hl
	ld	hl,0000h
	call	WAIT
	pop	hl
	ret


;open CMT subroutine
;input: a (1eh=read, 3eh=write)
;broken: none
OPENCMT:
	push	af
	call	OUT90H
	sub	05h		;read=19h, write=39h
	call	OUT90H
	xor	a
	ld	(CMTSTAT),a
	ld	(STOPFLG),a
	pop	af
	ret


;CMT relay (motor) on
;broken: af
MTON:
	push	bc
	ld	a,00001000b
	ld	b,a
	call	OUTB0H
	pop	bc
	ret


;close CMT subroutine
;input: a (1ah=read, 3ah=write)
;broken: af
CLOSECMT:
	push	bc
	call	OUT90H
	xor	a
	ld	b,00001000b
	call	OUTB0H
	pop	bc
	ret


;output port b0h
;input: a=new data, b=change bit
;broken: af
_OUTB0H:ds	OUTB0H-_OUTB0H
	org	OUTB0H

	push	hl
	ld	hl,PORTB0H
	xor	(hl)
	and	b
	xor	(hl)
	out	(0b0h),a
	ld	(hl),a
	pop	hl
	ret


;PLAY stop sub
;broken:none
_PLSTPS:ds	PLSTPS-_PLSTPS
	org	PLSTPS

	push	af
	push	hl
	push	de
	push	bc

	ld	a,07h		;ch.ABC=tone,portAB=in
	ld	e,38h
	call	SOUND
	inc	a		;register8=ch.A volume
	ld	e,00h
	call	SOUND
	inc	a		;register9=ch.B volume
	call	SOUND
	inc	a		;register10=ch.C volume
	call	SOUND

	xor	a
	ld	(PLAYST),a
	ld	(CHANNEL),a
	call	CLRPLBF

	ld	hl,PLWKA
	ld	(hl),0
	ld	d,h
	ld	e,l
	inc	de
	ld	bc,PLWKB-PLWKA-1
	ldir

	ld	hl,PLWKTBL
	ld	de,PLWKA+OCTAVE
	ld	bc,5
	ldir

	ld	hl,PLWKA
	ld	de,PLWKB
	ld	bc,PLWKC-PLWKA
	ldir

	pop	bc
	pop	de
	pop	hl
	pop	af
	ret


PLWKTBL:
	db	4		;O-value
	db	4		;L-value
	db	120		;T-value
	db	8		;V-value
	db	255		;M-value(low)


;stop and initialize for PLAY command
;broken:none
_PLSTOP:ds	PLSTOP-_PLSTOP
	org	PLSTOP
	di
	call	PLSTPS
	ei
	ret


;input: a=register, e=value
;broken: none
_SOUND:	ds	SOUND-_SOUND
	org	SOUND

	push	af
	out	(0a0h),a
	ld	a,e
	out	(0a1h),a
	pop	af
	ret


;convert play data
;input:	a=string length, hl=string address, ix=play work
;broken:af,bc,de,hl
CNVPLAY:
	ld	(PLAYLEN),a
	ld	(PLAYSTR),hl

CNVPLLP:
;check buffer space
	ld	a,(CHANNEL)
	ld	l,a
	add	a,a		;*2
	add	a,l		;*3
	add	a,a		;*6
	ld	l,BUFAIN	;(lower 1 byte)

	add	a,l		;(no increase)
	ld	l,a
	ld	h,BUFAIN/256	;(upper 1 byte)

	ld	d,(hl)
	inc	d		;in+1
	inc	hl
	ld	a,(hl)		;out
	sub	d
	jr	nc,CHKBFNC

	inc	hl
	inc	hl		;size
	inc	a
	add	a,(hl)
CHKBFNC:
	cp	8
	ret	c

	call	PLAYGETC
	ret	z
	call	PLAYINC
	call	TOUPPER
	call	PLAYCMD
	jr	CNVPLLP
	ret


PLAYCMD:
	sub	"A"
	cp	"G"-"A"+1
	jp	c,TONE
	ld	hl,PLAYTBL
	ld	b,8
PLCMDLP:
	cp	(hl)
	inc	hl
	jp	z,JPTBLNC
	inc	hl
	inc	hl
	djnz	PLCMDLP
	jp	FCERR


PLAYTBL:
	db	"V"-"A"
	dw	PLAYV
	db	"M"-"A"
	dw	PLAYM
	db	"S"-"A"
	dw	PLAYS
	db	"L"-"A"
	dw	PLAYL
	db	"T"-"A"
	dw	PLAYT
	db	"O"-"A"
	dw	PLAYO
	db	"R"-"A"
	dw	PLAYR
	db	"N"-"A"
	dw	PLAYN


PLAYV:
	call	GETNUM1
	jr	c,PLAYVNUM
	ld	a,8
PLAYVNUM:
	cp	16
	jp	nc,FCERR
PUTV:
	ld	(ix+VOLUME),a
	ret

PLAYM:
	call	GETNUM2
	jr	c,PLAYMNUM
	ld	hl,255
PLAYMNUM:
	ld	(ix+PERIOD),l
	ld	(ix+PERIOD+1),h
	ret

PLAYS:
	call	GETNUM1
	cp	10h
	jp	nc,FCERR
	add	a,10h
	jr	PUTV

PLAYL:
	call	GETNUM1
	jr	c,PLAYLNUM
	ld	a,4
PLAYLNUM:
	dec	a
	cp	64
	jp	nc,FCERR
	inc	a
	ld	(ix+LENGTH),a
	ret

PLAYT:
	call	GETNUM1
	jr	c,PLAYTNUM
	ld	a,120
PLAYTNUM:
	cp	32
	jp	c,FCERR
	ld	(ix+TEMPO),a
	ret

PLAYO:
	call	GETNUM1
	jr	c,PLAYONUM
	ld	a,4
PLAYONUM:
	dec	a
	cp	8
	jp	nc,FCERR
	inc	a
	ld	(ix+OCTAVE),a
	ret


;joy stick
;input: a=1or2
;output:a (0-0-trigger2-trigger1-right-left-down-up)
;broken:f
_JOYSTK:ds	JOYSTK-_JOYSTK
	org	JOYSTK

	push	de
	rrca
	scf
	rra
	ld	e,a		;c0h or 80h

	ld	a,07h		;register7=portABin-out,noise,tone
	out	(0a0h),a
	in	a,(0a2h)
	ld	d,a		;
	jr	SKPPATCH2


;1cb4h: to be patched by PC6001V/VX/VW
;1cb5h: to be patched by PC6001V/VX
_PATCH2:ds	PATCH2-_PATCH2
	org	PATCH2
	db	00h
	db	00h


SKPPATCH2:
	and	10111111b	;parallel port A=in
	or	10000000b	;parallel port B=out
	out	(0a1h),a

	ld	a,0fh		;register15=parallel port B
	call	SOUND		;c0h or 80h

	ld	a,0eh		;register14=parallel port A
	out	(0a0h),a
	in	a,(0a2h)
	cpl
	ld	e,a		;;

	ld	a,07h
	out	(0a0h),a
	ld	a,d		;
	out	(0a1h),a

	ld	a,e		;;
	pop	de
	ret
	

TONETBL:
	db	18,22,0,4,8,10,14

SCALE:
;		c/b+	c+/d-	d	d+/e-	e/f-	f/e+
	dw	1dd0h,	1c24h,	1a8fh,	1912h,	17aah,	1656h
;		f+/g-	g	g+/a-	a	a+/b-	b/c-
	dw	1515h,	13e6h,	12c8h,	11bah,	10bbh,	0fcbh


PLAYN:
	call	GETNUM1
	jp	nc,FCERR
	cp	97
	jp	nc,FCERR
	or	a
	jr	z,PLAYN0

	ld	b,0
PLAYNLP:
	inc	b
	sub	12
	jr	nc,PLAYNLP
	add	a,a
	ld	d,0ffh
	ld	e,a
	ld	hl,SCALE+24
	add	hl,de
	ld	a,(hl)
	inc	hl
	ld	d,(hl)
	ld	e,a
	jr	OCTVLP

PLAYR:
	xor	a
	push	af		;volume
	push	de		;(tune)
	call	GETNUM1
	jr	nc,PLAYRNC
	or	a
	jp	z,FCERR
	jr	CHKLEN
PLAYRNC:
	ld	a,4
	jr	CHKLEN

;accidental mark
PLAYPLS:
	call	PLAYINC
	inc	e
	inc	e
	ld	a,e
	sub	24
	jr	c,NOACC
	ld	e,a		;=0
	jr	NOACC

PLAYMNS:
	call	PLAYINC
	dec	e
	dec	e
	jp	P,NOACC
	ld	e,22
	jr	NOACC

PLAYN0:
	xor	a
	push	af		;volume
	push	de		;(tune)

;for compatibility with PC-6001
	ld	a,80
	jr	CALCLEN

TONE:
	ld	hl,TONETBL
	ld	d,0
	ld	e,a
	add	hl,de
	ld	e,(hl)
	call	PLAYGETC
	jr	z,NOACC
	cp	"+"
	jr	z,PLAYPLS
	cp	"#"
	jr	z,PLAYPLS
	cp	"-"
	jr	z,PLAYMNS
	cp	"="
	jp	z,FCERR

NOACC:
	ld	hl,SCALE
	ld	d,0
	add	hl,de

	ld	a,(ix+OCTAVE)
	ld	b,a
	ld	a,(hl)
	inc	hl
	ld	d,(hl)
OCTVLP:
	srl	d
	rra
	djnz	OCTVLP
	ld	e,a
	ld	a,(ix+VOLUME)

PUSHVOL:
	push	af		;volume
	push	de		;tune
	call	GETNUM1
	or	a
	jr	nz,CHKLEN
	ld	a,(ix+LENGTH)
CHKLEN:
	cp	65
	jp	nc,FCERR

CALCLEN:
;60[s/min]/T[/min]/(L/4)/(2/975)[s]=117000/T/L
	push	af		;L-value
	ld	hl,0e484h	;117000/2
	ld	a,(ix+TEMPO)	;T-value
	call	DIVI
	ex	de,hl
	pop	af		;L-value
	call	DIVI
	ld	h,d
	ld	l,e
	push	de		;117000/T/L/2
	push	hl

;dotted note
DOTLP:
	call	PLAYGETC
	cp	"."
	jr	nz,NOTDOT
	call	PLAYINC
	pop	hl
	add	hl,de
	srl	d
	rr	e
	push	hl
	jr	DOTLP
NOTDOT:
	pop	hl
	pop	de
	add	hl,de
	ex	de,hl

	di
	ld	a,d		;length
	call	PUTPLBF
	ld	a,e
	call	PUTPLBF
	pop	de		;tune
	ld	a,d
	call	PUTPLBF
	ld	a,e
	call	PUTPLBF
	pop	af		;volume
	call	PUTPLBF
	cp	10h
	jr	c,PLCMDEND
	ld	a,(ix+PERIOD)	;period
	call	PUTPLBF
	ld	a,(ix+PERIOD+1)
	call	PUTPLBF
PLCMDEND:
	ei
	ret


;get a character from PLAY string
;output:a,z(1=no character)
;broken:f,hl
PLAYGETC:
	ld	a,(PLAYLEN)
	or	a
	ret	z		;a=0 if no character
	ld	hl,(PLAYSTR)
	ld	a,(hl)
	cp	" "
	ret	nz
	call	PLAYINC
	jr	PLAYGETC


;increment (PLAYSTR) and decrement (PLAYLEN)
;broken:f,hl
PLAYINC:
	ld	hl,PLAYLEN
	dec	(hl)
	ld	hl,(PLAYSTR)
	inc	hl
	ld	(PLAYSTR),hl
	ret


;CLS command
;broken: af,de
_CLS:	ds	CLS-_CLS
C_CLS:
	org	CLS

	push	hl
	push	bc
	ld	hl,(CONSOL1)	;l=(CONSOL1)
	ld	a,(LASTLIN)
	sub	l
	call	CLSMAIN
	pop	bc
	pop	hl
	ret


;clear from first line to last line
;input: l=first line+1, a=last line-first line
CLSMAIN:
	ld	h,1
	call	GETAD
	push	hl		;character VRAM address
	ex	de,hl
	dec	d
	dec	d		;attribute VRAM address

	ld	hl,0000h
	ld	(GRPX1),hl
	ld	(GRPY1),hl

	inc	a		;(LASTLIN)-(CONSOL1)+1
	add	a,a		;*2
	add	a,a		;*4
	add	a,a		;*8
	ld	l,a
	add	hl,hl		;*16
	add	hl,hl		;*32
	ld	b,h
	ld	c,l
	dec	bc
	push	bc		;VRAM clear size

	ld	a,(SCREEN1)
	or	a
	jr	z,CLS1
	cp	2
	jr	c,CLS2

CLS34:
	inc	bc
	ld	h,b
	ld	l,c
	add	hl,hl		;*2
	add	hl,bc		;*3
	add	hl,hl		;*6
	add	hl,hl		;*12
	dec	hl
	pop	bc		;clear size
	ld	b,h
	ld	c,l
	pop	hl		;character VRAM address
	call	GETAD34
	push	hl		;dot pattern VRAM address
	push	bc		;clear size

	ld	h,a		;
	ld	a,(COLOR2)
	call	SETATT
	push	af
	ld	a,h		;
	sub	2
	jr	z,CLS34Z
	ld	a,50h	
CLS34Z:
	add	a,8ch		;screen mode 3=8ch, screen mode 4=dch
	ld	de,(VRAM-1)	;d=(VRAM)
	ld	e,0
	ld	bc,1ffh
	jr	CLSXOR

CLS1:
	ld	a," "
	push	af
	ld	hl,COLOR1
	ld	a,(hl)
	or	a
	jr	nz,CLS1NZ
   	inc	a
CLS1NZ:
	cp	5
	jr	c,CLS1C
	ld	a,4
CLS1C:
	ld	(hl),a
	add	a,1fh
;	jr	CLSXOR

CLSXOR:
	ld	hl,COLOR3
	xor	(hl)

CLSATT:
	ld	h,d
	ld	l,e
	inc	de
	ld	(hl),a
	ldir

CLSCH:
	pop	af		;character or bit pattern
	pop	bc		;;
	pop	hl		;
	ld	(hl),a
	ld	d,h
	ld	e,l
	inc	de
	ldir

	ld	hl,(CONSOL1)	;l=(CONSOL1)
	ld	h,1
	call	SETCSR

	ld	a,(CONSOL3)
	or	a
	call	nz,PRTFKEY
	ret

CLS2:
	call	GETSP
	push	af
	call	GETSPA2
	jr	CLSATT


;play routine
;input: hl=data address, (z=0)
;output:hl=next address
;broken:af,bc,de
_PLAY:	ds	PLAY-_PLAY
	org	PLAY

	push	ix
	ex	de,hl
	ld	hl,(PROGAD)
	push	hl

	call	STRARG
	jp	nz,MOERR
	ld	(PLWKA+PLLEN),a
	inc	hl
	inc	hl
	ld	a,(hl)
	ld	(PLWKA+PLADR),a
	inc	hl
	ld	a,(hl)
	ld	(PLWKA+PLADR+1),a
	call	CHKCLN		;a=(de)
	jr	z,SKPCHBC
	cp	","
	jp	nz,SNERR
	inc	de

	call	STRARG
	jp	nz,MOERR
	ld	(PLWKB+PLLEN),a
	inc	hl
	inc	hl
	ld	a,(hl)
	ld	(PLWKB+PLADR),a
	inc	hl
	ld	a,(hl)
	ld	(PLWKB+PLADR+1),a
	call	CHKCLN
	jr	z,SKPCHC
	cp	","
	jp	nz,SNERR
	inc	de

	call	STRARG
	jp	nz,MOERR
	jr	PLAYMAIN

SKPCHBC:
	xor	a
	ld	(PLWKB+PLLEN),a
SKPCHC:
	xor	a
PLAYMAIN:
	ld	(PLWKC+PLLEN),a
	inc	hl
	inc	hl
	ld	a,(hl)
	ld	(PLWKC+PLADR),a
	inc	hl
	ld	a,(hl)
	ld	(PLWKC+PLADR+1),a

PLAYLP1:
	ld	hl,STOPFLG
	ld	a,(hl)
	cp	03h
	call	z,PLSTOP
	jr	z,PLAYEND

PLAYNZ:
	ld	ix,PLWKC
	ld	b,3
PLAYLP2:
	push	bc
	ld	a,b
	dec	a
	ld	(CHANNEL),a
	ld	a,(ix+PLLEN)
	ld	l,(ix+PLADR)
	ld	h,(ix+PLADR+1)
	call	CNVPLAY
	ld	a,(PLAYLEN)
	ld	(ix+PLLEN),a
	ld	hl,(PLAYSTR)
	ld	(ix+PLADR),l
	ld	(ix+PLADR+1),h

	pop	bc
	ld	de,PLWKB-PLWKC
	add	ix,de
	djnz	PLAYLP2

	ld	a,0ffh
	ld	(CHANNEL),a

	ld	a,(PLWKA+PLLEN)
	ld	hl,PLWKB+PLLEN
	or	(hl)
	ld	hl,PLWKC+PLLEN
	or	(hl)
	jr	nz,PLAYLP1

	ld	b,3
PLAYLP3:
	ld	a,b
	dec	a
	ld	(CHANNEL),a
	ld	a,0ffh
	call	PUTPLBF
	djnz	PLAYLP3

;	ld	a,0ffh
	ld	(CHANNEL),a

PLAYEND:
	pop	de
	ld	hl,(PROGAD)
	ld	(PROGAD),de
	pop	ix
	ret


;clear key buffer pointer
;broken:hl
CLRPLBF:
	ld	hl,0
	ld	(BUFAIN),hl	;clear BFIN and BFOUT for ch.A
	ld	(BUFBIN),hl	;clear BFIN and BFOUT for ch.B
	ld	(BUFCIN),hl	;clear BFIN and BFOUT for ch.C
	ret


;put into PLAY command buffer
;input:	a
;broken:f,hl
PUTPLBF:
	ld	h,a
	ld	a,(CHANNEL)
	ld	l,a
	add	a,a		;a*2
	add	a,l		;a*3
	add	a,a		;a*6
	ld	l,BUFAIN	;(lower 1 byte)
	add	a,l		;(no increase)
	ld	l,a
	ld	a,h
	ld	h,BUFAIN/256	;(upper 1 byte)
	call	PUTBF
	ret


GETNUM1:
;output:a,c-flag(1=number)
;broken:f,bc,de
	call	GETNUM2
	jr	nc,GETNUM1NC
	ld	a,h
	or	a
	jp	nz,FCERR
	scf
GETNUM1NC:
	ld	a,l
	ret


GETNUM2:
;output:hl,c-flag(1=number)
;broken:f,bc,de
	call	PLAYGETC
	ld	hl,0
	ret	z		;c-flag=0
	cp	"="
	jr	z,GETNUMEQ
	cp	";"
	jr	z,GETNUMSEMI
	sub	"0"
	cp	"9"-"0"+1
	ret	nc		;c-flag=0
	ld	de,(PLAYSTR)
	push	de
	ld	a,(PLAYLEN)
	ld	b,a
	call	ATOI2
	ex	de,hl
	ld	(PLAYSTR),hl
	pop	bc		;
	or	a
	sbc	hl,bc
	ld	a,(PLAYLEN)
	sub	l
	ld	(PLAYLEN),a
	call	PLAYGETC
	jr	z,GETNUMZ
	cp	";"
	call	z,PLAYINC
GETNUMZ:
	ex	de,hl
	scf			;c-flag=1
	ret

GETNUMSEMI:
	call	PLAYINC
	ld	hl,0
	or	a		;c-flag=0
	ret

GETNUMEQ:
	call	PLAYINC
	call	PLAYGETC
	jp	z,FCERR
	call	PLAYINC
	call	TOUPPER
	ld	b,a
	sub	"A"
	cp	"Z"-"A"+1
	jp	nc,FCERR
	call	GETNAMEPLAY
	call	PLAYGETC
	cp	";"
	jp	nz,FCERR
	bit	7,c
	jp	nz,TMERR
	call	PLAYINC
	call	SRCHVAR
	jr	nc,GETNUMEQNC
	ld	hl,ZERO
GETNUMEQNC:
	call	SETF1
	call	FTOI
	scf
	ret


;FOR command
C_FOR:
	pop	hl		;cancel return address
	ex	de,hl
	call	CHKVAR
	ld	a,(hl)
	cp	"("
	jp	z,SNERR
	call	GETVAR
	bit	7,c
	jp	nz,TMERR
	push	bc		;variable name
	ld	de,(PROGAD)
	call	VARIN
	ld	a,(hl)
	inc	hl
	cp	TO
	jp	nz,SNERR
	ex	de,hl
	call	ARG
	ld	a,(ARGTYP)
	or	a
	jp	nz,TMERR
	ex	de,hl
	pop	bc		;variable name
	call	PUSHF1		;TO value
	push	bc		;variable name

	ld	hl,(PROGAD)
	ld	a,(hl)
	inc	hl
	or	a
	jr	z,STEP1
	cp	":"
	jr	z,STEP1
	cp	STEP
	jp	nz,SNERR
	ex	de,hl
	call	ARG
	ld	a,(ARGTYP)
	or	a
	jp	nz,TMERR
	jr	PSHSTEP
STEP1:
	dec	hl
	ld	(PROGAD),hl
	call	SETPLS1

PSHSTEP:
	call	CHKFRE

	pop	bc		;variable name
	call	POPF2		;TO value
	ld	hl,(PROGAD)
	push	hl		;program address
	ld	hl,(LINENUM)
	push	hl		;line number
	call	PUSHF2		;TO value
	call	PUSHF1		;STEP value
	push	bc		;variable name
	ld	a,FOR		;identifier
	push	af
	inc	sp
	jp	INTPEND


;NEXT command
C_NEXT:
	pop	hl		;cancel return address
NEXTLP:
	call	CHKCLN
	jr	z,NEXTNOV
	ex	de,hl
	call	CHKVAR
	bit	7,c
	jp	nz,TMERR
	ld	(PROGAD),hl
	ld	h,b
	ld	l,c
NEXTVLP:
	dec	sp
	pop	af		;identifier
	cp	FOR
	jp	nz,NFERR
	pop	de		;variable name

	ld	a,h
	or	l
	jr	z,NEXTOK
	rst	CPHLDE
	jr	z,NEXTOK

	ex	de,hl
	call	POPF1		;STEP value
	call	POPF1		;TO value
	ex	de,hl
	pop	af		;line number
	pop	af		;program address
	jr	NEXTVLP

NEXTNOV:
	ld	(PROGAD),de
	ld	hl,0000h
	jr	NEXTVLP

NEXTOK:
	call	POPF1		;STEP value
	call	PUSHF1		;STEP value

	ld	b,d
	ld	c,e
	push	bc		;variable name
	call	SRCHVAR
	push	hl		;variable address

	call	SETF2
	call	ADDF
	pop	de		;variable address
	ld	hl,FAC1
	ld	bc,5
	ldir

	pop	bc		;variable name

	call	POPF2		;STEP value
	call	POPF1		;TO value
	call	PUSHF1		;TO value
	call	PUSHF2		;STEP value

	push	bc		;variable name

	call	SRCHVAR
	ld	a,(FAC2+4)
	or	a
	jr	z,STEP0		;if STEP value = 0
	ld	a,(FAC2+3)
	rlca
	call	SETF2		;no change for c-flag
	call	c,EXFAC		;if STEP value < 0
	call	CMPF
	jr	c,NEXTEND	;for-next loop end

NEXTCONT:
	ld	hl,000eh	;variable name(2)+STEP(6)+TO(6)
	add	hl,sp
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	(LINENUM),de
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	(PROGAD),de
	ld	a,FOR
	push	af		;identifier
	inc	sp
	jp	INTPEND

STEP0:
	call	SETF2
	call	CMPF
	jr	nz,NEXTCONT

NEXTEND:
	pop	bc		;variable name
	call	POPF2		;STEP value
	call	POPF1		;TO value
	pop	hl		;line number
	pop	hl		;program address
	ld	hl,(PROGAD)
	ld	a,(hl)
	inc	hl
	cp	","
	ex	de,hl
	jp	z,NEXTLP
	jp	INTPEND


;DATA command
C_DATA:
	ld	b,0
DATALP:
	ld	a,(de)
	or	a
	jr	z,DATAEND
	inc	de
	cp	":"
	jr	z,DATACO
	cp	22h		;double quotation mark
	jr	nz,DATALP
	ld	a,b
	cpl
	ld	b,a
	jr	DATALP
DATACO:
	ld	a,b
	or	a
	jr	nz,DATALP
	dec	de
DATAEND:
	ld	(PROGAD),de
	ret


;INPUT command
C_INPT:
	ld	hl,(LINENUM)
	ld	a,h
	and	l
	inc	a
	jp	z,IDERR

	call	SKIPSP
	cp	"#"
	ld	a,0
	call	z,GETDEV
	ld	(DEVICE),a
	or	a
	call	z,CHGTXT

	push	de
	ld	a,(de)
	cp	22h		;double quotation mark
	jr	nz,INPTMAIN

	ld	a,(DEVICE)
	or	a
	jp	nz,SNERR
PROMPT:
	inc	de
	ld	a,(de)
	or	a
	jr	z,PROMPTEND
	cp	22h		;double quotation mark
	jr	z,PROMPTEND
	call	PUTC
	jr	PROMPT
PROMPTEND:
	inc	de
	call	SKIPSP
	cp	";"
	jp	nz,SNERR
	inc	de
	ld	(PROGAD),de

INPTMAIN:
	ld	a,(DEVICE)
	or	a
	jp	nz,INPTEXT

	ld	hl,INPUTQ
	call	PUTS
	call	INPT1
	jp	c,C_STOP

;analyze input buffer
INPTANA:
	ld	de,INPBUF
INPTLP:
	ld	hl,(PROGAD)
	call	CHKVAR
	bit	7,c
	jr	nz,INPTSTR

INPTNUM:
	push	de		;input buffer
	call	GETVAR
	pop	de		;input buffer
	push	hl		;variable address

	ld	a,255
	call	ATOF
	pop	hl		;variable address
	ld	a,(INPBUF)
	or	a
	jr	z,INPTNEXT
	push	de		;input buffer
	ld	a,(de)
	ex	de,hl
	ld	hl,FAC1
	ld	bc,5
	ldir
	pop	de		;input buffer
	or	a
	jr	z,INPTNEXT
	cp	","
	jr	z,INPTNEXT
	ld	a,(DEVICE)
	or	a
	jp	nz,FDERR
	ld	hl,REDO
	call	PUTS
	pop	hl		;program address
	ld	(PROGAD),hl
	push	hl		;program address
	jr	INPTMAIN

INPTNEXT:
	ld	hl,(PROGAD)
	ld	a,(hl)
	cp	","
	jr	nz,INPTEND
	inc	hl
	ld	(PROGAD),hl

	ld	a,(INPBUF)
	or	a
	jr	z,INPTLP
	ld	a,(de)
	inc	de
	cp	","
	jr	z,INPTLP
	ld	a,(DEVICE)
	or	a
	jp	nz,ODERR	
	ld	a,"?"
	call	PUTC
	jr	INPTMAIN

INPTEND:
	pop	hl		;cancel program address
	ld	a,(de)
	cp	","
	ret	nz
	ld	hl,EXTRA
	call	PUTS
	ret

INPTSTR:
	push	de		;input buffer
	call	GETVAR
	pop	de		;input buffer

	ld	c,0		;double quotation mark count
	ld	a,(de)
	cp	22h		;double quotation mark
	jr	nz,INPTSNZ
	inc	de
	inc	c
INPTSNZ:
	ld	(STRDSC1+2),de
	ld	b,0

INPTSLP:
	ld	a,c
	or	a
	ld	a,(de)
	jr	nz,INPTCHKDQ
	cp	","
	jr	z,INPTSZ
INPTCHKZ:
	or	a
	jr	z,INPTSZ
	inc	de
	inc	b
	jr	INPTSLP

INPTCHKDQ:
	cp	22h		;double quotation mark
	jr	nz,INPTCHKZ
	dec	c
	inc	de
	jr	INPTSLP

INPTSZ:
	push	de		;input buffer
	ld	a,b
	ld	(STRDSC1),a
	xor	a
	ld	(STRDSC2),a
	push	hl		;variable address
	call	ADDSTR
	pop	de		;variable address
	ld	hl,STRDSC1
	ld	bc,4
	ldir
	pop	de		;input buffer
	jr	INPTNEXT


INPUTQ:
	db	"? ",00h
EXTRA:
	db	"?Extra ignored",0dh,0ah,00h

REDO:
	db	"?Redo from start",0dh,0ah,00h


;one line input
;output: hl=INPBUF-1, c-flag(1=stop)
;broken: af,bc,de,hl
INPT1:
	ld	hl,INPBUF
INPT1LP1:
	call	CSRON
INPT1LP2:
	ld	a,(STOPFLG)
	cp	03h
	jp	z,INPT1STOP
	ld	a,(CONSOL3)
	or	a
	call	nz,CHKSHFT
	call	GETC
	jr	z,INPT1LP2
	push	hl
	call	CSROFF
	pop	hl

	cp	0feh
	jr	z,INPT1PAGE
	ld	b,a
	call	CHGTXT
	ld	a,b

	cp	0dh		;RETURN
	jr	z,INPT1END

;temporary: control code
	cp	08h
	jr	z,INPT1DEL
	cp	14h
	jr	z,INPT1PUTC
	cp	20h
	jr	c,INPT1LP1
;

INPT1PUTC:
	call	PUTC
	ld	(hl),a
	ld	de,INPBUF+71
	rst	CPHLDE
	jr	nc,INPT1LP1
	inc	hl
	jr	INPT1LP1

INPT1END:
	ld	(hl),0
	call	PRTNL
	ld	hl,INPBUF-1
	ret

INPT1STOP:
	call	PLSTOP
	call	CSROFF
	call	PRTNL
	ld	hl,INPBUF
	xor	a
	ld	(STOPFLG),a
	ld	(hl),a
	dec	hl
	scf
	ret

INPT1DEL:
	ld	de,INPBUF
	rst	CPHLDE
	jr	z,INPT1LP1
	ex	de,hl
	ld	hl,DELSTR
	call	PUTS
	ex	de,hl
	dec	hl
	jr	INPT1LP1

INPT1PAGE:
	ld	a,(PAGES)
	ld	b,a
	ld	a,(SCREEN2)
	inc	a
	cp	b
	jr	c,INPT1PAGEC
	xor	a
INPT1PAGEC:
	call	CHGACT
	call	CHGDSP
	jp	INPT1LP1

DELSTR:
	db	1dh," ",1dh,00h


;check shift key for function key display
CHKSHFT:
	push	hl
	push	de
	push	bc

	ld	hl,0180h	;wait for PC-6001VW
	call	WAIT

	call	STICK
	and	01h
	ld	hl,FNCSHFT
	cp	(hl)
	ld	(hl),a
	call	nz,PRTFKEY
	pop	bc
	pop	de
	pop	hl
	ret


;input by external device
;input:	a=(DEVICE), hl=INPBUF-1
;output:
;broken:
INPTEXT:
	cp	2
	jr	z,INPT232
	rlca
	jp	nc,FCERR

	call	INPOPN
	ld	hl,INPBUF
	ld	b,71
INPTCMTLP:
	call	GETCMTTR
	cp	0dh
	jr	z,INPTCMTEND
	ld	(hl),a
	inc	hl
	djnz	INPTCMTLP
INPTCMTEND:
	ld	(hl),0
	call	RCLOSE
	ld	hl,INPBUF-1
	jp	INPTANA


INPT232:
	ld	de,INPBUF
	ld	b,71
INPT232LP:
	call	CHKSTOP
	call	GETRSBF
	cp	0dh
	jr	z,INPT232END
	ld	(de),a
	inc	de
	djnz	INPT232LP
INPT232END:
	xor	a
	ld	(de),a
	ld	hl,INPBUF-1
	jp	INPTANA


;DIM command
C_DIM:
	ex	de,hl
DIMCHKV:
	call	CHKVAR

	push	hl		;program address
	call	SRCHARR
	jp	nc,DDERR
	call	SETARNM
	pop	de		;program address
	push	hl		;array address
	ld	a,c
	ld	bc,4
	rlca
	jr	c,DIMSTR
	inc	c		;numeric:bc=5, string:bc=4
DIMSTR:
	push	hl		;array address
	push	bc		;element bytes
	ld	a,(de)
	cp	"("
	jp	nz,DIM10

	inc	de
	ld	c,0
DIMLP1:
	push	bc		;dimensions
	call	INT2ARG
	pop	bc		;dimensions
	inc	c
	jp	z,OMERR		;over 255 dimensions
	inc	hl		;+1
	pop	de		;element bytes
	ex	(sp),hl		;push size, pop array address
	push	hl		;array address
	push	de		;element bytes
	ld	de,(PROGAD)
	ld	a,(de)
	inc	de
	cp	","
	jr	z,DIMLP1
	cp	")"
	jp	nz,SNERR

CALLMKA:
	call	MAKEARR
	ld	hl,(PROGAD)
	ld	a,(hl)
	inc	hl
	cp	","
	jp	z,DIMCHKV
	ret

DIM10:
	pop	bc		;element bytes
	ld	hl,11
	ex	(sp),hl		;push size, pop array address
	push	hl		;array address
	push	bc		;element bytes
	ld	c,1		;dimensions=1
	jr	CALLMKA


;READ command
C_READ:
	ex	de,hl
C_READ2:
	call	CHKVAR
	call	GETVAR
	push	bc		;variable name
	push	hl		;variable address

	ld	hl,(DATAAD)
	ld	de,(DATALN)
	ld	a,(hl)
	cp	","
	jr	z,READDATA
	cp	":"
	jr	z,READLP3
	or	a
	jp	nz,SNERR

READLP1:
	inc	hl
READLP2:
	ld	a,(hl)
	inc	hl
	or	(hl)
	jp	z,ODERR
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	c,0		;double quation mark counter

READLP3:
	inc	hl
	ld	a,(hl)
	or	a
	jr	z,READLP1
	cp	DATA
	jr	z,READDATA
	cp	REM
	jr	z,READREM
	cp	22h		;double quotation mark
	jr	z,READDQ
	cp	":"
	jr	z,READLP3
	cp	" "
	jr	z,READLP3

READLP4:
	inc	hl
	ld	a,(hl)
	or	a
	jr	z,READLP1
	bit	0,c
	jr	nz,READDQ
	cp	":"
	jr	z,READLP3
READDQ:
	cp	22h		;double quotation mark
	jr	nz,READLP4
	inc	c
	jr	READLP4

READREM:
	xor	a
	ld	b,a
	ld	c,a
	cpir
	jr	READLP2

READDATA:
	ex	de,hl
	ld	(DATALN),hl
RDDTLP:
	inc	de		;data address
	ld	a,(de)
	cp	" "
	jr	z,RDDTLP

	pop	hl		;variable address
	pop	bc		;variable name
	bit	7,c
	jr	nz,READSTR

	cp	","
	jr	z,READNUM
	cp	"."
	jr	z,READNUM
	cp	"&"
	jr	z,READNUM
	cp	"-"
	jr	z,READNUM
	cp	"+"
	jr	z,READNUM
	sub	"0"
	cp	"9"-"0"+1
	jr	nc,RDERR
READNUM:
	push	hl		;variable address
	ld	a,255
	call	ATOF
	pop	hl		;variable address
	push	de		;data address
	ex	de,hl
	ld	hl,FAC1
	ld	bc,5
	ldir
	pop	de		;data address
	jr	READEND

READSTR:
	ld	bc,0		;b=double quotation mark?, c=length
	cp	22h		;double quotation mark
	jr	nz,RDSNDQ
	inc	b
	inc	de
RDSNDQ:
	inc	hl
	inc	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	dec	hl
	dec	hl
	dec	hl

RDSLP2:
	ld	a,(de)
	or	a
	jr	z,RDSEND
	bit	0,b
	jr	z,RDSCHK
	cp	22h		;double quotation mark
	jr	nz,RDSNEXT
	inc	de
	ld	a,(de)
	or	a
	jr	z,RDSEND
	cp	","
	jr	z,RDSEND

RDERR:
	ld	hl,(DATALN)
	ld	(LINENUM),hl
	jp	SNERR

RDSCHK:
	cp	","
	jr	z,RDSEND
	cp	":"
	jr	z,RDSEND

RDSNEXT:
	inc	de
	inc	c
	jp	z,LSERR
	jr	RDSLP2

RDSEND:
	ld	(hl),c

READEND:
	ld	(DATAAD),de
	ld	hl,(PROGAD)
	ld	a,(hl)
	cp	","
	ret	nz
	inc	hl
	jp	C_READ2


;LET command
C_LET:
	pop	hl		;cancel return address
	ex	de,hl
	jp	VAR


;GOTO command
C_GOTO:
	call	GETLN
	call	SRCHLN
	jp	nc,ULERR
	ld	(PROGAD),bc
	ret


;run command
C_RUN:
	pop	hl		;cancel
	call	CHKSTOP
	call	CLEREND
	call	CHKCLN
	ld	hl,(STARTAD)
	jr	z,RUNLP
	call	GETLN
	call	SRCHLN
	jp	nc,ULERR
	ld	h,b
	ld	l,c
	inc	hl

RUNLP:
	ld	a,(hl)
	inc	hl
	or	(hl)
	jp	z,EDIT
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	(LINENUM),de
	inc	hl

INTPRT:
	ld	a,(hl)
	inc	hl
	ld	(PROGAD),hl
	or	a
	jr	z,RUNLP
	cp	":"
	jr	z,INTPRT
	cp	" "
	jr	z,INTPRT
	cp	80h
	jr	nc,COMMAND
	dec	hl

VAR:
	call	CHKVAR
	call	GETVAR
	ld	de,(PROGAD)
	call	VARIN
	jr	INTPEND


COMMAND:
	cp	0abh		;aah=NEW
	jp	nc,SNERR
	ex	de,hl		;de=program address
	ld	hl,CMDTBL
	call	JPTBL
;	jr	INTPEND

INTPEND:
	ld	hl,(PROGAD)
INTPELP:
	ex	de,hl
	call	CHKCLN
	jp	nz,SNERR
	ex	de,hl
	call	CHKSTOP
	jr	INTPRT


;skip CMT data
;input:	d=count, e=data
;broken:af,b
_CMTSKP:ds	CMTSKP-_CMTSKP
	org	CMTSKP

	ld	b,d
CMTSKPLP:
	call	GETCMTTR
	cp	e
	jr	nz,CMTSKP
	djnz	CMTSKPLP
	ret


;input:	de=program address(#)
;output:a, de,(PROGAD)=next address
;broken:f,bc,hl
GETDEV:
	inc	de
	call	NUMARGMO
	push	de
	call	FTOI2
	pop	de
	ld	a,h
	or	l
	jr	z,GETDEVZ	;#0
	bit	7,h
	jp	z,FCERR
	ld	a,l
	neg
	cp	4
	jp	nc,FCERR
	cp	2
	jr	z,GETDEVZ	;#-2
	sub	2		;#-3 -> 1
	jr	nc,GETDEVZ
	ld	a,80h		;#-1 -> 80h
GETDEVZ:
	push	af
	call	CHKCMM
	jp	nz,SNERR
	ld	(PROGAD),de
	pop	af
	ret


;CMT open for INPUT #-1
;broken:af,b,de
_INPOPN:ds	INPOPN-_INPOPN
	org	INPOPN

	ld	a,0ffh
	ld	(VERIFY),a
	call	ROPEN
	ld	de,069ch
	call	CMTSKP
	ret


;IF command
C_IF:
	call	NUMARGMO
	ld	a,(FAC1+4)
	or	a
	jp	z,C_REM

	ld	a,(de)
	ld	b,a
	inc	de
	cp	THEN
	jr	z,IFOK
	cp	GOTO
	jp	nz,SNERR
IFOK:
	call	CHKCLN
	jr	z,IFEND
	sub	"0"
	cp	"9"-"0"+1
	jp	c,C_GOTO
	ld	a,b
	cp	THEN
	jp	nz,SNERR
IFEND:
	ex	de,hl
	ld	(PROGAD),hl
	pop	af		;cancel return address
	jp	INTPRT		;skip colon check


;REM command
C_REM:
	ex	de,hl
	xor	a
	ld	b,a
	ld	c,a
	cpir
	dec	hl
	ld	(PROGAD),hl
	ret


;RETURN command
C_RET:
	pop	bc		;return address

RETLP:
	ld	hl,0001h
	add	hl,sp
	ex	de,hl
	ld	hl,(STACK)
	sbc	hl,de		;c-flag=0
	jp	c,RGERR
	dec	sp
	pop	af		;GOSUB or FOR identifier
	cp	GOSUB
	jr	z,RETOK
;	cp	FOR
;	jp	nz,RGERR
	pop	hl		;FOR variable name
	call	POPF2		;STEP value
	call	POPF2		;TO value
	pop	hl		;line number
	pop	hl		;program address
	jr	RETLP

RETOK:
	pop	hl
	ld	(LINENUM),hl
	pop	hl
	ld	(PROGAD),hl

	push	bc		;return address
	ret


;GOSUB command
C_GSUB:
	call	GETLN
GSUBLP:
	call	CHKCLN		;a=(de)
	inc	de
	jr	nz,GSUBLP
	dec	de
	push	de		;program address

GSUB:
	call	SRCHLN
	jp	nc,ULERR
	ld	(PROGAD),bc

	call	CHKFRE

	pop	de		;program address
	pop	hl		;return address

	push	de		;program address
	ld	de,(LINENUM)
	push	de
	ld	a,GOSUB
	push	af		;gosub identifier
	inc	sp
	jp	(hl)


;RESTORE command
C_RSTR:
	call	CHKCLN
	jr	z,RSTRZ
	call	GETLN
	push	hl
	ld	(PROGAD),de
	call	SRCHLN
	jp	nc,ULERR
	ld	(DATAAD),bc
	pop	hl
	ld	(DATALN),hl
	ret

RSTRZ:
	ld	hl,(BASICAD)
	ld	(DATAAD),hl
	ret


;CONT command
C_CONT:
	pop	hl		;cancel return address
	ld	hl,(LINENUM)
	ld	a,h
	and	l
	inc	a
	jp	nz,CNERR	;if (LINENUM)<>0ffffh

	ld	hl,(STOPAD)
	ld	a,h
	or	l
	jp	z,CNERR		;if (STOPAD)=0000h
	ld	(PROGAD),hl

	ld	a,(STOPSC3)
	call	CHGACT
	ld	a,(STOPSC2)
	call	CHGDSP
	jp	INTPRT


;STOP command
C_STOP:
	ei
	pop	hl		;cancel return address
	xor	a
	ld	(STOPFLG),a
	ld	(DEVICE),a
	ld	a,37h		;RTS=1
	out	(81h),a
	call	CHGTXT
	ld	a,(CSRX)
	dec	a
	call	nz,PRTNL
	ld	hl,(PROGAD)
	ld	(STOPAD),hl
	ld	hl,(LINENUM)
	ld	(STOPLN),hl
	ld	hl,BREAK
	jp	PRTLNUM

BREAK:
	db	07h,"Break",00h


;OUT command
C_OUT:
	call	INT1ARG
	push	hl		;
	ld	a,(de)
	cp	","
	jp	nz,SNERR
	inc	de
	call	INT1ARG
	pop	bc		;
	out	(c),l
	ret


;ON command
C_ON:
	call	NUMARGMO
	push	de
	call	FTOI1
	pop	de
	ld	a,(de)
	ld	b,a		;

ONLP:
	inc	de
	ld	(PROGAD),de
	dec	l
	jp	nz,ONNZ
	ld	a,b		;
	cp	GOTO
	jp	z,C_GOTO
	cp	GOSUB
	jp	z,C_GSUB
	jp	SNERR
ONNZ:
	push	bc
	push	hl
	call	GETLN
	ld	(PROGAD),de
	pop	hl
	pop	bc
	ld	a,(de)
	cp	","
	jr	z,ONLP
	ret


;LPRINT command
C_LPRT:
	ld	a,1
	jp	PRTDEV


;LLIST command
C_LLST:
	ld	a,1
	ld	(DEVICE),a
;	jp	C_LIST


;LIST command
C_LIST:
	pop	hl		;cancel return address
	ld	hl,0000h
	push	hl
	ld	hl,0fffeh
	call	CHKCLN
	jr	z,LISTSTRT
	pop	hl
	call	GETLN
	push	hl		;start
	call	CHKCLN
	jr	z,LISTSTRT
	cp	MINUS
	jp	nz,SNERR
	inc	de
	call	CHKCLN
	ld	hl,0ffffh
	call	nz,GETLN
	call	CHKCLN
	jp	nz,SNERR

LISTSTRT:
	push	hl		;end

	ld	hl,(BASICAD)
LISTLP1:
	call	CHKSTOP
	inc	hl
LISTLP2:
	ld	a,(hl)
	inc	hl
	or	(hl)
	jr	z,LISTEND

	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ex	(sp),hl
	rst	CPHLDE		;hl=end, de=line number
	jr	c,LISTEND

	pop	bc
	ex	(sp),hl
	ex	de,hl
	rst	CPHLDE		;hl=line number, de=start, (sp)=end
	ex	de,hl
	ex	(sp),hl
	push	hl
	ex	de,hl
	ld	d,b
	ld	e,c
	jr	nc,LISTPRT

	ex	de,hl
	dec	hl
	dec	hl
	ld	a,(hl)
	dec	hl
	ld	l,(hl)
	ld	h,a
	jr	LISTLP2

LISTPRT:
	push	hl
	call	PRTNL
	pop	hl

	push	de		;
	call	I2TOF
	call	FTOA
	inc	hl
	call	PUTS
	ld	a," "
	call	PUTDEV
	pop	hl		;

	ld	bc,0		;double quotation mark and DATA counter
	ld	d,b		;REM counter
LISTLP3:
	inc	hl
	ld	a,(hl)
	or	a
	jr	z,LISTLP1

	inc	d
	dec	d
	jr	nz,LISTPUT
	cp	REM
	jr	z,LISTREM
	cp	22h
	jr	z,LISTDQ
	inc	c
	dec	c
	jr	nz,LISTCHKCLN
	bit	0,b
	jr	nz,LISTPUT
	cp	0c2h
	jr	nc,LISTFNC
	cp	DATA
	jr	z,LISTDATA
	cp	80h
	jr	nc,LISTCMD
LISTPUT:
	call	PUTDEV
	jr	LISTLP3

LISTEND:
	pop	hl
	pop	hl
	jp	EDIT

LISTDQ:
	inc	b
	jr	LISTPUT

LISTCHKCLN:
	bit	0,b
	jr	nz,LISTPUT
	cp	":"
	jr	nz,LISTDQ
	dec	c
	jr	LISTPUT

LISTREM:
	inc	d
LISTDATA:
	inc	c
LISTCMD:
	ld	e,80h-1
	push	hl
	ld	hl,CMDLST-1
	jr	LISTLP4
LISTFNC:
	ld	e,0c2h-1
	push	hl
	ld	hl,FNCLST-1

LISTLP4:
	inc	hl
	bit	7,(hl)
	jr	z,LISTLP4
	inc	e
	cp	e
	jr	nz,LISTLP4

LISTZ:
	ld	a,(hl)
	and	7fh
LISTLP5:
	call	PUTDEV
	inc	hl
	ld	a,(hl)
	bit	7,a
	jr	z,LISTLP5
	pop	hl
	jr	LISTLP3


;CLEAR command
C_CLER:
	call	CHKCLN
	jr	z,CLEREND
	call	NUMARGSN
	push	de
	call	FTOI2
	pop	de
	bit	7,h
	jp	nz,FCERR
	push	hl		;1st parameter
	ld	hl,(STREND)
	inc	hl
	ld	a,(de)
	cp	","
	jr	nz,CLMAIN
	inc	de
	call	NUMARGMO
	call	FTOI

CLMAIN:
	ex	de,hl
	ld	hl,(USREND)
	inc	hl
	rst	CPHLDE
	jp	c,FCERR
	ex	de,hl

	dec	hl
	pop	bc		;1st parameter
	push	hl		;2nd parameter-1
	sbc	hl,bc		;c-flag=0
	ld	de,(VARAD)
	rst	CPHLDE
	jp	c,OMERR

	ld	(STACK),hl
	pop	hl		;2nd parameter-1
	ld	(STRAD),hl
	ld	(STREND),hl

CLEREND:
	pop	bc		;return address
	ld	hl,(STACK)
	ld	sp,hl
	push	bc		;return address
	ld	hl,(VARAD)
	ld	(ARRAD),hl
	ld	(FREEAD),hl
	ld	hl,(BASICAD)
	ld	(DATAAD),hl
	ret


;COLOR command
C_COLR:
	call	CHKCMM
	jr	z,COLRPAR2
	call	INT1ARG
	ld	(COLOR1),a
	call	CHKCLN		;a=(de)
	ret	z
	cp	","
	ret	nz
	inc	de

COLRPAR2:
	call	CHKCMM
	jr	z,COLRPAR3
	call	INT1ARG
	ld	(COLOR2),a
	call	CHKCLN		;a=(de)
	ret	z
	cp	","
	ret	nz
	inc	de

COLRPAR3:
	call	INT1ARG
	dec	a
	cp	2
	jp	nc,FCERR
	add	a,a

	ld	hl,COLOR3
	cp	(hl)
	ret	z
	ld	(hl),a		;1,2 -> 0,2

	ld	hl,(VRAM-1)
	ld	l,0
	ld	bc,0002h	;32*16=256*2

COLRLP:
	ld	a,(hl)
	xor	02h
	ld	(hl),a
	inc	hl
	djnz	COLRLP
	dec	c
	jr	nz,COLRLP
	ret


;PRINT command
C_PRT:
	call	SKIPSP
	cp	"#"
	ld	a,0
	call	z,GETDEV
PRTDEV:
	ld	(DEVICE),a
	rlca
	jr	nc,PRTLP

	call	WOPEN
	ld	b,6
	ld	a,9ch
PRTDEVLP:
	call	PUTCMT
	djnz	PRTDEVLP

PRTLP:
	call	CHKCLN		;a=(de)
	jr	z,PRTEOL
PRTLP2:
	cp	";"
	jr	z,PRTNEXT
	cp	","
	jr	z,PRTCMM
	cp	SPC
	jp	z,PRTSPC
	cp	TAB
	jp	z,PRTTAB

	call	ARG
	ld	a,(ARGTYP)
	or	a
	jr	z,PRTNUM
	dec	a
	jp	nz,SNERR

PRTSTR:
	ld	hl,(FAC1+1)
	ld	a,(hl)
	inc	hl
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	hl,(PROGAD)
	ex	de,hl
	or	a
	jr	z,PRTLP
	ld	b,a
PRTSLP:
	ld	a,(hl)
	inc	hl
	call	PUTDEV
	djnz	PRTSLP
	jr	PRTLP

PRTNUM:
	push	de
	call	FTOA
	call	PUTS
	pop	de
	jr	PRTLP

PRTEOL:
	call	PRTEND
PRTNL:
	xor	a
	ld	(GRPFLG),a
	ld	hl,CRLF
	call	PUTS
	ret

PRTNEXT:
	inc	de
	call	CHKCLN
	jr	nz,PRTLP2
PRTEND:
	ld	(PROGAD),de
	ld	a,(DEVICE)
	rlca
	ret	nc
	call	WCLOSE
	ret

PRTCMM:
	push	de
	call	CMMMAIN
	pop	de
	jr	PRTNEXT

CMMMAIN:
	ld	a,(DEVICE)
	or	a
	jr	z,CMM0	;CRT
	dec	a
	jr	z,CMM1	;printer

;RS-232C,CMT
	ld	b,14
	call	PUTSP
	ret

;CRT
CMM0:
	ld	a,(CSRX)
	sub	15
	jr	nc,PRTNL
CMMSP:
	neg
	ld	b,a
;	call	PUTSP
;	ret

PUTSP:
	ld	a," "
PUTSPLP:
	call	PUTDEV
	djnz	PUTSPLP
	ret

;printer
CMM1:
	ld	a,(PRTPOS)
	ld	b,8
CMM1LP:
	sub	14
	jr	c,CMMSP
	djnz	CMM1LP
	call	PRTNL
	ret

PRTSPC:
	inc	de
	call	FNCNUMR
	push	de
	call	FTOI1
	pop	de
PRTSPC2:
	ld	b,l
PRTSPC3:
	call	PUTSP
	dec	de
	jr	PRTNEXT


PRTTAB:
	inc	de
	call	FNCNUMR
	push	de
	call	FTOI1
	pop	de

	ld	a,(DEVICE)
	or	a
	jr	z,PRTTAB0	;0=CRT
	dec	a
	jr	z,PRTTAB1	;1=printer
	jr	PRTSPC2		;2,80-ff=RS-232C,CMT

;CRT
PRTTAB0:
	dec	de
	ld	a,l
	ld	hl,CSRX
	sub	(hl)
	jp	c,PRTNEXT
	inc	a
PRTTABSP:
	ld	b,a
	inc	de
	jr	PRTSPC3

PRTTAB1:			;printer
	ld	a,l
	ld	hl,PRTPOS
	sub	(hl)
	jp	z,PRTNEXT
	jp	c,PRTNEXT
	jr	PRTTABSP


;PRESET command
C_PRST:
	ld	a,(COLOR2)
	jr	PSETRST

;PSET command
C_PSET:
	ld	a,(COLOR1)

;PSET and PRESET
PSETRST:
	push	af
	call	GETXY
	ld	de,(PROGAD)
	call	SKIPSP
	cp	","
	jr	nz,PSSETAT
	pop	af		;cancel
	inc	de
	push	bc		;x
	push	hl		;y
	call	INT1ARG
	pop	hl		;y
	pop	bc		;x
	push	af
PSSETAT:
	pop	af
	call	SETATT

PSET:
;pset(bc,hl),(ATTDAT)
	ld	a,(SCREEN1)
	dec	a
	jr	z,PSET2
	jp	m,PSET1
;	dec	a
;	jr	z,PSET3
PSET4:
PSET3:
	call	GETADG34
	ld	a,(ATTDAT)
	xor	(hl)
	and	d
	xor	(hl)
	ld	(hl),a
	ret

;screen mode 1
PSET1:
	call	GETADG
	ld	a,(ATTDAT)
	ld	(hl),a
	ret

;screen mode 2
PSET2:
	push	bc		;x
	call	GETADG
	ld	a,(hl)
	and	40h		;semi-graphic mode?
	jr	nz,PS2SEMI

	ld	a,(COLOR2)
	or	a
	jr	z,PSET2Z
	dec	a
	rrca
	rrca
	or	3fh
PSET2Z:
	inc	h
	inc	h
	ld	(hl),a		;hl=hl+200h
	dec	h
	dec	h

PS2SEMI:
	ld	a,(ATTDAT)
	ld	e,a		;
	or	a
	jr	z,SKIPATT
	cp	5
	ld	a,(COLOR3)
	jr	c,PS2C1
	xor	02h
PS2C1:
	add	a,60h
	ld	(hl),a
SKIPATT:
	inc	h
	inc	h		;hl=hl+200h

	pop	bc		;x
	call	DOTBIT2
	ld	b,a

	ld	a,(hl)
	and	3fh
	or	b
	ld	c,a

	ld	a,e		;
	or	a
	jr	z,PSET2C0
	dec	a
	and	03h
	rrca
	rrca
	add	a,c
PS2END:
	ld	(hl),a
	ret

PSET2C0:
	ld	a,b
	cpl
	and	(hl)
	ld	(hl),a
	ret


;screen mode 2 dot bit
;input: c=X, d=Y mod 12
;output: a
;broken: f,bc
DOTBIT2:
	ld	a,c
	and	04h
	rrca
	ld	c,a		;0,2
	ld	a,d
	and	0ch		;0,4,8
	add	a,c
	rrca			;0,1,2,3,4,5
	ld	b,a
	inc	b
	ld	a,40h
DOTB2LP:
	rrca
	djnz	DOTB2LP
	ret


;LINE command
C_LINE:
	ld	bc,(GRPX1)
	ld	hl,(GRPY1)
	push	de
	call	CHKXY
	pop	de
	push	bc
	push	hl

	call	SKIPSP
	cp	MINUS
	jr	z,LINE2

	pop	hl
	pop	bc
	call	GETXY		;bc,hl
	push	bc
	push	hl
	ld	de,(PROGAD)
	call	SKIPSP
	cp	MINUS
	jp	nz,SNERR
LINE2:
	inc	de
	call	GETXY		;bc,hl

	ld	de,(PROGAD)
	call	SKIPSP
	cp	","
	ld	a,(COLOR1)
	push	af
	jp	nz,LINEMAIN
	inc	de
	call	SKIPSP
	cp	","
	jr	z,LINESKPC

;color
	pop	af
	push	bc
	push	hl
	call	INT1ARG
	pop	hl
	pop	bc
	push	af
	call	SKIPSP
	cp	","
	jp	nz,LINEMAIN

LINESKPC:
	inc	de
	call	SKIPSP
	cp	"B"
	jp	nz,SNERR
	inc	de
	call	SKIPSP
	cp	"F"
	jr	z,LINEBF

;LINE BOX
	ld	(PROGAD),de
	ld	(GRPX2),bc	;x2
	ld	(GRPY2),hl	;y2
	pop	af
	call	SETATT
	pop	hl		;y1
	ld	(GRPY3),hl
	pop	hl		;x1
	ld	(GRPX3),hl
	call	SORTXY

	ld	hl,(GRPX3)
	push	hl		;smaller x
	ld	hl,(GRPY2)
	push	hl		;larger y
	ld	hl,(GRPY3)
	push	hl		;smaller y

;down-up-right-left
	ld	bc,(GRPX3)	;smaller x
	ld	de,(GRPY2)	;larger y
	call	LINE
	pop	de		;smaller y
	ld	(GRPY2),de
	call	LINE
	ld	bc,(GRPX2)
	pop	hl		;larger y
	ld	(GRPY2),hl
	call	LINE
	pop	bc		;smaller x
	ld	(GRPX2),bc
	call	LINE
	ret


LINEBF:
	inc	de
	ld	(PROGAD),de
	ld	(GRPX2),bc	;x2
	ld	(GRPY2),hl	;y2
	pop	af
	call	SETATT
	pop	hl		;y1
	ld	(GRPY3),hl
	pop	hl		;x1
	ld	(GRPX3),hl
	call	SORTXY

	ld	de,(GRPY3)	;smaller y
	ld	bc,(GRPX3)	;smaller x, b=0
	ld	hl,(GRPY2)	;larger y

	ld	a,(SCREEN1)
	cp	2
	jr	nc,LINEBF34

;line bf (screen mode 1,2)
BFLP:
	ld	(GRPY2),de
	call	LINE
	rst	CPHLDE
	ret	z
	push	hl		;larger y
	dec	b
	call	DECY		;b>=80h:inc y
	inc	b
	ex	de,hl
	pop	hl		;larger y
	jr	BFLP


;line bf (screen mode 3,4)
LINEBF34:
	ex	de,hl		;smaller y

	ld	a,c		;smaller x
	and	07h
	ld	b,a
	ld	a,0ffh
	jr	z,BF34Z

BF34LP1:
	srl	a
	djnz	BF34LP1
BF34Z:
	ld	e,a		;left edge change bit

	call	GETADG34

	ld	a,(SCREEN1)
	cp	2
	ld	a,(GRPX2)	;larger x
	jr	nz,BF34SC4	;screen mode 4
	inc	a
BF34SC4:
	and	07h
	inc	a
	ld	b,a
	xor	a
BF34LP2:
	scf
	rra
	djnz	BF34LP2
	ld	d,a		;right edge change bit


	ld	a,(GRPX3)
	and	0f8h
	ld	b,a
	ld	a,(GRPX2)
	and	0f8h
	sub	b		;

	rrca
	rrca
	rrca

	push	af		;
	jr	nz,BF34NZ
	ld	a,d
	and	e
	ld	e,a
BF34NZ:
	dec	a
	ld	b,a		;bytes
	ld	a,(GRPY3)
	ld	c,a
	ld	a,(GRPY2)
	sub	c
	inc	a
	ld	c,a		;lines

BF34LP3:
;left edge
	ld	a,(ATTDAT)
	xor	(hl)
	and	e		;e=left edge change bit
	xor	(hl)
	ld	(hl),a

	pop	af		;
	push	af		;
	jr	z,BF34NEXT

;middle part
	push	hl		;VRAM address
	ld	a,b
	or	a
	jr	z,BF34RHT
	push	bc
BF34LP4:
	ld	a,(ATTDAT)
	inc	hl
	ld	(hl),a
	djnz	BF34LP4
	pop	bc

;right edge
BF34RHT:
	inc	hl
	ld	a,(ATTDAT)
	xor	(hl)
	and	d		;d=right edge change bit
	xor	(hl)
	ld	(hl),a
	pop	hl		;VRAM address

BF34NEXT:
	push	de
	ld	de,0020h
	add	hl,de
	pop	de
	dec	c
	jr	nz,BF34LP3

	pop	af		;
	ret


LINEMAIN:
	ld	(GRPX2),bc	;x2
	ld	(GRPY2),hl	;y2
	pop	af		;color
	call	SETATT
	pop	de		;y1
	pop	bc		;x1

;input: bc=x1, de=y1, (GRPX2)=x2, (GRPY2)=y2, (ATTDAT)=attribute
;broken: af
LINE:
	push	hl
	push	de
	push	bc
	ld	hl,(GRPX2)
	push	hl
	ld	hl,(GRPY2)
	push	hl

	ld	(GRPX3),bc	;x1
	ld	(GRPY3),de	;y1
	call	SORTX
	ld	bc,(GRPX2)	;end
	ld	hl,(GRPX3)	;start
	or	a
	sbc	hl,bc

	ld	a,(SCREEN1)
	or	a
	jr	nz,SKIPX
;screen mode 1: dx=dx*3
	ld	d,h
	ld	e,l
	add	hl,hl
	add	hl,de
SKIPX:
	push	hl		;dx
	ld	bc,(GRPY2)	;end
	ld	hl,(GRPY3)	;start
	sbc	hl,bc		;dy, c-flag=0
	rrca
	jr	c,SKIPY
;screen mode 1 or 3: dy=dy*2
	add	hl,hl
SKIPY:
	pop	de		;dx
	push	de		;dx
	push	hl		;dy

	bit	7,h
	jr	z,DYGE0
;if dy<0, hl=-hl
	xor	a
	sub	l
	ld	l,a
	ld	a,0
	sbc	a,h
	ld	h,a
DYGE0:
	rst	CPHLDE
	jr	nc,SLOPEY	;if |dy/dx|>=1

	ld	hl,0
	or	a
	sbc	hl,de
	push	hl		;error=-dx

LINELP1:
	ld	bc,(GRPX3)
	ld	hl,(GRPY3)
	call	PSET

	pop	hl		;error
	pop	bc		;dy
	pop	de		;dx
	push	de		;dx
	push	bc		;dy

	call	ADDDY
	push	hl		;error
	bit	7,h
	jr	nz,CALLDECX

;if error>=0
	pop	hl		;error
	or	a
	sbc	hl,de		;error-=dx
	sbc	hl,de		;error-=dx
	pop	bc		;dy
	push	bc		;dy
	push	hl		;error
	call	DECY

CALLDECX:
	call	DECX
	bit	7,h
	jr	nz,LINEEND
	ld	de,(GRPX2)
	rst	CPHLDE
	jr	nc,LINELP1

LINEEND:
	pop	af
	pop	af
	pop	af

	pop	hl
	ld	(GRPY2),hl
	pop	hl
	ld	(GRPX2),hl

	pop	bc
	pop	de
	pop	hl
	ret


;|dy/dx|>1
SLOPEY:
	push	hl		;error=|dy|

LINELP2:
	ld	bc,(GRPX3)
	ld	hl,(GRPY3)
	call	PSET

	pop	hl		;error
	pop	bc		;dy
	pop	de		;dx
	push	de		;dx
	push	bc		;dy

	or	a
	sbc	hl,de		;error-=dx
	sbc	hl,de		;error-=dx
	push	hl		;error

	bit	7,h
	jr	z,CALLDECY

;if error<0
	pop	hl		;error
	call	ADDDY
	push	hl		;error
	call	DECX
	pop	hl		;error
	pop	bc		;dy
	push	bc		;dy
	push	hl		;error

CALLDECY:
	call	DECY
	bit	7,h
	jr	nz,LINEEND

	ld	de,(GRPY2)
	bit	7,b
	jr	z,LINEZ
	ex	de,hl
LINEZ:
	rst	CPHLDE
	jr	nc,LINELP2
	jr	LINEEND


;x=x+(8 or 4 or 2 or 1)
;input: (GRPX3)
;output: hl,(GRPX3)
;broken: af,bc
DECX:
	ld	a,(SCREEN1)
	inc	a
	ld	b,a
	ld	a,10h
DECXLP:
	rrca
	djnz	DECXLP
	ld	hl,(GRPX3)
	ld	c,a
	or	a
	sbc	hl,bc		;bc=8,4,2,1
	ld	(GRPX3),hl
	ret


;y=y+-(12 or 4 or 1 or 1)
;input: b(bit7=0:decrement, bit7=1:increment), (GRPY3)
;output: hl,(GRPY3)
;broken: af,de
DECY:
	ld	a,(SCREEN1)
	ld	de,12
	or	a
	jr	z,DECYZ
	ld	e,4
	dec	a
	jr	z,DECYZ
	ld	e,1
DECYZ:
	ld	hl,(GRPY3)
	bit	7,b
	jr	nz,INCY
;if dy>0
	sbc	hl,de		;de=12,4,1,1,c-flag=0
	jr	DECYEND
INCY:
	add	hl,de		;de=12,4,1,1
DECYEND:
	ld	(GRPY3),hl
	ret


;increment x
;input:	hl=address,d=bit
;output:hl,d
;broken:af
INCX2:
	rrc	d
	jr	c,INCX2C
	ret	po
	rrc	d
	ret

INCX2C:
	jp	po,INCX2END	;screen mode 4
	rrc	d		;screen mode 1 or 3

INCX2END:
	inc	hl
	ret


;decrement x
;input:	hl=address, d=bit
;output:hl,d
;broken:af
DECX2:
	rlc	d
	jr	c,DECX2C
	ret	po		;screen mode 4
	rlc	d		;screen mode 3
	ret

DECX2C:
	jp	po,DECX2END	;screen mode 4
	rlc	d		;screen mode 1 or 3

DECX2END:
	dec	hl
	ret


;error+=|dy|*2
;input: bc=dy, hl=error
;output: hl=error
;broken: af,bc
ADDDY:
	bit	7,b
	jr	z,ADDDYZ
;if dy<0
	xor	a
	sub	c
	ld	c,a
	ld	a,0
	sbc	a,b
	ld	b,a
ADDDYZ:
	add	hl,bc		;error+=|dy|
	add	hl,bc		;error+=|dy|
	ret


;x1 <-> x2, y1 <-> y2
;input: (GRPX2)=x2, (GRPY2)=y2, (GRPX3)=x1, (GRPY3)=y1
;output: (GRPX2)=larger x,(GRPY2)=larger y,(GRPX3)=smaller x,(GRPY3)=smaller y
;broken: de,hl
SORTXY:
	push	af
	ld	hl,(GRPX2)
	ld	de,(GRPX3)
	rst	CPHLDE
	jr	nc,SORTXOK
	ld	(GRPX2),de
	ld	(GRPX3),hl
SORTXOK:
	ld	hl,(GRPY2)
	ld	de,(GRPY3)
	rst	CPHLDE
	jr	c,SORTY
	pop	af
	ret


;(x1,y1) <-> (x2,y2)
;input: (GRPX2)=x2, (GRPY2)=y2, (GRPX3)=x1, (GRPY3)=y1
;output: (GRPX2),(GRPY2)=smaller x with y, (GRPX3),(GRPY3)=larger x with y
;broken: de,hl
SORTX:
	push	af
	ld	hl,(GRPX2)
	ld	de,(GRPX3)
	rst	CPHLDE
	jr	c,NOSORT
	ld	(GRPX2),de
	ld	(GRPX3),hl
	ld	hl,(GRPY2)
	ld	de,(GRPY3)
SORTY:
	ld	(GRPY2),de
	ld	(GRPY3),hl
NOSORT:
	pop	af
	ret


;PAINT command
C_PAIN:
	call	GETXY
	push	bc		;X
	push	hl		;Y
	ld	de,(PROGAD)
	call	SKIPSP
	cp	","
	ld	a,(COLOR1)
	jr	nz,PASETATT
	inc	de
	call	INT1ARG
PASETATT:
	call	SETATT
	call	SKIPSP
	cp	","
	jr	nz,PASTART
	inc	de
	call	INT1ARG
	ld	(BORDERC),a
	call	CNVATT
	ld	(BORDERA),a
PASTART:
	pop	hl		;Y
	pop	bc		;X

PAMAIN:
	ld	a,(SCREEN1)
	or	a
	jr	z,PAINT1	;screen mode 1
	dec	a
	ret	z		;screen mode 2
	call	GETADG34
	jr	PADWN
PAINT1:
	call	GETADG
	ld	d,0ffh

PADWN:
	call	PALINE
	ret	z
	push	hl		;address
	push	de		;bit
	ld	bc,(PAWRK)
	push	bc
	call	PAUP2
	pop	bc
	ld	(PAWRK),bc
	pop	de		;bit
	pop	hl		;address

PADWN2:
	ld	a,(SCREEN1)
	or	a
	ld	e,19h
	jr	nz,PADWN34
	ld	e,01h
PADWN34:
	ld	a,h
	and	1fh
	cp	e
	jr	c,PADWNOK
	ld	a,l
	cp	0e0h
	ret	nc
PADWNOK:
	ld	bc,COLUMNS
	add	hl,bc

	xor	a
	ld	(PACNT),a
PADWNLP1:
	call	SRCHOK
	jr	c,CALLDWN
	ld	a,(PACNT)
	inc	a
	ld	(PACNT),a
	push	hl		;address
	push	de		;bit
	push	hl
	push	de
	call	CHKFRE
	pop	de
	pop	hl
	call	INCX2
	call	SRCHNG
	jr	nc,PADWNLP1

CALLDWN:
	ld	a,(PACNT)
	or	a
	ret	z
PADWNLP2:
	pop	de		;bit
	pop	hl		;address
	dec	a
	ld	(PACNT),a
	jr	z,PADWN
	push	af
	call	PADWN
	pop	af
	jr	PADWNLP2


PAUP:
	call	PALINE
	ret	z
	push	hl		;address
	push	de		;bit
	ld	bc,(PAWRK)
	push	bc
	call	PADWN2
	pop	bc
	ld	(PAWRK),bc
	pop	de		;bit
	pop	hl		;address

PAUP2:
;if (hl - start address) < 0020h
	ld	a,(SCREEN1)
	and	02h		;0(screen mode 1) or 2(screen mode 3,4)
	ld	e,a
	ld	a,h
	and	1fh
	cp	e
	jr	nz,PAUPNZ
	ld	a,l
	cp	20h
	ret	c
PAUPNZ:
	ld	bc,0-COLUMNS
	add	hl,bc

	xor	a
	ld	(PACNT),a
PAUPLP1:
	call	SRCHOK
	jr	c,CALLUP
	ld	a,(PACNT)
	inc	a
	ld	(PACNT),a
	push	hl		;address
	push	de		;bit
	push	hl
	push	de
	call	CHKFRE
	pop	de
	pop	hl
	call	INCX2
	call	SRCHNG
	jr	nc,PAUPLP1

CALLUP:
	ld	a,(PACNT)
	or	a
	ret	z
PAUPLP2:
	pop	de		;bit
	pop	hl		;address
	dec	a
	ld	(PACNT),a
	jr	z,PAUP
	push	af
	call	PAUP
	pop	af
	jr	PAUPLP2


PALINE:
	ld	a,(STOPFLG)
	cp	03h
	jp	z,C_STOP
	cp	1bh
	jr	z,PALINE

	call	CHKPA
	ret	z
	push	hl		;address
	push	de		;bit
	call	PAINTR
	ld	a,l
	and	1fh
	ld	c,a
	ld	b,d
	ld	(PAWRK),bc	;X_right
	pop	de		;bit
	pop	hl		;address
	call	PAINTL		;z-flag=0
	ret


;search paintable area
;input:hl=address, d=bit
;output:hl,d,c-flag(1=over,0=NG)
;broken:af,e
SRCHOK:
	ld	a,l
	and	1fh
	ld	e,a
	ld	a,(PAWRK)	;address low
	and	1fh
	cp	e
	ret	c
	jr	nz,SRCHOKNZ
	ld	a,(PAWRK+1)	;bit
	cp	d
	jr	c,SRCHOKNZ
	jr	z,SRCHOKNZ
	scf
	ret

SRCHOKNZ:
	call	GETATT
	ld	a,(BORDERA)
	cp	e
	jr	z,SRCHOKZ
	ld	a,(ATTDAT)
	cp	e
	jr	z,SRCHOKZ
	or	a		;reset c-flag
	ret

SRCHOKZ:
	call	INCX2
	ld	a,l
	and	1fh
	jr	nz,SRCHOK
	bit	7,d
	jr	z,SRCHOK
	scf
	ret


;search unpaintable area
;get unpaintable area
;input:hl=address, d=bit
;output:hl,d,c-flag(1=over,0=NG)
;broken:af,e
SRCHNG:
	ld	a,l
	and	1fh
	ld	e,a
	ld	a,(PAWRK)	;address low
	and	1fh
	cp	e
	ret	c
	jr	nz,SRCHNGNZ
	ld	a,(PAWRK+1)	;bit
	cp	d
	jr	c,SRCHNGNZ
	jr	z,SRCHNGNZ
	scf
	ret

SRCHNGNZ:
	call	GETATT
	ld	a,(BORDERA)
	cp	e
	ret	z
	ld	a,(ATTDAT)
	cp	e
	ret	z

	call	INCX2
	ld	a,l
	and	1fh
	jr	nz,SRCHNG
	bit	7,d
	jr	z,SRCHNG
	scf
	ret


;paint to left direction
;input: hl=address, d=bit
;output:hl,d
;broken:af,bc,e
PAINTL:
	ld	a,l
	and	1fh
	jr	nz,PALOK
	bit	7,d
	ret	nz
PALOK:
	call	DECX2
	call	CHKPA
	jr	nz,PAINTL
	call	INCX2
	ret

;paint to right direction
;input: hl=address, d=bit
;output:hl,d
;broken:af,bc,e
PAINTR:
	ld	a,l
	cpl
	and	1fh
	jr	nz,PAROK
	bit	0,d
	ret	nz
PAROK:
	call	INCX2
	call	CHKPA
	jr	nz,PAINTR
	call	DECX2
	ret


;check and paint
;input:	hl=address, d=bit
;output:z(1=not painted)
;broken:af,e
CHKPA:
	ld	a,(hl)
	and	d
	ld	e,a
	ld	a,(BORDERA)
	and	d
	cp	e
	ret	z

	ld	a,(ATTDAT)
	xor	(hl)
	and	d
	xor	(hl)
	ld	(hl),a

	or	0ffh		;reset z-flag
	ret


;SCREEN command
C_SCRN:
	ld	hl,(SCREEN1)	;l=(SCREEN1)
	ld	h,1		;no 1st parameter
	push	hl
	ld	hl,(SCREEN2)	;l=(SCREEN2),h=(SCREEN3)
	push	hl

	call	CHKCMM
	jr	z,SCRPAR2
	call	INT1ARG
	dec	l

	pop	bc		;c=2nd,b=3rd parameter
	pop	af		;cancel 1st parameter
	push	hl		;l=1st parameter, h=0
	push	bc		;c=2nd,b=3rd parameter

	call	CHKCLN		;a=(de)
	jr	z,SCRMAIN
	cp	","
	jp	nz,SNERR
	inc	de

SCRPAR2:
	call	CHKCMM
	jr	z,SCRPAR3
	call	INT1ARG
	dec	a

	pop	hl		;l=2nd,h=3rd parameter
	ld	l,a
	push	hl

	call	CHKCLN		;a=(de)
	jr	z,SCRMAIN
	cp	","
	jp	nz,SNERR
	inc	de

SCRPAR3:
	call	CHKCMM
	jp	z,MOERR
	call	INT1ARG
	dec	a

	pop	hl		;l=2nd,h=3rd parameter
	ld	h,a
	push	hl


SCRMAIN:
	pop	hl		;l=2nd,h=3rd parameter
	pop	bc		;c=1st parameter

	ld	a,(PAGES)
	dec	a
	cp	h
	jp	c,FCERR
	cp	l
	jp	c,FCERR

	ld	a,c
	cp	4
	jp	nc,FCERR
	cp	2
	jr	c,SCROK
	ld	a,l
	or	a
	jr	nz,SCROK
	ld	a,b
	or	a		;b>0:no 1st parameter
	jp	z,FCERR		;if 1st>=2 and 2nd=0
SCROK:
	push	hl		;l=2nd,h=3rd parameter
	push	bc		;c=1st parameter
	ld	a,l
	call	CHGACT
	pop	bc		;c=1st parameter
	ld	a,b
	or	a
	ld	a,c
	call	z,CHGMOD	;b>0: no 1st parameter
	pop	af		;a=3rd parameter
	call	CHGDSP
	ret


;LOCATE command
C_LOCA:
	call	INT1ARG
	ld	hl,WIDTH
	cp	(hl)
	jp	nc,FCERR
	inc	a
	push	af		;
	ld	a,(de)
	cp	","
	jp	nz,SNERR
	inc	de
	call	INT1ARG
	cp	ROWS
	jp	nc,FCERR
	inc	a
	pop	hl		;
	ld	l,a
	call	SETCSR
	ret


;CONSOLE command
C_CNSL:
	call	CHKCMM
	ld	a,(CONSOL1)
	jr	z,CNSLPAR2
	call	INT1ARG
	inc	a
	ld	(CONSOL1),a
	call	CHKCLN
	jr	z,CNSLEND
	cp	","
	jp	nz,SNERR
	inc	de

CNSLPAR2:
	ld	hl,CONSOL2
	inc	(hl)
	call	CHKCMM
	jr	z,CNSLPAR3
	call	INT1ARG
	ld	a,(CONSOL1)
	add	a,l
	dec	a
	ld	(CONSOL2),a
	call	CHKCLN
	jr	z,CNSLEND
	cp	","
	jp	nz,SNERR
	inc	de

CNSLPAR3:
	call	CHKCMM
	jr	z,CNSLPAR4
	call	INT1ARG
	cp	2
	jp	nc,FCERR

	ld	hl,CONSOL3
	cp	(hl)
	jr	z,CNSLZ
	ld	(hl),a
	push	de
	call	PRTFKEY
	pop	de

CNSLZ:
	call	CHKCLN
	jr	z,CNSLEND
	cp	","
	jp	nz,SNERR
	inc	de

CNSLPAR4:
	call	INT1ARG
	cp	2
	jp	nc,FCERR
	ld	(CONSOL4),a

CNSLEND:
	ld	a,ROWS
	ld	hl,CONSOL3
	sub	(hl)
	ld	b,a

	ld	hl,CONSOL1
	ld	a,(hl)
	cp	b
	jr	c,CNSL1OK
	ld	(hl),b
CNSL1OK:
	ld	hl,CONSOL2
	ld	a,(hl)
	cp	ROWS
	jr	c,CNSL2OK
	ld	a,ROWS
	ld	(hl),a
CNSL2OK:
	ld	hl,LASTLIN
	ld	(hl),a
	cp	b
	ret	c
	ld	a,(SCREEN1)
	cp	2
	ret	nc		;screen mode 3,4
	ld	(hl),b
	ret


;CLOAD command
C_CLD:
	pop	hl		;cancel return address
	xor	a
	ld	(DEVICE),a
	ld	h,a
	ld	l,a
	ld	(TARGET),hl
	ld	(TARGET+2),hl
	ld	(TARGET+4),hl
	dec	a
	ld	(VERIFY),a

	call	SKIPSP
	cp	PRINT
	push	af		;verify?
	jr	nz,CLDNZ
	inc	de
CLDNZ:
	call	STRARG
	jr	nz,NOTARGET
	or	a
	jp	z,FCERR

	ld	bc,0006h
	cp	c
	jr	nc,CLDNC
	ld	c,a
CLDNC:
	inc	hl
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ex	de,hl
	ld	de,TARGET
	ldir

NOTARGET:
	call	ROPEN

CLDLP1:
;check header (d3h*10)
	ld	de,0ad3h
	call	CMTSKP

;file name
	ld	hl,FNAME
	ld	b,6
CLDLP2:
	call	GETCMTTR
	ld	(hl),a
	inc	hl
	djnz	CLDLP2

;compare file name
	ld	de,TARGET-1
	ld	hl,FNAME-1
	ld	b,6
CLDLP3:
	inc	de
	inc	hl
	ld	a,(de)
	or	a
	jr	z,CLDFND
	cp	(hl)
	jr	nz,CLDSKIP
	djnz	CLDLP3
	jr	CLDFND

CLDSKIP:
	ld	hl,SKIP
	call	PUTS
	ld	hl,FNAME
	call	PUTS
	call	PRTNL

;check footer (00h*10)
	ld	de,0a00h
	call	CMTSKP
	jr	CLDLP1

CLDFND:
	ld	hl,FOUND
	call	PUTS
	ld	hl,FNAME
	call	PUTS
	call	PRTNL

	pop	af		;verify?
	jr	z,CLDZ1
	call	NEW
	xor	a
	ld	(VERIFY),a
CLDZ1:
	ld	c,a		;c=0: not verify

	ld	hl,(STARTAD)
CLDLP4:
	ld	b,10
CLDLP5:
	call	BLNKAST
	ex	de,hl
	ld	hl,0-0002h
	add	hl,sp
	rst	CPHLDE
	jr	z,CLDOM		;over memory error
	ex	de,hl
	call	GETCMTTR
	inc	c		;c=0: not verify
	dec	c
	jr	z,CLDZ2
	cp	(hl)
	jr	nz,CLDBAD
CLDZ2:
	ld	(hl),a
	inc	hl
	or	a
	jr	nz,CLDLP4
	djnz	CLDLP5
	call	RCLOSE

	ld	(VARAD),hl
	inc	c
	dec	c
	call	z,CLEREND

	ld	hl,(STARTAD)
CLDLP6:
;skip address and line number
	ld	a,(hl)
	inc	hl
	or	(hl)
	jp	z,EDIT
	dec	hl

	ld	d,h
	ld	e,l
	ld	bc,4
	add	hl,bc

;search next line
	xor	a
;	ld	b,a
	ld	c,a
	cpir

;next line address
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ex	de,hl
	jr	CLDLP6

CLDOM:
	call	RCLOSE
	call	NEW
	jp	OMERR

CLDBAD:
	call	RCLOSE
	ld	hl,BAD
	jp	PUTSEDIT


;put characters (in CRT)
;input: hl,(0fa58h)=0:CRT,1:printer,2:RS-232C,80-ff:CMT
;broken: af,hl,(FAC1,bc,de)
_PUTS:	ds	PUTS-_PUTS
	org	PUTS

	ld	a,(hl)
	or	a
	ret	z
	cp	22h		;double quotation mark
	ret	z
	call	PUTDEV
	inc	hl
	jr	PUTS


FOUND:
	db	"Found:",00h

SKIP:
	db	"Skip:",00h

BAD:
	db	"Bad",00h


;put a character in device
;input: a=character, 0fa58h=0:CRT,1:printer,2:RS-232C,80-ff:CMT
;output:none
;broken:af
PUTDEV:
	push	af
	ld	a,(DEVICE)
	or	a
	jr	z,PUTCRT
	dec	a
	jr	z,PUTPRT2
	dec	a
	jr	z,PUT232
	cp	80h-2
	jp	nc,PUTCMT2
	pop	af
	ret

PUTCRT:
	pop	af
	call	PUTC
	ret

;input: a
;output:none
;broken:af
PUT232:
	ld	a,17h		;RTS=0
	out	(81h),a
PUT232LP:
	ld	a,(STOPFLG)
	cp	03h
	jp	z,C_STOP
	in	a,(81h)
	cpl
	and	81h
	jr	nz,PUT232LP	;wait for DSR=1, TxRDY=1

	pop	af
	out	(80h),a

	ld	a,37h		;RTS=1
	out	(81h),a
	ret


;put a character to printer
;input: a
;output:none
;broken:none
PUTPRT:
	push	af
PUTPRT2:
	ld	a,(STOPFLG)
	cp	03h
	jp	z,C_STOP

	ld	a,(GRPFLG)
	or	a
	jr	z,NOTGRP
	xor	a
SETGRP:
	ld	(GRPFLG),a
	pop	af
	ret

NOTGRP:
	pop	af
	push	af

	cp	09h
	jr	z,PUTPRTTAB
	cp	14h
	jr	z,SETGRP
	cp	0dh
	jr	c,PUTPRTC
	push	hl
	ld	hl,PRTPOS
	jr	nz,PUTPRTNZ
	ld	(hl),0ffh
PUTPRTNZ:
	inc	(hl)
	pop	hl

PUTPRTC:
	call	CNVKANA
	call	PRINTER
	pop	af
	ret

;input:	a
;broken:af
PRINTER:
	push	af
	in	a,(0c0h)
	and	02h
	jr	z,PRINTER	;busy
	pop	af
	cpl
	out	(91h),a
	ld	a,01h
	out	(93h),a		;strobe (>1us)
	xor	a
	out	(93h),a
	ret

PUTPRTTAB:
	ld	a,(PRTPOS)
	cpl
	and	07h
	inc	a
	push	bc
	ld	b,a
	ld	a," "
PUTPRTTABLP:
	call	PUTPRT
	djnz	PUTPRTTABLP
	pop	bc
	pop	af
	ret


;convert hiragana -> katakana
;input:	a
;output:a
;broken:f
CNVKANA:
	cp	86h
	ret	c
	cp	0a0h
	jr	c,HIRAGANA
	cp	0e0h
	ret	c
HIRAGANA:
	xor	20h
	ret


;DEF command
C_DEF:
	ld	hl,(LINENUM)
	ld	a,h
	and	l
	inc	a
	jp	z,IDERR
	call	SKIPSP
	cp	FN
	jp	nz,SNERR
	inc	de
	ex	de,hl
	call	CHKVAR
	bit	7,c
	jp	nz,TMERR
	set	7,b
	push	hl		;program address
	call	SRCHVAR
	call	c,MAKEVAR
	pop	de		;program address
	call	CHKLPAR
	ex	de,hl
	call	CHKVAR
	bit	7,c
	jp	nz,TMERR
	ex	de,hl
	call	CHKRPAR
	call	SKIPSP
	cp	EQ
	jp	nz,SNERR
	inc	de
	call	SKIPSP

	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),b
	inc	hl
	ld	(hl),c
;	inc	hl
;	ld	(hl),0

	dec	de
DEFLP:
	inc	de
	call	CHKCLN
	jr	nz,DEFLP

	ld	(PROGAD),de
	ret


;POKE command
C_POKE:
	call	NUMARGMO
	push	de
	call	FTOI
	pop	de
	ld	a,(de)
	cp	","
	jp	nz,SNERR
	inc	de
	push	hl		;
	call	NUMARGMO
	call	FTOI1
	ld	a,l
	pop	hl		;
	ld	(hl),a
	ret


;CSAVE command
C_CSV:
	call	STRARG
	jp	nz,MOERR
	or	a
	jp	z,FCERR

	inc	hl
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)

	ld	hl,0
	ld	(TARGET),hl
	ld	(TARGET+2),hl
	ld	(TARGET+4),hl

	ld	bc,0006h
	cp	c
	jr	nc,CSVNC
	ld	c,a
CSVNC:
	ex	de,hl
	ld	de,TARGET
	ldir

	call	WOPEN

;write header (d3h*10)
	ld	b,10
CSVLP1:
	ld	a,0d3h
	call	PUTCMT
	djnz	CSVLP1

;file name
	ld	hl,TARGET
	ld	b,6
CSVLP2:
	ld	a,(hl)
	call	PUTCMT
	inc	hl
	djnz	CSVLP2

;data
	ld	hl,(STARTAD)
	ld	de,(VARAD)
CSVLP4:
	ld	a,(hl)
	call	PUTCMT
	inc	hl
	rst	CPHLDE
	jr	nz,CSVLP4

;footer (00h*9)
CSVEND:
	ld	b,9
CSVLP6:
	xor	a
	ld	(DEVICE),a
	call	PUTCMT
	djnz	CSVLP6

	call	WCLOSE
	ret


;EXEC command
C_EXEC:
	call	NUMARGMO
	call	FTOI
	call	JPHL
	ret

JPHL:
	jp	(hl)


;SOUND command
C_SOUN:
	call	CHKCLN
	jp	z,SNERR
	call	INT1ARG
	cp	16
	jp	nc,FCERR
	push	af
	ld	a,(de)
	cp	","
	jp	nz,SNERR
	inc	de
	call	INT1ARG
	pop	af
	ld	e,l
	call	SOUND
	ret


;PLAY command
C_PLAY:
	ex	de,hl
	call	PLAY
	ld	(PROGAD),hl
	ret


;KEY command
C_KEY:
	call	INT1ARG
	cp	11
	jp	nc,FCERR
	ld	a,l
	add	a,a		;*2
	add	a,a		;*4
	add	a,a		;*8
	ld	l,a
	push	de
	ld	de,FNCKEY-8
	add	hl,de
	pop	de
	ld	a,(de)
	cp	","
	jp	nz,SNERR
	push	hl		;
	inc	de
	call	STRARG
	jp	nz,MOERR
	inc	hl
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ex	de,hl
	pop	de		;
	or	a
	jr	z,KEYZ

	cp	9
	jr	c,KEYOK
	ld	a,8
KEYOK:
	ld	c,a
	ld	b,0
	ldir
KEYZ:
	sub	8
	ret	nc
	neg
	ld	b,a
	xor	a
KEYLP:
	ld	(de),a
	djnz	KEYLP
;	call	PRTFKEY
	ret


;LCOPY command
C_LCPY:
	ld	hl,LCPYHD
	ld	b,5
LCPYLP1:
	ld	a,(hl)
	call	PRINTER
	inc	hl
	djnz	LCPYLP1

	ld	hl,(VRAM-1)
	inc	h
	inc	h
	ld	l,0
	ld	a,(SCREEN1)
	cp	2
	jr	c,LCPYTXT

LCPYGRP:
	ld	de,1800h
LCPYLP2:
	xor	a
	ld	c,(hl)
	call	SENDGRP
	inc	hl
	dec	de
	ld	a,d
	or	e
	jr	nz,LCPYLP2

LCPYEND:
	ld	b,20h
LCPYLP3:
	xor	a
	call	PRINTER
	djnz	LCPYLP3

	ld	b,6
LCPYLP4:
	ld	a,0ah
	call	PRINTER
	djnz	LCPYLP4
	ret

;header for lcopy
LCPYHD:
	db	20h,20h,0ah,1dh,0c1h

LCPYTXT:
	ld	a,04h
	out	(93h),a		;CGROM ON
	ld	b,10h
LCPYTLP1:
	push	bc
	ld	c,0ch
LCPYTLP2:
	ld	b,COLUMNS
LCPYTLP3:
	ld	a,(hl)
	rlca
	rlca
	rlca
	rlca
	ld	d,a
	and	0f0h
	add	a,0ch
	sub	c
	ld	e,a
	ld	a,d
	and	0fh
	add	a,60h
	ld	d,a
	ld	a,(de)
	push	bc
	ld	c,a

	dec	h
	dec	h
	ld	a,(hl)		;attribute
	inc	h
	inc	h

	bit	5,a
	jr	nz,LCPYSEMI
	rrca
	jr	nc,NOTREV
	ld	a,c
	cpl
	ld	c,a
NOTREV:
	call	SENDGRP
	pop	bc
	inc	hl
	djnz	LCPYTLP3
	ld	de,0-COLUMNS
	add	hl,de
	dec	c
	jr	nz,LCPYTLP2
	ld	de,COLUMNS
	add	hl,de
	pop	bc
	djnz	LCPYTLP1
	ld	a,05h
	out	(93h),a		;CGROM OFF
	jr	LCPYEND

LCPYSEMI:
	pop	bc
	push	bc
	ld	a,c
	cp	5
	ld	a,(hl)
	jr	c,SEMI14
	ld	a,c
	cp	9
	ld	a,(hl)
	jr	c,SEMI58

	rrca
	rrca
SEMI58:
	rrca
	rrca
SEMI14:
	and	03h
	push	hl
	ld	hl,LCPYTBL
	add	a,l
	ld	l,a
	jr	nc,SEMINC
	inc	h
SEMINC:
	ld	c,(hl)
	pop	hl
	jr	NOTREV

;c=	9-12	xx**xxxx
;	5-8	xxxx**xx
;	1-4	xxxxxx**

LCPYTBL:		
	db	00h,0fh,0f0h,0ffh

;send graphic data to PC-6021
;input:	c
;broken:af,b
SENDGRP:
	ld	b,8
SENDGLP:
	rl	c
	rra
	djnz	SENDGLP
	call	PRINTER
	ret


;NEW command
C_NEW:
	call	NEW
	call	CLEREND
	jp	EDIT

NEW:
	ld	hl,(BASICAD)
	xor	a
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	ld	(VARAD),hl
	ret


;FN() function
C_FN:
	ex	de,hl
	call	CHKVAR
	push	hl		;program address
	set	7,b
	call	SRCHVAR
	jp	c,UFERR
	pop	de		;program address
	push	hl		;function address
	call	FNCNUM
	pop	bc		;function address
	push	de		;program address

;push old FN() argument
	ld	hl,(FNARG+3)
	push	hl
	ld	hl,(FNARG+1)
	push	hl
	ld	a,(FNARG)
	push	af
	ld	hl,(FNPAR)
	push	hl		;old FN() parameter

	push	bc		;function address
	ld	hl,FAC1
	ld	de,FNARG
	ld	bc,5
	ldir
	pop	hl		;function address

	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	a,(hl)
	inc	hl
	ld	h,(hl)
	ld	l,a
	ld	(FNPAR),hl

	call	ARG

	pop	hl		;old FN() parameter
	ld	(FNPAR),hl

;pop old FN() argument
	pop	af
	ld	(FNARG),a
	pop	hl
	ld	(FNARG+1),hl
	pop	hl
	ld	(FNARG+3),hl

	pop	de		;program address
	pop	hl		;cancel return address

	jp	CHKSTRBCK


;INKEY$
C_INKY:
	call	GETC
	jr	z,INKYZ
	ld	b,a
INKYNZ:
	ld	a,1
	ld	(STRDSC1),a
	ld	hl,(STRAD)
	ld	de,(STACK)
	rst	CPHLDE
	jr	nz,INKYOK

	push	de
	push	bc
	call	GC
	pop	bc
	pop	de

	ld	hl,(STRAD)
	rst	CPHLDE
	jp	z,OSERR

INKYOK:
	ld	(hl),b
	ld	(STRDSC1+2),hl
	dec	hl
	ld	(STRAD),hl

INKYEND:
	ld	hl,STRDSC1
	ld	(FAC1+1),hl
	ld	a,1
	ld	(ARGTYP),a
	ret

INKYZ:
	xor	a
	ld	(STRDSC1),a
	jr	INKYEND


;not x = -(x+1)
C_NOT:
	ld	a,(ARGTYP)
	or	a
	jp	nz,TMERR
	call	EXFAC
	call	INT
	ld	hl,PLSONE
	call	SETF2
	call	ADDF
	ld	hl,FAC1+3
	ld	a,(hl)
	xor	80h
	ld	(hl),a
	ret


C_PLS:
	ld	a,(ARGTYP)
	or	a
	jr	nz,PLSSTR
	call	ADDF
	ret

PLSSTR:
	cp	3
	jp	nz,TMERR
ADDSTR:
	ld	hl,STRDSC1
	ld	c,(hl)
	ld	a,(STRDSC2)
	ld	b,a
	add	a,c
	jp	c,LSERR		;over 255 characters
	ld	(hl),a

	ld	hl,(STRAD)
	ld	d,0
	ld	e,a
	or	a
	sbc	hl,de
	ld	de,(STACK)
	rst	CPHLDE
	jr	nc,ADDSTROK

	push	bc
	call	GC
	pop	bc
	ld	hl,(STRAD)
	ld	a,b
	add	a,c
	ld	d,0
	ld	e,a
	or	a
	sbc	hl,de
	ld	de,(STACK)
	rst	CPHLDE
	jp	c,OSERR

ADDSTROK:
	ld	(STRAD),hl
	inc	hl
	ex	de,hl
	ld	hl,(STRDSC1+2)
	ld	(STRDSC1+2),de

	ld	a,c
	or	a
	ld	a,b
	ld	b,0
	jr	z,ADDSZ1
	ldir
ADDSZ1:
	or	a
	jr	z,ADDSZ2
	ld	c,a
	ld	hl,(STRDSC2+2)
	ldir
ADDSZ2:
	ld	a,1
	ld	(ARGTYP),a

	ld	hl,(STRBCK2+2)
	ld	a,h
	or	l
	jp	nz,STERR
	ret


C_MNS:
	ld	a,(ARGTYP)
	or	a
	jp	nz,TMERR
	call	SUBF
	ret


C_MUL:
	ld	a,(ARGTYP)
	or	a
	jp	nz,TMERR
	call	MULF
	ret


C_DIV:
	ld	a,(ARGTYP)
	or	a
	jp	nz,TMERR
	call	DIVF
	ret


C_POW:
	ld	a,(ARGTYP)
	or	a
	jp	nz,TMERR
	call	PUSHF2		;y
	call	LOG		;log(x)
	call	POPF2		;y
	call	MULF		;ylog(x)
	call	EXP		;x^y=exp(ylog(x))
	ret


C_AND:
	call	F12TOI2
	ld	a,l
	and	e
	ld	l,a
	ld	a,h
	and	d
	ld	h,a
	call	S2TOF
	ret


C_OR:
	call	F12TOI2
	ld	a,l
	or	e
	ld	l,a
	ld	a,h
	or	d
	ld	h,a
	call	S2TOF
	ret


C_GT:
C_LT:
	ld	a,c
	xor	80h
	ld	c,a
	ld	a,(ARGTYP)
	rrca
	jr	c,CMPSTR

	call	CMPF
	jr	z,EQLPEND
	rla
GTLTEND:
	rrc	c
	xor	c
	rrca
	jr	nc,SETTRUE	;>(11010001b),<(11010011b)
	jr	SETFALSE

CMPSTR:
	push	bc		;c=operator
	rlca
	jp	nc,TMERR
	xor	a
	ld	(ARGTYP),a
	ld	de,(STRDSC1+2)
	ld	hl,(STRDSC2+2)
	ld	a,(STRDSC1)
	ld	b,a
	ld	a,(STRDSC2)
	or	b
	jr	z,CMPSEQ
	cp	b
	jr	nc,CMPSLP
	ld	b,a
CMPSLP:
	ld	a,(de)
	cp	(hl)
	jr	nz,CMPSNZ
	inc	de
	inc	hl
	djnz	CMPSLP
	ld	a,(STRDSC1)
	ld	hl,STRDSC2
	cp	(hl)
	jr	nz,CMPSNZ
CMPSEQ:
	pop	bc		;c=operator
	jr	EQLPEND	
CMPSNZ:
	pop     bc		;c=operator
	rla
	jr	GTLTEND


C_EQ:
	ld	de,FAC1
	ld	hl,FAC2
	ld	b,5
	ld	a,(ARGTYP)
	or	a
	jr	z,EQLP
;compare string
	cp	3
	jp	nz,TMERR
	xor	a
	ld	(ARGTYP),a
	ld	a,(STRDSC1)
	ld	b,a
	ld	a,(STRDSC2)
	cp	b
	jr	nz,EQLPEND
	or	b
	jr	z,EQLPEND
	ld	de,(STRDSC1+2)
	ld	hl,(STRDSC2+2)
EQLP:
	ld	a,(de)
	cp	(hl)
	jr	nz,EQLPEND
	inc	de
	inc	hl
	djnz	EQLP
EQLPEND:
	ld	a,c		;operator
	rlca
	jr	nz,EQNZ
	ccf
EQNZ:
	jr	nc,SETTRUE
;	jr	SETFALSE


SETFALSE:
SETZERO:
	ld	hl,ZERO
	jr	SETF1

SETTRUE:
SETMNS1:
	ld	hl,TRUE
SETF1:
	ld	de,FAC1
SETF:
	ld	bc,5
	ldir
	ret

SETF2:
	ld	de,FAC2
	jr	SETF


;SGN() function
C_SGN:
	call	FNCNUM
	ld	a,(FAC1+4)
	or	a
	jr	z,SETZERO
	ld	a,(FAC1+3)
	rlca
	jr	c,SETMNS1
	jp	SETPLS1


;INT() function
C_INT:
	call	FNCNUM
INT:
	call	CPYFAC
	call	GETINT
	ld	a,(FAC2+3)
	rlca
	ret	nc
	call	CMPF
	ret	z
	ld	hl,MNSONE
	call	SETF2
	call	ADDF
	ret


;ABS() function
C_ABS:
	call	FNCNUM
	ld	hl,FAC1+3
	res	7,(hl)
	ret


;USR() function
C_USR:
	call	FNCNUM
	ld	hl,(USRAD)
	call	JPHL
	ret


;FRE() function
C_FRE:
	call	CHKLPAR
	call	ARG
	call	CHKRPAR
	ld	a,(ARGTYP)
	or	a
	jr	z,FRENUM
	dec	a
	jp	nz,SNERR
;string
FRESTR:
	call	GC
	ld	hl,(STRAD)
	ld	de,(STACK)
	jr	CALCFRE
;numeric
FRENUM:
	ld	hl,0
	add	hl,sp
	ld	de,(FREEAD)
CALCFRE:
	sbc	hl,de		;c-flag=0
	call	I2TOF
	jp	SETTYP0


;INP() function
C_INP:
	call	FNCI1
	ld	b,h		;h=0
	ld	c,l
	in	l,(c)
	call	I2TOF		;h=0
	ret


;SQR() function
;y_n+1=(y_n + x/y_n)/2
C_SQR:
	call	FNCNUM
	ld	a,(FAC1+3)
	rlca
	jp	c,FCERR		;sqr(-x)
	ld	de,FAC1+4
	ld	a,(de)
	or	a
	ret	z		;sqr(0)=0
	call	PUSHF1		;x
	ld	a,(de)
	sub	81h
	rra			;=sra a, c-flag=bit7
	add	a,81h
	ld	(de),a		;exponent of y_0 = (exponent of x)/2

	ld	b,5
SQRLP:
	push	bc
	call	CPYFAC
	call	POPF1		;x
	call	PUSHF1		;x
	call	PUSHF2		;;y
	call	DIVF		;x/y
	call	POPF2		;;y
	call	ADDF		;x/y+y
	ld	hl,FAC1+4
	dec	(hl)		;y=(x/y+y)/2
	jp	z,OVERR
	pop	bc
	djnz	SQRLP
	call	POPF2
	ret


;RND() function
C_RND:
	call	FNCNUM
	ld	a,(FAC1+4)
	or	a
	jr	z,RND0		;rnd(0)
	ld	a,(FAC1+3)
	rlca
	jr	c,RNDMNS	;rnd(-x)
RNDPLS:				;rnd(+x)
	ld	hl,RSEED
	ld	de,FAC1
	ld	bc,4
	ldir
RNDMNS:
	call	DECINT4
	ld	hl,RNDFCT
	ld	de,FAC2
	ld	bc,4
	ldir
	call	MULRND
RND0:
	ld	hl,RSEED
	ld	de,FAC1
	ld	bc,4
	ldir

	ld	hl,(FAC1)
	ld	c,l
	ld	a,h
	ld	hl,(FAC1+2)
	ld	b,16
RNDLP:
	bit	7,h
	jr	nz,RNDNZ
	sla	c
	rla
	adc	hl,hl
	djnz	RNDLP
RNDNZ:
	res	7,h
	ld	(FAC1+2),hl
	ld	l,c
	ld	h,a
	ld	(FAC1),hl
	ld	a,80h-16
	add	a,b
	ld	(FAC1+4),a
	ret

RNDFCT:
	db	65h,52h,0fh,00h


;LOG() function
;log(x)=log(a*2^n)=log(a)+n*log(2)
;a'=(a-1)/(a+1)
;log(a)=2*(a'+a'^3/3+a'^5/5+...)=2a'(1+1/3*a'^2(1+3/5*a'^2(...(1+17/19*a'^2))))))))))
C_LOG:
	call	FNCNUM
LOG:
	ld	hl,FAC1+3
	ld	a,(hl)
	rlca
	jp	c,FCERR		;x<0
	inc	hl
	ld	a,(hl)
	or	a
	jp	z,FCERR		;x=0
	sub	81h
	push	af		;n
	ld	(hl),81h	;a
	call	PUSHF1		;a
	ld	hl,PLSONE
	call	SETF2
	call	ADDF		;a+1
	call	POPF2		;a
	call	PUSHF1		;a+1
	call	SETMNS1
	call	ADDF		;a-1
	call	POPF2		;a+1
	call	DIVF		;a'=(a-1)/(a+1)
	call	PUSHF1		;a'
	call	CPYFAC
	call	MULF		;a'^2
	call	PUSHF1		;a'^2
	call	SETPLS1		;y

	ld	b,20
LOGLP:
	call	POPF2		;a'^2
	call	PUSHF2		;a'^2
	push	bc
	call	MULF		;y*a'^2
	call	CPYFAC
	pop	bc
	inc	b
	ld	l,b
	push	bc
	call	I1TOF
	call	EXFAC
	call	DIVF		;y*a'^2/b
	call	CPYFAC
	pop	bc
	dec	b
	dec	b
	ld	l,b
	push	bc
	call	I1TOF		;b-2
	call	MULF		;y*a'^2*(b-2)/b
	ld	hl,PLSONE
	call	SETF2
	call	ADDF		;y=1+y*a'^2*(b-2)/b
	pop	bc
	djnz	LOGLP

	call	POPF2		;a'^2
	call	POPF2		;a'
	call	MULF		;a'*y
	ld	hl,FAC1+4
	ld	a,(hl)
	or	a
	jr	z,LOGZ
	inc	(hl)		;2*a'*y
	jp	z,OVERR
LOGZ:
	pop	bc		;b=n
	call	PUSHF1		;2*a'*y
	ld	l,b
	call	S1TOF
	ld	hl,LOG2
	call	SETF2
	call	MULF		;n*log(2)
	call	POPF2		;2*a'*y
	call	ADDF		;n*log(2)+2*a'*y
	ret


;TAN() function
;tan(x)=sin(x)/cos(x)
C_TAN:
	call	FNCNUM
	call	PUSHF1		;x
	call	COS		;cos(x)
	call	CPYFAC
	call	POPF1		;x
	call	PUSHF2		;cos(x)
	call	SIN		;sin(x)
	call	POPF2		;cos(x)
	call	DIVF		;sin(x)/cos(x)
	ret


;EXP() function
;exp(x)=2^n*e^a, n=[x/log2], a=x-n*log2
C_EXP:
	call	FNCNUM
EXP:
	call	PUSHF1		;x
	ld	hl,LOG2
	call	SETF2
	call	DIVF		;x/log2
	ld	a,(FAC1+3)
	rlca
	jr	nc,EXPPLS
	ld	a,(FAC1+4)
	cp	88h
	jr	nc,EXPZERO
	ld	hl,MNSONE
	call	SETF2
	call	ADDF		;x/log2-1 if x<0
EXPPLS:
	call	GETINT		;n=[x/log2]
	call	POPF2		;x
	call	FTOI
	push	hl		;;;n
	call	PUSHF2		;x
	ld	hl,LOG2
	call	SETF2
	call	MULF		;n*log2
	call	CPYFAC
	call	POPF1		;x
	call	SUBF		;a=x-n*log2

;1+a(1+a/2(1+a/3(1+...(1+a/10))))))))))
	ld	hl,PLSONE
	call	SETF2
	ld	b,10
EXPLP:
	call	PUSHF1		;a
	push	bc
	call	MULF		;a*y
	call	CPYFAC
	pop	bc
	ld	l,b
	push	bc
	call	I1TOF
	call	EXFAC
	call	DIVF		;a*y/b
	ld	hl,PLSONE
	call	SETF2
	call	ADDF		;y=a*y/b+1
	call	CPYFAC
	pop	bc
	call	POPF1		;a
	djnz	EXPLP

	pop	hl		;;;n
	ld	a,(FAC2+4)	;=81h?
	ld	d,0
	ld	e,a
	add	hl,de
	ld	a,h
	or	a
	jp	nz,OVERR
	ld	a,l
	or	a
	jp	z,OVERR
	ld	(FAC2+4),a	;e^a*2^n
	call	EXFAC
	ret

EXPZERO:
	call	POPF1
	jp	SETZERO

LOG2:
	db	0f8h,17h,72h,31h,80h


;COS() function
;cos(x)=sin(x+pi/2)
C_COS:
	call	FNCNUM
COS:
	ld	hl,PIDIV2
	call	SETF2
	call	ADDF		;x+pi/2
	call	SIN
	ret

PIDIV2:
	db	0a2h,0dah,0fh,49h,81h


;SIN() function
;x-x^3/3!+x^5/5!-...=x(1-x^2/(2*3)(1-x^2/(4*5)(...(1-x^2/(20*21)))))))))))
C_SIN:
	call	FNCNUM
SIN:
	call	PUSHF1		;x
	ld	hl,PI2
	call	SETF2
	call	PUSHF2		;2pi
	call	DIVF		;x/2pi
	call	GETINT		;int(x/2pi)
	call	POPF2		;2pi
	call	MULF		;int(x/2pi)*2pi
	call	CPYFAC
	call	POPF1		;x
	call	SUBF		;x'=x-int(x/2pi)*2pi
	call	PUSHF1		;x'
	call	CPYFAC
	call	MULF
	call	PUSHF1		;x'^2
	call	SETPLS1		;y=1

	ld	b,20
SINLP:
	call	CPYFAC		;y
	ld	l,b
	push	bc
	call	I1TOF		;b
	call	EXFAC
	call	DIVF		;y/b
	call	CPYFAC
	pop	bc
	inc	b
	ld	l,b
	push	bc
	call	I1TOF		;b+1
	call	EXFAC
	call	DIVF		;y/b/(b+1)

	pop	bc
	call	POPF2		;x'^2
	call	PUSHF2		;x'^2
	push	bc
	call	MULF		;x'^2/b/(b+1)*y
	call	CPYFAC
	call	SETPLS1
	call	SUBF		;y=1-x'^2/b/(b+1)*y
	pop	bc
	dec	b
	dec	b
	djnz	SINLP

	call	POPF2		;x'^2
	call	POPF2		;x'
	call	MULF

;if |sin(x)|>1
	ld	a,(FAC1+4)
	sub	81h
	ret	nz
	ld	(FAC1),a
	ret

PI2:
	db	0a2h,0dah,0fh,49h,83h


;PEEK() function
C_PEEK:
	call	FNCNUM
	call	FTOI
	ld	l,(hl)
	call	I1TOF
	ret


;LPOS() function
C_LPOS:
	call	CHKLPAR
	call	ARG
	call	CHKRPAR
	ld	a,(ARGTYP)
	cp	2
	jp	nc,SNERR
	ld	hl,(PRTPOS)
	jr	SETI1


;POS() function
C_POS:
	call	CHKLPAR
	call	ARG
	call	CHKRPAR
	ld	a,(ARGTYP)
	cp	2
	jp	nc,SNERR
	ld	hl,(CSRX)
	dec	l
	jr	SETI1


;LEN() function
C_LEN:
	call	FNCSTR
	ld	l,a
SETI1:
	call	I1TOF
SETTYP0:
	xor	a
	ld	(ARGTYP),a	;0=numeric
	ret


;STR$() function
C_STR:
	call	FNCNUM
	call	FTOA
	ld	(STRDSC1+2),hl

	ld	b,0-1
STRLP:
	inc	b
	ld	a,(hl)
	inc	hl
	or	a
	jr	nz,STRLP

	ld	a,b
	ld	(STRDSC1),a
	xor	a
	ld	(STRDSC2),a
	call	ADDSTR
	jp	INKYEND


;VAL() function
C_VAL:
	call	FNCSTR
	inc	hl
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	call	ATOF
	jr	SETTYP0


;ASC() function
C_ASC:
	call	FNCSTR
	or	a
	jp	z,FCERR
	inc	hl
	inc	hl
	ld	a,(hl)
	inc	hl
	ld	h,(hl)
	ld	l,a
	ld	l,(hl)
	jr	SETI1


;CHR$() function
C_CHR:
	call	FNCI1
	ld	b,l
	jp	INKYNZ


;LEFT$() function
C_LEFT:
	call	ARGSI1
	ld	c,1
	jr	MID


;RIGHT$() function
C_RHT:
	call	ARGSI1
	ld	a,(de)
	ld	h,a		;
	sub	l
	jr	nc,RHTNC
	xor	a
RHTNC:
	inc	a
	ld	c,a
	ld	l,h		;
	jr	MID


;MID$() function
C_MID:
	call	ARGSI1
	push	de		;string descriptor address
	ld	de,(PROGAD)

	ld	c,l
	ld	a,c
	or	a
	jp	z,FCERR
	ld	l,0ffh
	ld	a,(de)
	cp	","
	jr	nz,MIDNZ
	inc	de
	push	bc
	call	INT1ARG
	pop	bc
MIDNZ:
	pop	de		;string descriptor address

;de=string descriptor address, c=1st arg, l=2nd arg
MID:
	ld	a,(de)
	sub	c
	jr	c,NULLSTR
	inc	a
	cp	l
	jr	c,MIDC
	ld	a,l
MIDC:
	ld	(STRDSC1),a
	inc	de
	inc	de
	ld	a,(de)
	ld	l,a
	inc	de
	ld	a,(de)
	ld	h,a
	dec	c
	add	hl,bc
	ld	(STRDSC1+2),hl
	xor	a
	ld	(STRDSC2),a
	call	ADDSTR
MIDEND:
	ld	de,(PROGAD)
	call	CHKRPAR
	call	INKYEND
	ret

NULLSTR:
	xor	a
	ld	(STRDSC1),a
	jr	MIDEND


;POINT() function
C_POIN:
	call	GETXY
	call	POINT
	ld	l,a
	call	I1TOF
	ret


;input: bc=X, hl=Y
;output: a=color
;broken: f,bc,de,hl
POINT:
	ld	a,(SCREEN1)
	dec	a
	jr	z,POINT2
	jp	m,POINT1
	dec	a
	jr	z,POINT3

POINT4:
	call	GETADG34
	ld	a,d
	ld	e,(hl)
POINT4LP:
	cp	00000001b
	jr	z,POINT4OK
	rrca
	srl	e
	jr	POINT4LP
POINT4OK:
	and	e
	ret

POINT3:
	call	GETADG34
	ld	a,d
	ld	e,(hl)
POINT3LP:
	cp	00000011b
	jr	z,POINT3OK
	rrca
	rrca
	srl	e
	srl	e
	jr	POINT3LP

POINT3OK:
	and	e
	inc	a
	ret

POINT2:
	push	bc		;x
	call	GETADG
	pop	bc		;x
	call	DOTBIT2
	ld	b,(hl)		;
	inc	h
	inc	h
	ld	c,(hl)
	and	c
	ret	z
	ld	a,(hl)
	and	0c0h
	rlca
	rlca
	inc	a
	ld	c,a
	ld	a,b		;
	and	02h
	rlca
	add	a,c
	ret

POINT1:
	call	GETADG
	ld	a,(hl)
	sub	20h
	inc	a
	ret


;CSRLINE function
C_CSRL:
	ld	hl,(CSRY)
	dec	l
	call	I1TOF
	ret


;STICK() function
C_STCK:
	call	FNCI1
	ld	a,l
	or	a
	jr	z,STCK0
	cp	3
	jp	nc,FCERR
	call	JOYSTK
;exchange bit2 and bit3
	ld	b,a
	and	0ch
	ld	a,b
	jp	pe,CNVSTCK
	xor	0ch
	jr	CNVSTCK

STCK0:
	call	STICK
	rrca
	rrca
CNVSTCK:
	and	0fh
	ld	hl,STCKTBL
	add	a,l
	ld	l,a
	jr	nc,STCKNC
	inc	h
STCKNC:
	ld	l,(hl)
	call	I1TOF
	ret

STCKTBL:
;		    u   d   ud  r   ur  dr  udr
	db	0,  1,  5,  0,  3,  2,  4,  0
;		l   ul  dl  udl rl url drl udrl
	db	7,  8,  6,  0,  0,  0,  0,  0


;STRIG() function
C_STRG:
	call	FNCI1
	ld	a,l
	or	a
	jr	z,STRG0
	cp	3
	jp	nc,FCERR
	call	JOYSTK
	and	10h
	jp	z,SETZERO
	jr	SETPLS1

STRG0:
	call	STICK
	rlca
	jp	nc,SETZERO
SETPLS1:
	ld	hl,PLSONE
	jp	SETF1


;TIME function
C_TIME:
	ld	hl,(TIME)
	ld	de,(TIME+2)
	call	I4TOF
	ret


;SCREEN() function
;not called but jumped
FNCSCRN:
	call	CHKLPAR
	call	INT1ARG
	ld	a,(de)
	cp	","
	jp	nz,SNERR
	inc	de
	push	hl		;
	call	INT1ARG
	call	CHKRPAR
	pop	bc		;
	ld	h,c
	inc	h
	inc	l
	call	GETAD
	ld	l,(hl)
	call	I1TOF
	jp	FNCRTN


;convert string to float
;input: a=max length, de=program address
;output: FAC1, de=next address (except for VAL())
;broken: FAC2, af,bc,hl
ATOF:
	or	a
	jp	z,SETZERO
	ld	b,a
ATOFLP1:
	ld	a,(de)
	inc	de
	cp	"&"
	jp	z,ATOFHEX
	cp	" "
	jr	nz,ATOFMAIN
	djnz	ATOFLP1
	jp	SETZERO

ATOFMAIN:
	dec	de
	ld	a,b
	call	ATOIF
	push	bc		;c=sign
	ld	a,b
	or	a
	jr	z,ATOFSGN

	ld	c,0		;after-dot counter
ATOFLP2:
	ld	a,(de)
	inc	de
	cp	"."
	jr	z,ATOFLP3
	cp	"E"
	jr	z,E10
	cp	"e"
	jr	z,E10
	cp	" "
	jr	nz,ATOFNZ
	djnz	ATOFLP2
	jr	ATOFSGN

ATOFLP3:
	call	CTOF
	jr	nc,ATOFDIV
	inc	c
	djnz	ATOFLP3

ATOFDIV:
	ld	a,c
	or	a
	jr	z,AFTRDOT
	push	de		;program address
ATOFLP4:
	push	bc
	call	DIVF10
	pop	bc
	dec	c
	jr	nz,ATOFLP4
	pop	de		;program address

AFTRDOT:
	ld	a,b
	or	b
	jr	z,ATOFSGN
ATOFLP5:
	ld	a,(de)
	inc	de
	cp	"E"
	jr	z,E10
	cp	"e"
	jr	z,E10
	cp	" "
	jr	nz,ATOFNZ
	djnz	ATOFLP5
	jr	ATOFSGN

E10:
	call	PUSHF1
	call	ATOIF
	call	POPF2
	ld	a,(FAC2+4)
	or	a
	jr	z,E10ZERO
	call	PUSHF2

	ld	a,c		;sign of exponent
	or	a
	jr	z,E10PLS
	ld	hl,FAC1+3
	set	7,(hl)
E10PLS:
	push	de
	ld	hl,LOG10
	call	SETF2
	call	MULF
	call	EXP
	pop	de
	call	POPF2
	push	de
	call	MULF
	pop	de
	inc	de

ATOFNZ:
	dec	de

ATOFSGN:
	pop	bc		;sign
	ld	a,c
	or	a
	ret	z
	ld	hl,FAC1+3
	set	7,(hl)
	ret

E10ZERO:
	pop	bc		;cancel sign
	call	EXFAC		;set FAC1=0
	ret

ATOFHEX:
	dec	de
	dec	b
	call	HEX
	call	S2TOF
	ret

LOG10:
	db	0deh,8dh,5dh,13h,82h


;convert string to float (integer part)
;input: a=length, de=program address
;output: FAC1, de=next address, b=remained length, c=sign(0:+ 1:-)
;broken: FAC2, af,bc,hl
ATOIF:
	push	de
	call	SETZERO
	pop	de
	ld	b,a
	ld	c,0		;sign

ATOIFLP1:
	ld	a,(de)
	inc	de
	cp	"+"
	jr	z,ATOIFLP2
	cp	PLUS
	jr	z,ATOIFLP2
	inc	c
	cp	"-"
	jr	z,ATOIFLP2
	cp	MINUS
	jr	z,ATOIFLP2
	dec	c
	cp	" "
	jr	nz,ATOIFNZ
	djnz	ATOIFLP1
	ret			;all space

ATOIFNZ:
	dec	de
ATOIFLP2:
	call	CTOF
	ret	nc
	djnz	ATOIFLP2
	ret


;FAC1 = FAC1 * 10 + [0-9]
;input: FAC1, de=program address
;output: FAC1, c-flag(1=OK), b=b-1, de=next address
;broken: af,hl
CTOFLP:
	inc	de
CTOF:
	ld	a,(de)
	cp	" "
	jr	z,CTOFLP
	sub	"0"
	cp	"9"-"0"+1
	ret	nc
	inc	de

	push	bc
	push	de		;program address
	push	af
	call	MULF10
	call	CPYFAC
	pop	af
	ld	l,a
	call	I1TOF
	call	ADDF
	pop	de		;program address
	pop	bc
	scf
	ret


;FAC1 = FAC1 * 0.1
;input: FAC1
;output: FAC1
;broken: FAC2,af,bc,de,hl

DIVF10:
	ld	hl,0cccdh
	ld	(FAC2),hl
	ld	hl,4ccch
	ld	(FAC2+2),hl
	ld	a,7dh
	ld	(FAC2+4),a
	call	MULF
	ret

;	ld	hl,EM1
;	call	SETF2
;	call	MULF
;	ret


;FAC1 = FAC1 * 10
;input: FAC1
;output: FAC1
;broken: FAC2,af,bc,de,hl
MULF10:
	ld	hl,0000h
	ld	(FAC2),hl
	ld	h,20h
	ld	(FAC2+2),hl
	ld	a,84h
	ld	(FAC2+4),a
	call	MULF
	ret

;	call	CPYFAC
;	ld	l,10
;	call	I1TOF
;	call	MULF
;	ret


;compare FAC2 to FAC1
;input: FAC1,FAC2
;output: f
;broken: a,b,de,hl
CMPF:
	ld	de,FAC1+3
	ld	hl,FAC2+3
	ld	a,(hl)
	rlca
	ld	a,(de)
	jr	c,CMPFNEG2
	rlca
	ret	c

CMPFPOS:
	inc	de
	inc	hl
	ld	b,5
CMPFLP:
	ld	a,(de)
	cp	(hl)
	ret	nz
	dec	hl		;no changes in flag
	dec	de		;no changes in flag
	djnz	CMPFLP		;no changes in flag
	ret

CMPFNEG2:
	rlca
	ret	nc

;FAC1<0, FAC2<0
	ex	de,hl
	jr	CMPFPOS


;FAC1 = FAC1 - FAC2
;input: FAC1,FAC2
;output: FAC1
;broken: FAC2,af,b,de,hl
SUBF:
	ld	hl,FAC2+3
	ld	a,(hl)
	xor	80h
	ld	(hl),a
;	call	ADDF
;	ret


;FAC1 = FAC1 + FAC2
;input: FAC1,FAC2
;output: FAC1
;broken: FAC2,af,b,de,hl
ADDF:
	ld	a,(FAC2+4)
	or	a
	ret	z
	ld	a,(FAC1+4)
	or	a
	jr	nz,NOTZERO
	call	PUSHF2
	call	POPF1
	ret
NOTZERO:
	ld	hl,FAC1+3
	ld	a,(hl)
	rlca
	jr	c,ADDNEG1
	set	7,(hl)
	xor	a
	jr	SETSGN1
ADDNEG1:
	call	NEGINT4
	ld	a,11b
SETSGN1:
	ld	(TMP),a
	ld	hl,FAC2+3
	ld	a,(hl)
	rlca
	jr	c,ADDNEG2
	set	7,(hl)
	xor	a
	jr	SETSGN2
ADDNEG2:
	call	EXFAC
	call	NEGINT4
	call	EXFAC
	ld	a,11b
SETSGN2:
	ld	(TMP+1),a

;exponent part
	ld	a,(FAC2+4)
	ld	b,a
	ld	a,(FAC1+4)
	sub	b
	jr	z,SAME		;FAC1 exponent = FAC2 exponent
	jr	nc,ADD1GT2
	call	EXFAC
	neg
	ld	hl,(TMP)	;l=(TMP), h=(TMP+1)
	ld	b,h
	ld	h,l
	ld	l,b
	ld	(TMP),hl
ADD1GT2:			;FAC1 exponent > FAC2 exponent
;	cp	32
;	jr	nc,		;FAC1 >> FAC2
	ld	hl,(FAC2)
	ld	de,(FAC2+2)
	ld	b,a
ADDFLP1:
	ld	a,(TMP+1)
	rrca
	rr	d
	rr	e
	rr	h
	rr	l
	djnz	ADDFLP1

	jr	nc,ADDFNC
	inc	hl
	ld	a,h
	or	l
	jr	nz,ADDFNC
	inc	de
	ld	a,d
	or	e
	jr	nz,ADDFNC
	ld	d,80h
	ld	a,(FAC2+4)
	inc	a
	ld	(FAC2+4),a

ADDFNC:
	ld	(FAC2),hl
	ld	(FAC2+2),de
SAME:
	ld	hl,(FAC1)
	ld	de,(FAC2)
	add	hl,de
	ld	(FAC1),hl
	ld	hl,(FAC1+2)
	ld	de,(FAC2+2)
	adc	hl,de
	ld	(FAC1+2),hl
	ld	a,(TMP)
	ld	b,a
	ld	a,(TMP+1)
	adc	a,b
	bit	1,a
	jr	z,ANSPOS	;answer=positive
	push	af
	call	NEGINT4

	jr	nc,NEGZERO
	pop	af
	xor	01h
	jr	ANSPOS
NEGZERO:
	pop	af

ANSPOS:
	rrca
	jr	nc,SEARCH1
;1bin up
	ld	hl,(FAC1)
	ld	de,(FAC1+2)
	rr	d		;c-flag=1
	rr	e
	rr	h
	rr	l
	ld	(FAC1),hl
	ld	(FAC1+2),de
	ld	hl,FAC1+4
	inc	(hl)
	jp	z,OVERR
SEARCH1:
	push	af		;
	ld	hl,(FAC1)
	ld	de,(FAC1+2)
	ld	a,h
	or	l
	or	d
	or	e
	jr	z,ADDFZERO
	ld	b,h
	ld	c,l
	ld	hl,FAC1+4
ADDFLP2:
	bit	7,d
	jr	nz,SETADDSGN
	sla	c
	rl	b
	rl	e
	rl	d
	ld	(FAC1),bc
	ld	(FAC1+2),de
	dec	(hl)
	jp	z,OVERR
	jr	ADDFLP2
SETADDSGN:
	pop	af		;
	ld	hl,FAC1+3
	rl	(hl)
	rrca
	rr	(hl)
	ret

ADDFZERO:
	ld	(FAC1+4),a	;answer=0
	pop	af		;
	ret


;FAC1 = FAC1 * FAC2
;input: FAC1,FAC2
;output: FAC1
;broken: FAC2,af,bc,de,hl
MULF:

;result=bc-de-de'-hl'

	ld	a,(FAC1+4)
	or	a
	jp	z,SETZERO
	ld	a,(FAC2+4)
	or	a
	jp	z,SETZERO

	ld	hl,FAC1+3
	ld	a,(hl)
	set	7,(hl)
	ld	hl,FAC2+3
	xor	(hl)
	push	af		;sign
	set	7,(hl)

	ld	bc,0
	ld	d,b
	ld	e,c

	exx
	push	hl
	push	de
	push	bc
	ld	de,0
	ld	h,d
	ld	l,e

	ld	b,32
MULFLP:
	exx
	ld	a,(FAC1)
	rrca
	jr	nc,MULFNC

	ld	hl,(FAC2)
	add	hl,de
	ex	de,hl
	ld	hl,(FAC2+2)
	adc	hl,bc
	ld	b,h
	ld	c,l

MULFNC:
;rotate result
	rr	b
	rr	c
	rr	d
	rr	e
	exx
	rr	d
	rr	e
	rr	h
	rr	l

;FAC1 = FAC1 >> 1
	exx
	ld	hl,FAC1+3
	srl	(hl)
	dec	hl
	rr	(hl)
	dec	hl
	rr	(hl)
	dec	hl
	rr	(hl)
	exx

	djnz	MULFLP

	exx
	ld	hl,FAC1+4
	bit	7,b
	jr	nz,MULFNZ
;result = result << 1
	exx
	add	hl,hl
	rl	e
	rl	d
	exx
	rl	e
	rl	d
	rl	c
	rl	b
	dec	(hl)

MULFNZ:
	exx
	ld	a,d
	pop	bc
	pop	de
	pop	hl
	exx
	rlca
	jr	nc,MULFEND
	inc	de
	ld	a,d
	or	e
	jr	nz,MULFEND
	inc	bc
	ld	a,b
	or	c
	jr	nz,MULFEND
	ld	b,80h
	inc	(hl)
	jp	z,OVERR

MULFEND:
	ld	(FAC1),de
	ld	(FAC1+2),bc

;exponent
	ld	a,(FAC2+4)
	add	a,(hl)
	jr	c,MULFC
	sub	80h		;not 81h
	jp	c,OVERR
	jr	MULEXP
MULFC:
	sub	80h		;not 81h
	jp	nc,OVERR
MULEXP:
	ld	(hl),a		;exponent

MULSGN:
	ld	a,(FAC1+4)
	or	a
	jr	z,MULFZERO
	ld	hl,FAC1+3
	pop	af		;sign
	xor	(hl)
	and	80h
	xor	(hl)
	ld	(hl),a
	ret

MULFZERO:
	pop	af
	jp	SETZERO


;FAC1 = FAC1 / FAC2
;input: FAC1,FAC2
;output: FAC1
;broken: FAC2,af,bc,de,hl
DIVF:
	ld	a,(FAC2+4)
	or	a
	jp	z,DIV0ERR
	ld	b,a
	ld	a,(FAC1+4)
	or	a
	jp	z,SETZERO
	sub	b
	jr	c,DIVF1LT2
;FAC1>=FAC2
	cp	7fh
	jp	nc,OVERR
	jr	DIVFOK
;FAC1<FAC2
DIVF1LT2:
	jp	p,SETZERO
DIVFOK:
	add	a,81h
	ld	(FAC1+4),a

	ld	hl,FAC1+3
	ld	a,(hl)
	set	7,(hl)
	ld	hl,FAC2+3
	xor	(hl)
	push	af		;;sign
	set	7,(hl)

	exx			;
	push	hl
	push	de
	ld	hl,0
	ld	d,h
	ld	e,l
	exx			;

	call	CMPINT4
	jr	nc,DIVFNC
	ld	hl,FAC1+4
	dec	(hl)
	call	SLAF1

DIVFNC:
	ld	b,32
DIVFLP:
	jr	c,DIVFC1
	call	CMPINT4
	jr	c,DIVFC2
DIVFC1:
	ld	hl,(FAC1)
	ld	de,(FAC2)
	or	a
	sbc	hl,de
	ld	(FAC1),hl
	ld	hl,(FAC1+2)
	ld	de,(FAC2+2)
	sbc	hl,de
	ld	(FAC1+2),hl
	or	a		;reset c-flag
DIVFC2:
	ccf
	exx			;
	adc	hl,hl
	rl	e
	rl	d
	exx			;

	call	SLAF1
	djnz	DIVFLP

	exx			;
	jr	c,DIVFC3
	exx			;
	call	CMPINT4
	exx			;
	jr	c,DIVFC4
DIVFC3:
	inc	hl
	ld	a,h
	or	l
	jr	nz,DIVFC4
	inc	de
	ld	a,d
	or	e
	jr	nz,DIVFC4
	ld	a,(FAC1+4)
	inc	a
	jp	z,OVERR
	ld	(FAC1+4),a
	ld	d,80h
DIVFC4:
	ld	(FAC1),hl
	ld	(FAC1+2),de
	pop	de
	pop	hl
	exx			;

	jp	MULSGN


;shift left arithmetic for FAC1
;input:	FAC1
;output:FAC1,c
;broken:hl,f
SLAF1:
	ld	hl,FAC1
	sla	(hl)
	inc	hl
	rl	(hl)
	inc	hl
	rl	(hl)
	inc	hl
	rl	(hl)
	ret


;de=hl/a, a>0
;input:	a,hl
;output:de
;broken:af,bc
DIVI:
	ld	de,0
	ld	b,8
DIVILP1
	inc	b
	add	a,a
	jr	nc,DIVILP1
	rra
	ld	c,a
DIVILP2:
	ld	a,h
	jr	nc,DIVINC1
	sub	c
	or	a		;reset c-flag
	jr	DIVINC2
DIVINC1:
	sub	c
	jr	nc,DIVINC2
	add	a,c
DIVINC2:
	ld	h,a
	ccf
	rl	e
	rl	d
	add	hl,hl
	djnz	DIVILP2
	ret


;hl=hl/12
;input: hl<256
;output: hl=int(hl/12), a=hl mod 12
;broken: f,b=0,e
DIV12:
	ld	a,l
	ld	b,4
	ld	l,h		;h=0
	ld	e,01100000b
DIV12LP:
	sub	e
	jr	nc,DIV12NC
	add	a,e
DIV12NC:
	ccf
	rl	l
	srl	e
	djnz	DIV12LP
	ret


;push FAC1
;input: FAC1
;output: sp=sp-6
;broken: af,hl
PUSHF1:
	pop	af		;return address
	ld	hl,(FAC1+3)
	push	hl
	ld	hl,(FAC1+1)
	push	hl
	ld	hl,(FAC1-1)
	push	hl
	push	af		;
	ret


;push FAC2
;input: FAC2
;output: sp=sp-6
;broken: af,hl
PUSHF2:
	pop	af		;return address
	ld	hl,(FAC2+3)
	push	hl
	ld	hl,(FAC2+1)
	push	hl
	ld	hl,(FAC2-1)
	push	hl
	push	af		;
	ret


;pop FAC1
;input: none
;output: FAC1,sp=sp+6
;broken: af,hl
POPF1:
	pop	af		;return address
	pop	hl
	ld	(FAC1-1),hl
	pop	hl
	ld	(FAC1+1),hl
	pop	hl
	ld	(FAC1+3),hl
	push	af		;
	ret


;pop FAC2
;input: none
;output: FAC2,sp=sp+6
;broken: af,hl
POPF2:
	pop	af		;return address
	pop	hl
	ld	(FAC2-1),hl
	pop	hl
	ld	(FAC2+1),hl
	pop	hl
	ld	(FAC2+3),hl
	push	af		;
	ret


;copy FAC1 to FAC2
;input: FAC1
;output: FAC2
;broken: hl
CPYFAC:
	push	af
	call	PUSHF1
	call	POPF2
	pop	af
	ret


;exchange FAC1 and FAC2
;input: FAC1,FAC2
;output: FAC1,FAC2
;broken: hl
EXFAC:
	push	af
	call	PUSHF2
	call	CPYFAC
	call	POPF1
	pop	af
	ret


;add 4-byte integer and 4byte integer
;input: FAC1(integer),FAC2(integer)
;output: FAC1(integer),f
;broken: de,hl
ADDINT4:
	ld	hl,(FAC1)
	ld	de,(FAC2)
	add	hl,de
	ld	(FAC1),hl
	ld	hl,(FAC1+2)
	ld	de,(FAC2+2)
	adc	hl,de
	ld	(FAC1+2),hl
	ret


;subtract 4-byte integer from 4byte integer
;input: FAC1(integer),FAC2(integer)
;output: FAC1(integer),f
;broken: de,hl
SUBINT4:
	ld	hl,(FAC1)
	ld	de,(FAC2)
	or	a
	sbc	hl,de
	ld	(FAC1),hl
	ld	hl,(FAC1+2)
	ld	de,(FAC2+2)
	sbc	hl,de
	ld	(FAC1+2),hl
	ret


;negate 4-byte integer
;input: FAC1(integer)
;output: FAC1(integer)
;broken: af,hl
NEGINT4:
	ld	hl,FAC1
	xor	a
	sub	(hl)
	ld	(hl),a
	inc	hl
	ld	a,0
	sbc	a,(hl)
	ld	(hl),a
	inc	hl
	ld	a,0
	sbc	a,(hl)
	ld	(hl),a
	inc	hl
	ld	a,0
	sbc	a,(hl)
	ld	(hl),a
	ret


;a=FAC1(int4)/(hl)(int4)<=9,FAC1%=(hl),hl+=4
;input: FAC1(integer), hl=division factor (4byte int) address
;output: a=FAC1/(hl4), FAC1=FAC1%(hl4), hl=hl+4, a=[0,9]
;broken: FAC2,bc,de
DIVINT4:
	call	SETF2
	dec	hl
	push	hl
	xor	a
DIVINT4LP:
	inc	a
	call	SUBINT4
	jr	nc,DIVINT4LP
	dec	a
	call	ADDINT4
	pop	hl
	ret


;compare 4-byte integer to 4-byte integer
;input: FAC1(integer),FAC2(integer)
;output: f
;broken: a,de,hl
CMPINT4:
	ld	hl,(FAC1+2)
	ld	de,(FAC2+2)
	or	a
	sbc	hl,de
	ret	c
	ret	nz
	ld	hl,(FAC1)
	ld	de,(FAC2)
	sbc	hl,de
	ret


;decrement FAC1 (integer)
;input: FAC1
;output: FAC1
;broken: af,hl
DECINT4:
	ld	hl,(FAC1)
	ld	a,h
	or	l		;
	dec	hl
	ld	(FAC1),hl
	ret	nz		;
	ld	hl,(FAC1+2)
	dec	hl
	ld	(FAC1+2),hl
	ret


;dehl=hl*de
;input: hl,de
;output: dehl
;broken: af,bc
MULINT2:
	ld	a,h
	ld	c,l
	ld	hl,0
	ld	b,16
MULI2LP:
	rra
	rr	c
	jr	nc,MULI2NC
	add	hl,de
MULI2NC:
	srl	h
	rr	l
	djnz	MULI2LP
	rra
	rr	c
	ld	e,c
	ld	d,a
	ex	de,hl
	ret


;RSEED = (FAC1 (integer) * FAC2 (integer)) & ff,ff,ff,ff,ffh for rnd()
;input: FAC1,FAC2 (not zero)
;output: RSEED
;broken: FAC1
MULRND:
	xor	a
	ld	h,a
	ld	l,a
	ld	(RSEED),hl
	ld	(RSEED+2),hl
	ld	(RSEED+4),a
	ld	(FAC1+4),a

	exx			;
	push	hl
	push	de
	push	bc
	exx			;

	ld	hl,(FAC2)
	ld	de,(FAC2+2)

	ld	b,32
MULRLP:
	srl	d
	rr	e
	rr	h
	rr	l
	exx			;
	jr	nc,RNDNC
	ld	hl,(RSEED)
	ld	de,(FAC1)
	add	hl,de
	ld	(RSEED),hl
	ld	hl,(RSEED+2)
	ld	de,(FAC1+2)
	adc	hl,de
	ld	(RSEED+2),hl
	ld	a,(RSEED+4)
	ld	c,a
	ld	a,(FAC1+4)
	adc	a,c
	ld	(RSEED+4),a
RNDNC:
	call	SLAF1
	ld	a,(FAC1+4)
	rla
	ld	(FAC1+4),a
	exx			;
	djnz	MULRLP

	exx			;
	pop	bc
	pop	de
	pop	hl
	exx			;
	ret


_4000H:	ds	4000h-_4000H

	end
